/* 
 * JGrepper is "GREP search software".
 * 
 * Copyright (C) 2010  Isao Togo
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/******************************************************************************
 * TITLE           : JGrepper
 * VERSION         : 1.8.0
 * LANGUAGE        : Java6
 * ORIGINAL AUTHOR : 2010.02.28  I.TOGO  (Ver 1.0.0) (JDK 1.6.0 Update18)
 * UPDATED         : 2010.03.04  I.TOGO  (Ver 1.1.0)
 * UPDATED         : 2010.03.09  I.TOGO  (Ver 1.2.0)
 * UPDATED         : 2010.03.17  I.TOGO  (Ver 1.3.0)
 * UPDATED         : 2010.04.06  I.TOGO  (Ver 1.4.0) (JDK 1.6.0 Update19)
 * UPDATED         : 2010.08.08  I.TOGO  (Ver 1.5.0) (JDK 1.6.0 Update21)
 * UPDATED         : 2010.08.30  I.TOGO  (Ver 1.6.0)
 * UPDATED         : 2010.09.17  I.TOGO  (Ver 1.6.1)
 * UPDATED         : 2011.01.18  I.TOGO  (Ver 1.7.0) (JDK 1.6.0 Update23)
 * UPDATED         : 2011.03.04  I.TOGO  (Ver 1.8.0) (JDK 1.6.0 Update24)
 * UPDATED         : ****.**.**
 ******************************************************************************/
import java.util.*;
import java.util.regex.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;

import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.xssf.usermodel.*;
import org.apache.poi.hwpf.*;
import org.apache.poi.hwpf.usermodel.*;
import org.apache.poi.hslf.*;
import org.apache.poi.hslf.model.*;
import org.apache.poi.hslf.usermodel.*;
import org.mozilla.universalchardet.UniversalDetector;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.util.PDFTextStripper;
import org.apache.tools.zip.*;


/******************************************************************************
 *C
 ******************************************************************************/
class JGrepper extends JFrame implements ActionListener, HyperlinkListener, WindowListener, TreeSelectionListener, TreeWillExpandListener {

	private String		TITLE = "JGrepper Ver 1.8.0";

	//vpeBt@C̎擾e
	private GetProperties		properties;	
	// ʃvpeB
	private CommonProperties	commonProperties;

	private JLabel				statusBar;
	private JLabel				statusBar2;
	private JTree				treeArea;
	private JSplitPane			splitArea;

	private ProgressMonitor		progressMonitor;
	private long				progressCnt;
	private long				progressMax;
	private int					threadEndFlg;	// (0:s, 1:I)

	private DefaultTreeModel 	treeModel;
	private DefaultMutableTreeNode root;

	// ͈͂̐ݒ
	private JLabel				jlblFile;
	private JComboBox			jcboFile;
	private JButton				jbtnFileRef;
	private JButton				jbtnFileClr;
	private JLabel				jlblFolder;
	private JComboBox			jcboFolder;
	private JButton				jbtnFolderClr;
	private JCheckBox			jchkSubFolder;
	private JCheckBox			jchkArchive;
	private JLabel				jlblEnc;
	private JComboBox			jcboEnc;

	// ̐ݒ
	private JLabel				jlblRegEx;
	private JComboBox			jcboRegEx;
	private JButton				jbtnRegEx;
	private JComboBox			jcboRegExB;
	private JButton				jbtnRegExB;
	private JComboBox			jcboRegExC;
	private JButton				jbtnRegExC;
	private JRadioButton		jrdoAnd;
	private JRadioButton		jrdoOr;

	private JLabel				jlblSearchOpt;
	private JCheckBox			jchkSearchOpt1;
	private JCheckBox			jchkSearchOpt2;
	private JButton				jbtnSearchStart;

	// 
	//private JTextArea			jtxtResult;
	private JEditorPane			jtxtResult;

	// ^XNgC̃ACR
	private TrayIcon			trayIcon = null;


	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	JGrepper(String[] argsPath) {

		String lookAndFeel = "";
		lookAndFeel = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";	//Windows
		try {
			UIManager.setLookAndFeel(lookAndFeel);
			SwingUtilities.updateComponentTreeUI(this);
		} catch (Exception ex) { 
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
		setTitle(TITLE);

		// tH_c[̍쐬
		root = makeRoot("", 1);

		// ݒ
		InitSet();

		// ro
		splitArea = new JSplitPane();


		InitMenuBar();		// j[o[쐬
		InitToolBar();		// c[o[쐬
		InitStatusBar();	// Xe[^Xo[쐬
		InitTreeArea();		// c[GA쐬
		InitPanelArea();	// plGA쐬


		getContentPane().add(splitArea, BorderLayout.CENTER);


		// Cxg

		jbtnFileRef.setActionCommand("FileRefClick");
		jbtnFileRef.addActionListener(this);

		// t@CiNA{^j
		jbtnFileClr.setActionCommand("FileClrClick");
		jbtnFileClr.addActionListener(this);

		// tH_iNA{^j
		jbtnFolderClr.setActionCommand("FolderClrClick");
		jbtnFolderClr.addActionListener(this);

		// K\̓{^P
		jbtnRegEx.setActionCommand("RegExClick");
		jbtnRegEx.addActionListener(this);

		// K\̓{^Q
		jbtnRegExB.setActionCommand("RegExBClick");
		jbtnRegExB.addActionListener(this);

		// K\̓{^R
		jbtnRegExC.setActionCommand("RegExCClick");
		jbtnRegExC.addActionListener(this);

		// ׂẴL[[h܂
		jrdoAnd.setActionCommand("RegExAndClick");
		jrdoAnd.addActionListener(this);

		// ꂩ̃L[[h܂
		jrdoOr.setActionCommand("RegExOrClick");
		jrdoOr.addActionListener(this);

		// TutH_IvV
		jchkSubFolder.setActionCommand("SubFolderClick");
		jchkSubFolder.addActionListener(this);

		// kt@C̒gIvV
		jchkArchive.setActionCommand("ArchiveClick");
		jchkArchive.addActionListener(this);

		// 啶ƏʂIvV
		jchkSearchOpt1.setActionCommand("SearchOpt1Click");
		jchkSearchOpt1.addActionListener(this);

		// sƍs̋󔒂𖳎IvV
		jchkSearchOpt2.setActionCommand("SearchOpt2Click");
		jchkSearchOpt2.addActionListener(this);

		// Jn{^
		jbtnSearchStart.setActionCommand("SearchStartClick");
		jbtnSearchStart.addActionListener(this);

		// 
		jtxtResult.addHyperlinkListener(this);

		addWindowListener(this);

		// R}hCŁutH_vw肳Ăꍇ́Aʂɕ\
		if (argsPath != null) {
			if (argsPath.length > 0) {
				jcboFolder.setSelectedItem(argsPath[0]);
			}
		}

		// setDefaultCloseOperation(this.EXIT_ON_CLOSE);
		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);

	}


	////////////////////////////////////////////////////////////////////////////
	//ݒ
	////////////////////////////////////////////////////////////////////////////
	void InitSet() {

		try {
			String[] aryFileName = new String[20];
			String[] aryFolderPath = new String[20];
			String[] aryRegEx = new String[20];
			String[] aryRegExB = new String[20];
			String[] aryRegExC = new String[20];
			
			
			File file = new File("jgrepper.properties");
			if (!(file.exists())) {
				// vpeBt@C݂ȂƂ́AVKɋt@C쐬B
				file.createNewFile();
			}
			// vpeBt@C̓ǂݍ
			properties = new GetProperties();
			
			
			// ʃvpeB
			commonProperties = new CommonProperties();
			commonProperties.clear();
			// tHg
			commonProperties.setFontName(properties.getFontName());
			// tHgTCY
			commonProperties.setFontSize(properties.getFontSize());
			// t@C
			aryFileName[0] = properties.getFileName1();
			aryFileName[1] = properties.getFileName2();
			aryFileName[2] = properties.getFileName3();
			aryFileName[3] = properties.getFileName4();
			aryFileName[4] = properties.getFileName5();
			aryFileName[5] = properties.getFileName6();
			aryFileName[6] = properties.getFileName7();
			aryFileName[7] = properties.getFileName8();
			aryFileName[8] = properties.getFileName9();
			aryFileName[9] = properties.getFileName10();
			aryFileName[10] = properties.getFileName11();
			aryFileName[11] = properties.getFileName12();
			aryFileName[12] = properties.getFileName13();
			aryFileName[13] = properties.getFileName14();
			aryFileName[14] = properties.getFileName15();
			aryFileName[15] = properties.getFileName16();
			aryFileName[16] = properties.getFileName17();
			aryFileName[17] = properties.getFileName18();
			aryFileName[18] = properties.getFileName19();
			aryFileName[19] = properties.getFileName20();
			commonProperties.setFileName(aryFileName);
			// tH_
			aryFolderPath[0] = properties.getFolderPath1();
			aryFolderPath[1] = properties.getFolderPath2();
			aryFolderPath[2] = properties.getFolderPath3();
			aryFolderPath[3] = properties.getFolderPath4();
			aryFolderPath[4] = properties.getFolderPath5();
			aryFolderPath[5] = properties.getFolderPath6();
			aryFolderPath[6] = properties.getFolderPath7();
			aryFolderPath[7] = properties.getFolderPath8();
			aryFolderPath[8] = properties.getFolderPath9();
			aryFolderPath[9] = properties.getFolderPath10();
			aryFolderPath[10] = properties.getFolderPath11();
			aryFolderPath[11] = properties.getFolderPath12();
			aryFolderPath[12] = properties.getFolderPath13();
			aryFolderPath[13] = properties.getFolderPath14();
			aryFolderPath[14] = properties.getFolderPath15();
			aryFolderPath[15] = properties.getFolderPath16();
			aryFolderPath[16] = properties.getFolderPath17();
			aryFolderPath[17] = properties.getFolderPath18();
			aryFolderPath[18] = properties.getFolderPath19();
			aryFolderPath[19] = properties.getFolderPath20();
			commonProperties.setFolderPath(aryFolderPath);
			// 镶PiK\j
			aryRegEx[0] = properties.getRegEx1();
			aryRegEx[1] = properties.getRegEx2();
			aryRegEx[2] = properties.getRegEx3();
			aryRegEx[3] = properties.getRegEx4();
			aryRegEx[4] = properties.getRegEx5();
			aryRegEx[5] = properties.getRegEx6();
			aryRegEx[6] = properties.getRegEx7();
			aryRegEx[7] = properties.getRegEx8();
			aryRegEx[8] = properties.getRegEx9();
			aryRegEx[9] = properties.getRegEx10();
			aryRegEx[10] = properties.getRegEx11();
			aryRegEx[11] = properties.getRegEx12();
			aryRegEx[12] = properties.getRegEx13();
			aryRegEx[13] = properties.getRegEx14();
			aryRegEx[14] = properties.getRegEx15();
			aryRegEx[15] = properties.getRegEx16();
			aryRegEx[16] = properties.getRegEx17();
			aryRegEx[17] = properties.getRegEx18();
			aryRegEx[18] = properties.getRegEx19();
			aryRegEx[19] = properties.getRegEx20();
			commonProperties.setRegEx(aryRegEx);
			// 镶QiK\j
			aryRegExB[0] = properties.getRegExB1();
			aryRegExB[1] = properties.getRegExB2();
			aryRegExB[2] = properties.getRegExB3();
			aryRegExB[3] = properties.getRegExB4();
			aryRegExB[4] = properties.getRegExB5();
			aryRegExB[5] = properties.getRegExB6();
			aryRegExB[6] = properties.getRegExB7();
			aryRegExB[7] = properties.getRegExB8();
			aryRegExB[8] = properties.getRegExB9();
			aryRegExB[9] = properties.getRegExB10();
			aryRegExB[10] = properties.getRegExB11();
			aryRegExB[11] = properties.getRegExB12();
			aryRegExB[12] = properties.getRegExB13();
			aryRegExB[13] = properties.getRegExB14();
			aryRegExB[14] = properties.getRegExB15();
			aryRegExB[15] = properties.getRegExB16();
			aryRegExB[16] = properties.getRegExB17();
			aryRegExB[17] = properties.getRegExB18();
			aryRegExB[18] = properties.getRegExB19();
			aryRegExB[19] = properties.getRegExB20();
			commonProperties.setRegExB(aryRegExB);
			// 镶RiK\j
			aryRegExC[0] = properties.getRegExC1();
			aryRegExC[1] = properties.getRegExC2();
			aryRegExC[2] = properties.getRegExC3();
			aryRegExC[3] = properties.getRegExC4();
			aryRegExC[4] = properties.getRegExC5();
			aryRegExC[5] = properties.getRegExC6();
			aryRegExC[6] = properties.getRegExC7();
			aryRegExC[7] = properties.getRegExC8();
			aryRegExC[8] = properties.getRegExC9();
			aryRegExC[9] = properties.getRegExC10();
			aryRegExC[10] = properties.getRegExC11();
			aryRegExC[11] = properties.getRegExC12();
			aryRegExC[12] = properties.getRegExC13();
			aryRegExC[13] = properties.getRegExC14();
			aryRegExC[14] = properties.getRegExC15();
			aryRegExC[15] = properties.getRegExC16();
			aryRegExC[16] = properties.getRegExC17();
			aryRegExC[17] = properties.getRegExC18();
			aryRegExC[18] = properties.getRegExC19();
			aryRegExC[19] = properties.getRegExC20();
			commonProperties.setRegExC(aryRegExC);
			// 镶`^niK\j
			commonProperties.setRegExAndOr(properties.getRegExAndOr());
			// TutH_
			commonProperties.setSubFolder(properties.getSubFolder());
			// kt@C̒g
			commonProperties.setArchive(properties.getArchive());
			// GR[h̎
			commonProperties.setEncode(properties.getEncode());
			// 啶Əʂ
			commonProperties.setCaseInsensitive(properties.getCaseInsensitive());
			// sƍs̋󔒂𖳎
			commonProperties.setTrim(properties.getTrim());
			// \`
			commonProperties.setTextFormat(properties.getTextFormat());
		
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
			// vOI
			System.exit(0);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//j[o[쐬
	////////////////////////////////////////////////////////////////////////////
	void InitMenuBar() {

		// j[o[
		JMenuBar menuBar = new JMenuBar();
		getRootPane().setJMenuBar(menuBar);

		// [t@C]
		JMenu menuFile = new JMenu("t@C(F)");
		menuFile.setMnemonic('F');
		menuBar.add(menuFile);

		// [t@C]-[^XNgCɊi[]
		JMenuItem menuTray = new JMenuItem("^XNgCɊi[");
		menuTray.setActionCommand("Tray");
		menuTray.addActionListener(this);
		menuFile.add(menuTray);

		// [t@C]-Zp[^
		menuFile.addSeparator();

		// [t@C]-[I]
		JMenuItem menuExit = new JMenuItem("I(X)");
		menuExit.setMnemonic('X');
		menuExit.setActionCommand("Exit");
		menuExit.addActionListener(this);
		menuFile.add(menuExit);

		// [ҏW]
		JMenu menuEdit = new JMenu("ҏW(E)");
		menuEdit.setMnemonic('E');
		menuBar.add(menuEdit);

		// [ҏW]-[ʂNA]
		JMenuItem menuClear = new JMenuItem("ʂNA");
		menuClear.setActionCommand("Clear");
		menuClear.addActionListener(this);
		menuEdit.add(menuClear);

		// [ҏW]-[ʂSI]
		JMenuItem menuAllSel = new JMenuItem("ʂSI");
		menuAllSel.setActionCommand("AllSel");
		menuAllSel.addActionListener(this);
		menuEdit.add(menuAllSel);

		// [ҏW]-[Nbv{[hɃRs[]
		JMenuItem menuCopy = new JMenuItem("I͈͂Nbv{[hɃRs[");
		menuCopy.setActionCommand("Copy");
		menuCopy.addActionListener(this);
		menuEdit.add(menuCopy);

		// []
		JMenu menuSearch = new JMenu("(S)");
		menuSearch.setMnemonic('S');
		menuBar.add(menuSearch);

		// []-[ʂSI]
		JMenuItem menuGrep = new JMenuItem("Jn");
		menuGrep.setActionCommand("Grep");
		menuGrep.addActionListener(this);
		menuSearch.add(menuGrep);

		// []-[ʂ̏o͌`]
		JMenu menuTextFormat = new JMenu("ʂ̏o͌`iplain textj");
		// []-[ʂ̏o͌`]-[`]
		JRadioButtonMenuItem menuFmtHtml = new JRadioButtonMenuItem("HTML`");
		menuFmtHtml.setActionCommand("Html");
		menuFmtHtml.addActionListener(this);
		JRadioButtonMenuItem menuFmtHidemaru = new JRadioButtonMenuItem("GۃGfB^`iplain textj");
		menuFmtHidemaru.setActionCommand("Hidemaru");
		menuFmtHidemaru.addActionListener(this);
		JRadioButtonMenuItem menuFmtSakura = new JRadioButtonMenuItem("TNGfB^`iplain textj");
		menuFmtSakura.setActionCommand("Sakura");
		menuFmtSakura.addActionListener(this);
		//WI{^̓O[vĔrIɂ
		ButtonGroup bg = new ButtonGroup();
		bg.add(menuFmtHtml);
		bg.add(menuFmtHidemaru);
		bg.add(menuFmtSakura);
		if (commonProperties.getTextFormat().equals("0")) {
			// HTML`
			menuFmtHtml.setSelected(true);
		} else if (commonProperties.getTextFormat().equals("1")) {
			// GۃGfB^`
			menuFmtHidemaru.setSelected(true);
		} else if (commonProperties.getTextFormat().equals("2")) {
			// TNGfB^`
			menuFmtSakura.setSelected(true);
		} else {
			// ̑iHTML`j
			menuFmtHtml.setSelected(true);
			commonProperties.setTextFormat("0");
		}
		//
		menuTextFormat.add(menuFmtHtml);
		menuTextFormat.add(menuFmtHidemaru);
		menuTextFormat.add(menuFmtSakura);
		menuSearch.add(menuTextFormat);

		// [wv]
		JMenu menuHelp = new JMenu("wv(H)");
		menuHelp.setMnemonic('H');
		menuBar.add(menuHelp);

		// [wv]-[JGrepperɂ]
		JMenuItem menuAbout = new JMenuItem("JGrepperɂ(A)...");
		menuAbout.setMnemonic('A');
		menuAbout.setActionCommand("About");
		menuAbout.addActionListener(this);
		menuHelp.add(menuAbout);

		// [t@C]-Zp[^
		menuHelp.addSeparator();

		// [wv]-[GNU General Public License version 3 (GPLv3)]
		JMenuItem menuAboutGPL = new JMenuItem("GNU General Public License version 3 (GPLv3)");
		menuAboutGPL.setActionCommand("AboutGPL");
		menuAboutGPL.addActionListener(this);
		menuHelp.add(menuAboutGPL);

		// [wv]-[Apache License Version 2.0]
		JMenuItem menuAboutASF = new JMenuItem("Apache License Version 2.0");
		menuAboutASF.setActionCommand("AboutASF");
		menuAboutASF.addActionListener(this);
		menuHelp.add(menuAboutASF);

		// [wv]-[The Legion of the Bouncy Castle (MIT License)]
		JMenuItem menuAboutBouncyCastle = new JMenuItem("The Legion of the Bouncy Castle (MIT License)");
		menuAboutBouncyCastle.setActionCommand("AboutBouncyCastle");
		menuAboutBouncyCastle.addActionListener(this);
		menuHelp.add(menuAboutBouncyCastle);

		// [wv]-[NOTICE]
		JMenuItem menuAboutNOTICE = new JMenuItem("NOTICE");
		menuAboutNOTICE.setActionCommand("AboutNOTICE");
		menuAboutNOTICE.addActionListener(this);
		menuHelp.add(menuAboutNOTICE);
	}

	////////////////////////////////////////////////////////////////////////////
	//c[o[쐬
	////////////////////////////////////////////////////////////////////////////
	void InitToolBar() {
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);

		JButton btnSearch = new JButton(new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/page_find.gif")));
		JButton btnReload = new JButton(new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/action_refresh.gif")));
		JButton btnAbout = new JButton(new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/icon_info.gif")));

		btnSearch.setToolTipText("Jn");
		btnReload.setToolTipText("tH_c[ŐVԂɍXV");
		btnAbout.setToolTipText("JGrepperɂ");

		btnSearch.setActionCommand("Search");
		btnReload.setActionCommand("Reload");
		btnAbout.setActionCommand("About");

		btnSearch.addActionListener(this);
		btnReload.addActionListener(this);
		btnAbout.addActionListener(this);

		toolBar.add(btnSearch);
		toolBar.add(btnReload);
		//toolBar.addSeparator();
		toolBar.add(btnAbout);

		getContentPane().add(toolBar, BorderLayout.NORTH);
	}

	////////////////////////////////////////////////////////////////////////////
	//Xe[^Xo[쐬
	////////////////////////////////////////////////////////////////////////////
	void InitStatusBar() {

		String strFontName = "lr SVbN";

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		p.setPreferredSize(new Dimension(600, 20));

		statusBar = new JLabel("@");
		statusBar.setFont(new Font(strFontName, Font.PLAIN, 12));
		statusBar.setBorder(new BevelBorder(BevelBorder.LOWERED));

		statusBar2 = new JLabel("@");
		statusBar2.setFont(new Font(strFontName, Font.PLAIN, 12));
		statusBar2.setBorder(new BevelBorder(BevelBorder.LOWERED));


		if (commonProperties.getTextFormat().equals("0")) {
			statusBar.setText("[HTML`]");
		} else if (commonProperties.getTextFormat().equals("1")) {
			statusBar.setText("[GۃGfB^`iplain textj]");
		} else if (commonProperties.getTextFormat().equals("2")) {
			statusBar.setText("[TNGfB^`iplain textj]");
		} else {
			statusBar.setText("[HTML`]");
		}

		p.add(statusBar, BorderLayout.WEST);
		p.add(statusBar2, BorderLayout.CENTER);

		getContentPane().add(p, BorderLayout.SOUTH);
	}

	////////////////////////////////////////////////////////////////////////////
	//c[GA쐬
	////////////////////////////////////////////////////////////////////////////
	void InitTreeArea() {

		treeArea = new JTree(root);
		treeArea.addTreeSelectionListener(this);
		treeModel = (DefaultTreeModel)treeArea.getModel();

		MyTreeCellRenderer renderer = new MyTreeCellRenderer();
		treeArea.setCellRenderer(renderer);


		//TreeWillExpandListener tel = new MyExpandListener();
		//treeArea.addTreeWillExpandListener(tel);
		treeArea.addTreeWillExpandListener(this);


		JScrollPane scrollpane = new JScrollPane(treeArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpane.setPreferredSize(new Dimension(200, 640));
		splitArea.setLeftComponent(scrollpane);
	}

	////////////////////////////////////////////////////////////////////////////
	//plGA쐬
	////////////////////////////////////////////////////////////////////////////
	void InitPanelArea() {

		String strFontName = "lr SVbN";

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		p.setPreferredSize(new Dimension(600, 640));

		JPanel panelCond = new JPanel();
		panelCond.setLayout(new BorderLayout());
		panelCond.setPreferredSize(new Dimension(600, 270));
		panelCond.setBorder(new BevelBorder(BevelBorder.RAISED));


		// ͈͂̐ݒpl
		JPanel p1 = new JPanel();
		p1.setLayout(null);
		p1.setPreferredSize(new Dimension(600, 110));
		p1.setBorder(new BevelBorder(BevelBorder.RAISED));

		// t@Cixj
		jlblFile = new JLabel("t@C",JLabel.LEFT);
		jlblFile.setBounds(20,5,100,20);
		jlblFile.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jlblFile.setBorder(new LineBorder(Color.blue, 1, true));

		// t@Ci͗j
		String[] jcboFile_items = {""};
		jcboFile = new JComboBox(jcboFile_items);
		jcboFile.setEditable(true);
		jcboFile.setBounds(120,5,325,20);
		jcboFile.setFont(new Font(strFontName, Font.PLAIN, 12));
		// R{{bNX̗Zbg
		String[] aryFileName = commonProperties.getFileName();
		jcboFile.removeAllItems();
		if (aryFileName != null) {
			for (int i=0; i<aryFileName.length; i++) {
				if (aryFileName[i] != null) {
					if (!(aryFileName[i].trim().equals(""))) {
						jcboFile.addItem(aryFileName[i]);
					}
				}
			}
		}
		// Xg̍ŏ̍ڂIڂɂ
		if (jcboFile.getItemCount() > 0) {
			jcboFile.setSelectedIndex(0);
		}

		// t@CiQƃ{^j
		jbtnFileRef = new JButton("̨ݒ");
		jbtnFileRef.setBounds(445,5,60,20);
		jbtnFileRef.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnFileRef.setMargin(new Insets(0, 0, 0, 0));

		// t@CiNA{^j
		jbtnFileClr = new JButton("NA");
		jbtnFileClr.setBounds(505,5,70,20);
		jbtnFileClr.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnFileClr.setMargin(new Insets(0, 0, 0, 0));

		// tH_ixj
		jlblFolder = new JLabel("tH_",JLabel.LEFT);
		jlblFolder.setBounds(20,30,100,20);
		jlblFolder.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jlblFolder.setBorder(new LineBorder(Color.blue, 1, true));

		// tH_i͗j
		String[] jcboFolder_items = {""};
		jcboFolder = new JComboBox(jcboFolder_items);
		jcboFolder.setEditable(true);
		jcboFolder.setBounds(120,30,385,20);
		jcboFolder.setFont(new Font(strFontName, Font.PLAIN, 12));
		// R{{bNX̗Zbg
		String[] aryFolderPath = commonProperties.getFolderPath();
		jcboFolder.removeAllItems();
		if (aryFolderPath != null) {
			for (int i=0; i<aryFolderPath.length; i++) {
				if (aryFolderPath[i] != null) {
					if (!(aryFolderPath[i].trim().equals(""))) {
						jcboFolder.addItem(aryFolderPath[i]);
					}
				}
			}
		}
		// Xg̍ŏ̍ڂIڂɂ
		if (jcboFolder.getItemCount() > 0) {
			jcboFolder.setSelectedIndex(0);
		}

		// tH_iNA{^j
		jbtnFolderClr = new JButton("NA");
		jbtnFolderClr.setBounds(505,30,70,20);
		jbtnFolderClr.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnFolderClr.setMargin(new Insets(0, 0, 0, 0));

		// TutH_IvV
		jchkSubFolder = new JCheckBox("TutH_");
		jchkSubFolder.setBounds(120,55,160,20);
		jchkSubFolder.setFont(new Font(strFontName, Font.PLAIN, 12));
		// `FN{bNX̏ԂZbg
		if (commonProperties.getSubFolder()==null) {
			jchkSubFolder.setSelected(false);
		} else {
			if (commonProperties.getSubFolder().equals("1")) {
				jchkSubFolder.setSelected(true);
			} else {
				jchkSubFolder.setSelected(false);
			}
		}

		// kt@C̒gIvV
		jchkArchive = new JCheckBox("ZIP̒g(1iK̈k܂)");
		jchkArchive.setBounds(305,55,250,20);
		jchkArchive.setFont(new Font(strFontName, Font.PLAIN, 12));
		// `FN{bNX̏ԂZbg
		if (commonProperties.getArchive()==null) {
			jchkArchive.setSelected(false);
		} else {
			if (commonProperties.getArchive().equals("1")) {
				jchkArchive.setSelected(true);
			} else {
				jchkArchive.setSelected(false);
			}
		}

		// GR[h̎ށixj
		jlblEnc = new JLabel("ڰ÷Ă̴ݺ",JLabel.LEFT);
		jlblEnc.setBounds(15,80,110,20);
		jlblEnc.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jlblEnc.setBorder(new LineBorder(Color.blue, 1, true));

		// GR[h̎ށiI𗓁j
		String[] jcboEnc_items = {"",
								  "Shift-JIS(Windows{)",
								  "Shift-JIS({)",
								  "EUC({)",
								  "JIS({)",
								  "Unicode(UTF-16)",
								  "Unicode(UTF-16BigEndian)",
								  "Unicode(UTF-32)",
								  "Unicode(UTF-32BigEndian)",
								  "UTF-8"
								 };
		jcboEnc = new JComboBox(jcboEnc_items);

		jcboEnc.setEditable(false);
		jcboEnc.setBounds(120,80,385,20);
		jcboEnc.setFont(new Font(strFontName, Font.PLAIN, 12));
		// Xg̑IڂZbg
		jcboEnc.setSelectedItem(commonProperties.getEncode());

		p1.add(jlblFile);
		p1.add(jcboFile);
		p1.add(jbtnFileRef);
		p1.add(jbtnFileClr);
		p1.add(jlblFolder);
		p1.add(jcboFolder);
		p1.add(jbtnFolderClr);
		p1.add(jchkSubFolder);
		p1.add(jchkArchive);
		p1.add(jlblEnc);
		p1.add(jcboEnc);


		// ̐ݒpl
		JPanel p2 = new JPanel();
		p2.setLayout(null);
		p2.setPreferredSize(new Dimension(600, 160));
		p2.setBorder(new BevelBorder(BevelBorder.RAISED));

		// 镶ixj
		jlblRegEx = new JLabel("镶",JLabel.LEFT);
		jlblRegEx.setBounds(30,10,90,20);
		jlblRegEx.setFont(new Font(strFontName, Font.PLAIN, 12));

		// 镶Pi͗j
		String[] jcboRegEx_items = {""};
		jcboRegEx = new JComboBox(jcboRegEx_items);
		jcboRegEx.setEditable(true);
		jcboRegEx.setBounds(120,10,385,20);
		jcboRegEx.setFont(new Font(strFontName, Font.PLAIN, 12));
		// R{{bNX̗Zbg
		String[] aryRegEx = commonProperties.getRegEx();
		jcboRegEx.removeAllItems();
		if (aryRegEx != null) {
			for (int i=0; i<aryRegEx.length; i++) {
				if (aryRegEx[i] != null) {
					//if (!(aryRegEx[i].trim().equals(""))) {
						jcboRegEx.addItem(aryRegEx[i]);
					//}
				}
			}
		}
		// Xg̍ŏ̍ڂIڂɂ
		if (jcboRegEx.getItemCount() > 0) {
			jcboRegEx.setSelectedIndex(0);
		}
		// K\͂P{^
		jbtnRegEx = new JButton("K\");
		jbtnRegEx.setBounds(505,10,80,20);
		jbtnRegEx.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnRegEx.setMargin(new Insets(0, 0, 0, 0));

		// 镶Qi͗j
		String[] jcboRegExB_items = {""};
		jcboRegExB = new JComboBox(jcboRegExB_items);
		jcboRegExB.setEditable(true);
		jcboRegExB.setBounds(120,35,385,20);
		jcboRegExB.setFont(new Font(strFontName, Font.PLAIN, 12));
		// R{{bNX̗Zbg
		String[] aryRegExB = commonProperties.getRegExB();
		jcboRegExB.removeAllItems();
		if (aryRegExB != null) {
			for (int i=0; i<aryRegExB.length; i++) {
				if (aryRegExB[i] != null) {
					//if (!(aryRegExB[i].trim().equals(""))) {
						jcboRegExB.addItem(aryRegExB[i]);
					//}
				}
			}
		}
		// Xg̍ŏ̍ڂIڂɂ
		if (jcboRegExB.getItemCount() > 0) {
			jcboRegExB.setSelectedIndex(0);
		}
		// K\͂Q{^
		jbtnRegExB = new JButton("K\");
		jbtnRegExB.setBounds(505,35,80,20);
		jbtnRegExB.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnRegExB.setMargin(new Insets(0, 0, 0, 0));

		// 镶Ri͗j
		String[] jcboRegExC_items = {""};
		jcboRegExC = new JComboBox(jcboRegExC_items);
		jcboRegExC.setEditable(true);
		jcboRegExC.setBounds(120,60,385,20);
		jcboRegExC.setFont(new Font(strFontName, Font.PLAIN, 12));
		// R{{bNX̗Zbg
		String[] aryRegExC = commonProperties.getRegExC();
		jcboRegExC.removeAllItems();
		if (aryRegExC != null) {
			for (int i=0; i<aryRegExC.length; i++) {
				if (aryRegExC[i] != null) {
					//if (!(aryRegExC[i].trim().equals(""))) {
						jcboRegExC.addItem(aryRegExC[i]);
					//}
				}
			}
		}
		// Xg̍ŏ̍ڂIڂɂ
		if (jcboRegExC.getItemCount() > 0) {
			jcboRegExC.setSelectedIndex(0);
		}
		// K\͂R{^
		jbtnRegExC = new JButton("K\");
		jbtnRegExC.setBounds(505,60,80,20);
		jbtnRegExC.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnRegExC.setMargin(new Insets(0, 0, 0, 0));

		// ׂẴL[[h܂
		jrdoAnd = new JRadioButton("ׂẴL[[h܂",true);
		jrdoAnd.setBounds(120,85,180,20);
		jrdoAnd.setFont(new Font("lr SVbN",Font.PLAIN,12));
		// ꂩ̃L[[h܂
		jrdoOr = new JRadioButton("ꂩ̃L[[h܂",false);
		jrdoOr.setBounds(300,85,200,20);
		jrdoOr.setFont(new Font("lr SVbN",Font.PLAIN,12));
		// WI{^O[v
		ButtonGroup group1 = new ButtonGroup();
		group1.add(jrdoAnd);
		group1.add(jrdoOr);
		// WI{^̏ԂZbg
		if (commonProperties.getRegExAndOr()==null) {
			// ׂẴL[[h܂
			jrdoAnd.setSelected(true);
		} else {
			if (commonProperties.getRegExAndOr().equals("1")) {
				// ꂩ̃L[[h܂
				jrdoOr.setSelected(true);
			} else {
				// ׂẴL[[h܂
				jrdoAnd.setSelected(true);
			}
		}

		// IvVixj
		jlblSearchOpt = new JLabel("IvV",JLabel.LEFT);
		jlblSearchOpt.setBounds(30,125,100,20);
		jlblSearchOpt.setFont(new Font(strFontName, Font.PLAIN, 12));

		// 啶ƏʂIvV
		jchkSearchOpt1 = new JCheckBox("啶Əʂ");
		jchkSearchOpt1.setBounds(120,125,180,20);
		jchkSearchOpt1.setFont(new Font(strFontName, Font.PLAIN, 12));
		// `FN{bNX̏ԂZbg
		if (commonProperties.getCaseInsensitive()==null) {
			jchkSearchOpt1.setSelected(false);
		} else {
			if (commonProperties.getCaseInsensitive().equals("1")) {
				jchkSearchOpt1.setSelected(true);
			} else {
				jchkSearchOpt1.setSelected(false);
			}
		}

		// sƍs̋󔒂𖳎IvV
		jchkSearchOpt2 = new JCheckBox("sƍs̋󔒂𖳎");
		jchkSearchOpt2.setBounds(305,125,190,20);
		jchkSearchOpt2.setFont(new Font(strFontName, Font.PLAIN, 12));
		// `FN{bNX̏ԂZbg
		if (commonProperties.getTrim()==null) {
			jchkSearchOpt2.setSelected(false);
		} else {
			if (commonProperties.getTrim().equals("1")) {
				jchkSearchOpt2.setSelected(true);
			} else {
				jchkSearchOpt2.setSelected(false);
			}
		}

		// Jn{^
		jbtnSearchStart = new JButton("Jn");
		jbtnSearchStart.setBounds(505,105,80,40);
		jbtnSearchStart.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnSearchStart.setMargin(new Insets(0, 0, 0, 0));

		p2.add(jlblRegEx);
		p2.add(jcboRegEx);
		p2.add(jbtnRegEx);
		p2.add(jcboRegExB);
		p2.add(jbtnRegExB);
		p2.add(jcboRegExC);
		p2.add(jbtnRegExC);
		p2.add(jrdoAnd);
		p2.add(jrdoOr);
		p2.add(jlblSearchOpt);
		p2.add(jchkSearchOpt1);
		p2.add(jchkSearchOpt2);
		p2.add(jbtnSearchStart);


		// 
		//jtxtResult = new JTextArea();
		jtxtResult = new JEditorPane();
		jtxtResult.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtResult.setEditable(false);
		if (commonProperties.getTextFormat().equals("0")) {
			jtxtResult.setContentType("text/html");
		} else {
			jtxtResult.setContentType("text/plain");
		}
		JScrollPane scrollpaneResult = new JScrollPane(jtxtResult, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneResult.setPreferredSize(new Dimension(600, 370));



		// plGA
		panelCond.add(p1, BorderLayout.NORTH);
		panelCond.add(p2, BorderLayout.SOUTH);
		p.add(panelCond, BorderLayout.NORTH);
		p.add(scrollpaneResult, BorderLayout.CENTER);
		splitArea.setRightComponent(p);
	}

	////////////////////////////////////////////////////////////////////////////
	//^XNgCɊi[
	////////////////////////////////////////////////////////////////////////////
	void taskTrayMenu() {

		try {
			// ACRɃ}EXƂɕ\|bvAbv̐ݒ
			PopupMenu pmenu = new PopupMenu("JGrepper");
			// CʂN
			MenuItem trayMenuWOpen = new MenuItem("CʂN");
			trayMenuWOpen.setActionCommand("TrayWinOpen");
			trayMenuWOpen.addActionListener(this);
			pmenu.add(trayMenuWOpen);
			// I
			MenuItem trayMenuWClose = new MenuItem("I");
			trayMenuWClose.setActionCommand("TrayWinClose");
			trayMenuWClose.addActionListener(this);
			pmenu.add(trayMenuWClose);
			// ACR
			Image image = Toolkit.getDefaultToolkit().getImage(getClass().getClassLoader().getResource("Resources/Images/page_find.gif"));
			trayIcon = new TrayIcon(image, "JGrepper", pmenu);
			trayIcon.setActionCommand("TrayIconDblclk");
			trayIcon.addActionListener(this);
			//VXegCZbg
			SystemTray.getSystemTray().add(trayIcon);

		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {
		try {
			String cmd = ae.getActionCommand();
			if (cmd.equals("Tray")) {
				OnTray();
			} else if (cmd.equals("TrayWinOpen")) {
				if (trayIcon != null) {
					// VXegCACR폜
					SystemTray.getSystemTray().remove(trayIcon);
					trayIcon = null;
					// ʂ\
					setVisible(true);
				}
			} else if (cmd.equals("TrayWinClose")) {
				OnExit();
			} else if (cmd.equals("TrayIconDblclk")) {
				if (trayIcon != null) {
					// VXegCACR폜
					SystemTray.getSystemTray().remove(trayIcon);
					trayIcon = null;
					// ʂ\
					setVisible(true);
				}
				//trayIcon.displayMessage("JGrepper", "CʂN܂", TrayIcon.MessageType.INFO);
			} else if (cmd.equals("Exit")) {
				OnExit();
			} else if (cmd.equals("Clear")) {
				OnClear();
			} else if (cmd.equals("AllSel")) {
				OnAllSel();
			} else if (cmd.equals("Copy")) {
				OnCopy();
			} else if (cmd.equals("Grep")) {
				OnSearch();
			} else if (cmd.equals("Reload")) {
				OnReload();
			} else if (cmd.equals("Html")) {
				commonProperties.setTextFormat("0");
				statusBar.setText("[HTML`]");
			} else if (cmd.equals("Hidemaru")) {
				commonProperties.setTextFormat("1");
				statusBar.setText("[GۃGfB^`iplain textj]");
			} else if (cmd.equals("Sakura")) {
				commonProperties.setTextFormat("2");
				statusBar.setText("[TNGfB^`iplain textj]");
			} else if (cmd.equals("About")) {
				OnAbout();
			} else if (cmd.equals("AboutGPL")) {
				OnAboutGPL();
			} else if (cmd.equals("AboutASF")) {
				OnAboutASF();
			} else if (cmd.equals("AboutBouncyCastle")) {
				OnAboutBouncyCastle();
			} else if (cmd.equals("AboutNOTICE")) {
				OnAboutNOTICE();
			} else if (cmd.equals("FileRefClick")) {
				OnFileRefClick();
			} else if (cmd.equals("FileClrClick")) {
				OnFileClrClick();
			} else if (cmd.equals("FolderClrClick")) {
				OnFolderClrClick();
			} else if (cmd.equals("RegExClick")) {
				OnRegExClick();
			} else if (cmd.equals("RegExBClick")) {
				OnRegExBClick();
			} else if (cmd.equals("RegExCClick")) {
				OnRegExCClick();
			} else if (cmd.equals("RegExAndClick")) {
				if (jrdoAnd.isSelected()) {
					// ׂẴL[[h܂
					commonProperties.setRegExAndOr("0");
				} else {
					// ꂩ̃L[[h܂
					commonProperties.setRegExAndOr("1");
				}
			} else if (cmd.equals("RegExOrClick")) {
				if (jrdoOr.isSelected()) {
					// ꂩ̃L[[h܂
					commonProperties.setRegExAndOr("1");
				} else {
					// ׂẴL[[h܂
					commonProperties.setRegExAndOr("0");
				}
			} else if (cmd.equals("SubFolderClick")) {
				if (jchkSubFolder.isSelected()) {
					// TutH_
					commonProperties.setSubFolder("1");
				} else {
					// TutH_Ȃ
					commonProperties.setSubFolder("0");
				}
			} else if (cmd.equals("ArchiveClick")) {
				if (jchkArchive.isSelected()) {
					// kt@C̒g
					commonProperties.setArchive("1");
				} else {
					// kt@C̒gȂ
					commonProperties.setArchive("0");
				}
			} else if (cmd.equals("SearchOpt1Click")) {
				if (jchkSearchOpt1.isSelected()) {
					// p啶ʂ
					commonProperties.setCaseInsensitive("1");
				} else {
					// p啶ʂȂ
					commonProperties.setCaseInsensitive("0");
				}
			} else if (cmd.equals("SearchOpt2Click")) {
				if (jchkSearchOpt2.isSelected()) {
					// sƍs̋󔒂𖳎
					commonProperties.setTrim("1");
				} else {
					// sƍs̋󔒂𖳎Ȃ
					commonProperties.setTrim("0");
				}
			} else if (cmd.equals("SearchStartClick")) {
				OnSearch();
			} else if (cmd.equals("Search")) {
				OnSearch();
			} else {
				System.out.println(cmd);
			}
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
	}
	public void hyperlinkUpdate(HyperlinkEvent e) {

		URL url = null;

		try {
			// NbNꂽs
			if (e.getEventType() != HyperlinkEvent.EventType.ACTIVATED) {
				return;
			}
			url = e.getURL();
			
			// NbNt@C̊gqɊ֘AtꂽAvP[VN
			if (System.getProperty("os.name").toUpperCase().startsWith("WINDOWS")) {
				// OS  Windows ̏ꍇ
				
				// NbNt@C̊gq擾
				String strExt = null;
				if (url.toString().lastIndexOf('.') >= 0) {
					strExt = new String(url.toString().substring(url.toString().lastIndexOf('.')));
					// ASSOCR}hgāANbNt@C̃t@C^Cv擾
					Process procAssoc = Runtime.getRuntime().exec("cmd.exe /c assoc " + strExt);
					InputStream isAssoc = procAssoc.getInputStream();
					BufferedReader brAssoc = new BufferedReader(new InputStreamReader(isAssoc));
					String strFileType = null;
					if ((strFileType = brAssoc.readLine()) != null) {
						//System.out.println("[ASSOC] " + strFileType);
						if (strFileType.indexOf('=') >= 0) {
							String strFtype = null;
							strFtype = new String(strFileType.substring(strFileType.indexOf('=') + 1));
							if (strFtype != null) {
								if (strFtype.equals("")) {
									// ASSOCR}hŎw肳ꂽgq̊֘AtȂꍇ
									ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@C^Cv܂B");
								} else {
									// FTYPER}hgāAI[vR}h擾
									Process procFtype = Runtime.getRuntime().exec("cmd.exe /c ftype " + strFtype);
									InputStream isFtype = procFtype.getInputStream();
									BufferedReader brFtype = new BufferedReader(new InputStreamReader(isFtype));
									String strOpenCommand = null;
									if ((strOpenCommand = brFtype.readLine()) != null) {
										//System.out.println("[FTYPE] " + strOpenCommand);
										if (strOpenCommand.indexOf('=') >= 0) {
											String strOpenCmd = null;
											strOpenCmd = new String(strOpenCommand.substring(strOpenCommand.indexOf('=') + 1));
											if (strOpenCmd != null) {
												if (strOpenCmd.equals("")) {
													// FTYPER}hŎw肳ꂽt@C^Cṽt@CJ߂̃R}hȂꍇ
													ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@CJ߂" + System.getProperty("line.separator") + "R}h܂B");
												} else {
													// 擾I[vR}hɁu"%1"v΁Aȍ~
													int i1;
													i1 = strOpenCmd.indexOf("\"%1\"");
													if (i1 >= 0) {
														strOpenCmd = strOpenCmd.substring(0, i1);
													} else {
														// 擾I[vR}hɁu%1v΁Aȍ~
														i1 = strOpenCmd.indexOf("%1");
														if (i1 >= 0) {
															strOpenCmd = strOpenCmd.substring(0, i1);
														} else {
															// 擾I[vR}hɁu"%1"vu%1vȂꍇAŌɌꂽ󔒂܂łR}hƂ
															strOpenCmd = strOpenCmd.trim();
															i1 = strOpenCmd.lastIndexOf(" ");
															if (i1 > 0) {
																strOpenCmd = strOpenCmd.substring(0, i1);
															}
														}
													}
													// 擾I[vR}hɊϐgĂ邩ۂ̃`FbNs
													if (strOpenCmd.indexOf('%') >= 0) {
														// I[vR}hɊϐgpĂꍇ
														int i2 = strOpenCmd.indexOf('%');
														int i3 = strOpenCmd.indexOf('%', i2 + 1);
														if (i3 >= 0) {
															String strEnvVar = strOpenCmd.substring(i2 + 1, i3);
															String strEnvVal = System.getenv(strEnvVar);
															if (i2 == 0) {
																strOpenCmd = strEnvVal + strOpenCmd.substring(i3 + 1);
															} else {
																strOpenCmd = strOpenCmd.substring(0, i2) + strEnvVal + strOpenCmd.substring(i3 + 1);
															}
														}
													}
													// ŏI̕ҏWʂsR}hƂăZbg
													String strCmd = strOpenCmd.trim();
													//if (strOpenCmd.charAt(0) == '\"') {
													//	strCmd = new String(strOpenCmd.substring(0, (strOpenCmd.indexOf('\"', 1) + 1)));
													//} else {
													//	strCmd = new String(strOpenCmd.substring(0, (strOpenCmd.indexOf(' ', 1) + 1)));
													//}
													// R}hs
													String strFileName = url.toString().substring(7).replace('/','\\');
													// sR}h "rundll32.exe" ܂܂Ăꍇ́At@C̗[u"vň͂ł͂Ȃ(for Win2000)B
													// ɁAR}hƈ̃t@C̊Ԃ͋󔒂Qȏ゠ƋNȂ̂ŁAK1ɂȂ΂ȂȂ(for Win2000)B
													if (strCmd.indexOf("rundll32.exe") >= 0) {
														//System.out.println(strCmd + " " + strFileName.trim());
														Process procCmd = Runtime.getRuntime().exec(strCmd + " " + strFileName.trim());
													} else {
														//System.out.println(strCmd + " \"" + strFileName + "\"");
														Process procCmd = Runtime.getRuntime().exec(strCmd + " \"" + strFileName + "\"");
													}
												}
											} else {
												// FTYPER}hŎw肳ꂽt@C^Cṽt@CJ߂̃R}hȂꍇ
												ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@CJ߂" + System.getProperty("line.separator") + "R}h܂B");
											}
										} else {
											// FTYPER}hŎw肳ꂽt@C^Cṽt@CJ߂̃R}hȂꍇ
											ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@CJ߂" + System.getProperty("line.separator") + "R}h܂B");
										}
									} else {
										// FTYPER}hŎw肳ꂽt@C^Cṽt@CJ߂̃R}hȂꍇ
										ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@CJ߂" + System.getProperty("line.separator") + "R}h܂B");
									}
								}
							} else {
								// ASSOCR}hŎw肳ꂽgq̊֘AtȂꍇ
								ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@C^Cv܂B");
							}
						} else {
							// ASSOCR}hŎw肳ꂽgq̊֘AtȂꍇ
							ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@C^Cv܂B");
						}
					} else {
						// ASSOCR}hŎw肳ꂽgq̊֘AtȂꍇ
						ErrorDialog d = new ErrorDialog(new JFrame(), "̊gq(" + strExt + ")Ɋ֘Atꂽt@C^Cv܂B");
					}
				} else {
					// gqȂt@CNbNꂽꍇ
					ErrorDialog d = new ErrorDialog(new JFrame(), "̃t@Cɂ͊gqȂ߁Ãt@CɊ֘AtꂽR}h邱Ƃo܂B");
				}
			} else {
				// OS  Windows łȂꍇ
				Desktop dp = Desktop.getDesktop();
				dp.open(new File(url.toString().substring(7)));
			}
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
	}
	public void valueChanged(TreeSelectionEvent te){

		StringBuffer sb = new StringBuffer();

		// ݑIĂc[m[h擾
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)treeArea.getLastSelectedPathComponent();
		if (node != null){
			// Iꂽm[h̃pX擾
			TreePath path = treeArea.getSelectionPath();
			if (path != null) {
				// pX擾
				int pathCnt = path.getPathCount();
				// Iꂽm[h܂ł̃pX擾
				Object[] data = path.getPath();
				for (int i=0; i<pathCnt; i++) {
					if (i > 0) {
						sb.append(data[i]);
						sb.append(File.separator);
					}
				}
				jcboFolder.setSelectedItem(sb.toString());
			}
		}
	}
	// c[JۂɌĂ΂
	@Override
	public void treeWillExpand(TreeExpansionEvent event) throws ExpandVetoException {

		StringBuffer sb = new StringBuffer();

		TreePath path = event.getPath();

		if (path != null) {
			// pX擾
			int pathCnt = path.getPathCount();
			// Iꂽm[h܂ł̃pX擾
			Object[] data = path.getPath();
			for (int i=0; i<pathCnt; i++) {
				if (i > 0) {
					sb.append(data[i]);
					sb.append(File.separator);
				}
			}
			Object obj = path.getLastPathComponent(); //Ԗ[(JƂĂ)m[h
			if (obj instanceof MyMutableTreeNode) {
				MyMutableTreeNode node = (MyMutableTreeNode) obj;
				// qm[h폜
				node.removeAllChildren();
				// Iꂽm[h܂ł̃pX̃t@Cꗗ擾
				File RootDir[] = (new File(sb.toString())).listFiles();
				if (RootDir!=null) {
					for (int j=0; j<RootDir.length; j++) {
						if (RootDir[j].isDirectory()) {
							MyMutableTreeNode dirNode = new MyMutableTreeNode(RootDir[j].getName());
							node.add(dirNode);	// qm[hɃf[^ǉ
						}
					}
				}
				treeModel.reload(node);
			}
		}
	}
	// c[ۂɌĂ΂
	@Override
	public void treeWillCollapse(TreeExpansionEvent event) throws ExpandVetoException {
	}
	public void windowClosing(WindowEvent e) {
		dispose();
	}
	public void windowActivated(WindowEvent e) {
	}
	public void windowClosed(WindowEvent e) {
		OnExit();
	}
	public void windowDeactivated(WindowEvent e) {
	}
	public void windowIconified(WindowEvent e) {
	}
	public void windowDeiconified(WindowEvent e) {
	}
	public void windowOpened(WindowEvent e) {
	}

	////////////////////////////////////////////////////////////////////////////
	//[t@C]-[^XNgCɊi[]
	////////////////////////////////////////////////////////////////////////////
	void OnTray() {
		try {
			if (trayIcon == null) {
				// ^XNgCɊi[
				taskTrayMenu();
				// ʂ\ɂ
				setVisible(false);
			}
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}
	////////////////////////////////////////////////////////////////////////////
	//[t@C]-[I]
	////////////////////////////////////////////////////////////////////////////
	void OnExit() {
		try {
			if (trayIcon != null) {
				//VXegCACR폜
				SystemTray.getSystemTray().remove(trayIcon);
				trayIcon = null;
			}
			// vpeBt@Cւ̏
			SetProperties setProp = new SetProperties(commonProperties);
			// vOI
			System.exit(0);
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}
	////////////////////////////////////////////////////////////////////////////
	//[ҏW]-[ʂNA]
	////////////////////////////////////////////////////////////////////////////
	void OnClear() {
		jtxtResult.setText("");
	}
	////////////////////////////////////////////////////////////////////////////
	//[ҏW]-[ʂSI]
	////////////////////////////////////////////////////////////////////////////
	void OnAllSel() {
		jtxtResult.requestFocusInWindow();
		jtxtResult.selectAll();
	}
	////////////////////////////////////////////////////////////////////////////
	//[ҏW]-[I͈͂Nbv{[hɃRs[]
	////////////////////////////////////////////////////////////////////////////
	void OnCopy() {
		jtxtResult.copy();
	}
	////////////////////////////////////////////////////////////////////////////
	//[]-[Jn]
	////////////////////////////////////////////////////////////////////////////
	void OnSearch() {
		// JnÕ`FbNitH_j
		if ((String)jcboFolder.getSelectedItem() == null) {
			ErrorDialog d = new ErrorDialog(new JFrame(), "tH_w肵ĂB");
			return;
		}
		if (((String)jcboFolder.getSelectedItem()).trim().equals("")) {
			ErrorDialog d = new ErrorDialog(new JFrame(), "tH_w肵ĂB");
			return;
		}
		// JnÕ`FbNi镶Pj
		int chkFlg1 = 0;
		int chkFlg2 = 0;
		int chkFlg3 = 0;
		if ((String)jcboRegEx.getSelectedItem() == null) {
			chkFlg1 = 1;
		} else if (((String)jcboRegEx.getSelectedItem()).trim().equals("")) {
			chkFlg1 = 1;
		}
		// JnÕ`FbNi镶Qj
		if ((String)jcboRegExB.getSelectedItem() == null) {
			chkFlg2 = 1;
		} else if (((String)jcboRegExB.getSelectedItem()).trim().equals("")) {
			chkFlg2 = 1;
		}
		// JnÕ`FbNi镶Rj
		if ((String)jcboRegExC.getSelectedItem() == null) {
			chkFlg3 = 1;
		} else if (((String)jcboRegExC.getSelectedItem()).trim().equals("")) {
			chkFlg3 = 1;
		}
		if ((chkFlg1 == 1) && (chkFlg2 == 1) && (chkFlg3 == 1)) {
			ErrorDialog d = new ErrorDialog(new JFrame(), "镶ŒЂƂ͎w肵ĂB");
			return;
		}


		threadEndFlg = 0;	// XbhItOi0:s, 1:Ij
		progressCnt = 0;	// iJEg̏
		progressMonitor = new ProgressMonitor(this, "", "", 0, 100);

		// Jn
		Thread thread = new Thread(){
			public void run() {
				setEnabled(false);
				setCursor(new Cursor(Cursor.WAIT_CURSOR));		// ҂J[\
				if (threadEndFlg == 0) {
					// t@C̎擾
					progressMax = getFileNum();
				}
				if (threadEndFlg == 0) {
					// Jn
					searchStart();
				}
				setEnabled(true);
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));	// ftHgJ[\
				if (threadEndFlg == 1) {
					statusBar2.setText("@𒆎~܂B");
				} else {
					statusBar2.setText("@");
				}
			}
		};
		thread.start();

	}
	////////////////////////////////////////////////////////////////////////////
	//[]-[tH_c[ŐVԂɍXV]
	////////////////////////////////////////////////////////////////////////////
	void OnReload() {
		
		setCursor(new Cursor(Cursor.WAIT_CURSOR));	// ҂J[\
		
		// tH_c[̍쐬
		root = makeRoot("", 0);
		
		// tH_c[̃[h
		treeModel.reload();
		
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));	// ftHgJ[\
	}
	////////////////////////////////////////////////////////////////////////////
	//[wv]-[JGrepperɂ]
	////////////////////////////////////////////////////////////////////////////
	void OnAbout() {
		FormAbout d = new FormAbout(new JFrame());
	}
	////////////////////////////////////////////////////////////////////////////
	//[wv]-[GNU General Public License version 3 (GPLv3)]
	////////////////////////////////////////////////////////////////////////////
	void OnAboutGPL() {
		FormAboutGpl d = new FormAboutGpl(new JFrame());
	}
	////////////////////////////////////////////////////////////////////////////
	//[wv]-[Apache License Version 2.0]
	////////////////////////////////////////////////////////////////////////////
	void OnAboutASF() {
		FormAboutAsf d = new FormAboutAsf(new JFrame());
	}
	////////////////////////////////////////////////////////////////////////////
	//[wv]-[The Legion of the Bouncy Castle (MIT License)]
	////////////////////////////////////////////////////////////////////////////
	void OnAboutBouncyCastle() {
		FormAboutBouncyCastle d = new FormAboutBouncyCastle(new JFrame());
	}
	////////////////////////////////////////////////////////////////////////////
	//[wv]-[NOTICE]
	////////////////////////////////////////////////////////////////////////////
	void OnAboutNOTICE() {
		FormNOTICE d = new FormNOTICE(new JFrame());
	}

	////////////////////////////////////////////////////////////////////////////
	//t@Cڍ
	////////////////////////////////////////////////////////////////////////////
	void OnFileRefClick() {
		// ͈͂̐ݒʕ\
		FormRange d = new FormRange(new JFrame(), commonProperties);
		if (!(d.getFileName().equals(""))) {
			// [o^]{^
			jcboFile.setSelectedItem(d.getFileName());
		}
	}
	////////////////////////////////////////////////////////////////////////////
	//t@CNA
	////////////////////////////////////////////////////////////////////////////
	void OnFileClrClick() {
		jcboFile.removeAllItems();
		commonProperties.setFileName(null);
	}
	////////////////////////////////////////////////////////////////////////////
	//tH_NA
	////////////////////////////////////////////////////////////////////////////
	void OnFolderClrClick() {
		jcboFolder.removeAllItems();
		commonProperties.setFolderPath(null);
	}
	////////////////////////////////////////////////////////////////////////////
	//K\͂P
	////////////////////////////////////////////////////////////////////////////
	void OnRegExClick() {
		// ͉ʕ\
		FormCond d = new FormCond(new JFrame(), commonProperties);
		if (!(d.getRegex().equals(""))) {
			// [o^]{^
			jcboRegEx.setSelectedItem(d.getRegex());
		}
	}
	////////////////////////////////////////////////////////////////////////////
	//K\͂Q
	////////////////////////////////////////////////////////////////////////////
	void OnRegExBClick() {
		// ͉ʕ\
		FormCond d = new FormCond(new JFrame(), commonProperties);
		if (!(d.getRegex().equals(""))) {
			// [o^]{^
			jcboRegExB.setSelectedItem(d.getRegex());
		}
	}
	////////////////////////////////////////////////////////////////////////////
	//K\͂R
	////////////////////////////////////////////////////////////////////////////
	void OnRegExCClick() {
		// ͉ʕ\
		FormCond d = new FormCond(new JFrame(), commonProperties);
		if (!(d.getRegex().equals(""))) {
			// [o^]{^
			jcboRegExC.setSelectedItem(d.getRegex());
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[g쐬
	////////////////////////////////////////////////////////////////////////////
	private DefaultMutableTreeNode makeRoot(String rootdir, int splashFlg) {

		SplashScreen splash = null;
		Graphics2D graphic = null;
		Dimension size = null;
		if (splashFlg == 1) {
			// XvbVXN[
			splash = SplashScreen.getSplashScreen();
			graphic = (Graphics2D)splash.createGraphics();
			size = splash.getSize();
		}

		File curFile = new File(System.getProperty("user.dir"));	// JgtH_
		//String curDrv = curFile.getAbsolutePath().substring(0, 2);	// JghCu

		// 
		DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("Rs[^");

		// tH_c[ŐVԂɍXV
		if (splashFlg == 0) {
			rootNode = root;
			rootNode.removeAllChildren();
		}

		// SẴhCu擾
		File[] roots = curFile.listRoots();
		for(int i=0; i<roots.length; i++) {
			DefaultMutableTreeNode drvNode = null;
			if (System.getProperty("os.name").toUpperCase().startsWith("WINDOWS")) {
				// hCui"C:\"ł͂ȂA"C:"gpj
				drvNode = new DefaultMutableTreeNode(roots[i].getPath().substring(0, 2));
			} else {
				drvNode = new DefaultMutableTreeNode(roots[i].getPath());
			}
			File RootDir[] = (new File(roots[i].getPath())).listFiles();
			// [gfBNgȉ
			if (RootDir!=null) {
				for (int j=0; j<RootDir.length; j++) {
					if (RootDir[j].isDirectory()) {
						//System.out.println(RootDir[j].getName());
						if (splashFlg == 1) {
							// XvbVXN[ɓǂݍݒ̃tH_\
							if (splash != null) {
								graphic.setComposite(AlphaComposite.Clear);
								graphic.fillRect(0, 0, size.width, size.height);
								graphic.setPaintMode();
								graphic.setColor(Color.WHITE);
								graphic.drawString("tH_...", 10, 95);
								graphic.drawString(roots[i].getPath() + RootDir[j].getName(), 10, 110);
								splash.update();
								try {
									Thread.sleep(200);
								} catch (InterruptedException ex) {
									StringWriter stringWriter = new StringWriter();
									PrintWriter printWriter = new PrintWriter(stringWriter);
									ex.printStackTrace(printWriter);
									ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
									//ex.printStackTrace();
								}
							}
						}
						drvNode.add(searchDir(RootDir[j]));
					}
				}
			}
			rootNode.add(drvNode);	// hCũ[gfBNg
		}
		return(rootNode);
	}

	////////////////////////////////////////////////////////////////////////////
	//TutH_̈ꗗ擾
	////////////////////////////////////////////////////////////////////////////
	/********
	private DefaultMutableTreeNode searchDir(File dir) {

		DefaultMutableTreeNode dirNode = new DefaultMutableTreeNode(dir.getName());
		File Dir[] = dir.listFiles();

		if (Dir==null) {
			return(dirNode);
		}
		for (int i=0; i<Dir.length; i++) {
			if (Dir[i].isDirectory()) {
				dirNode.add(searchDir(Dir[i]));
			//} else {
			//	dirNode.add(new DefaultMutableTreeNode(Dir[i].getName()));
			}
		}
		return(dirNode);
	}
	********/
	private MyMutableTreeNode searchDir(File dir) {

		MyMutableTreeNode dirNode = new MyMutableTreeNode(dir.getName());
		return(dirNode);
	}

	////////////////////////////////////////////////////////////////////////////
	//̗͗XV
	////////////////////////////////////////////////////////////////////////////
	void historyUpdate() {

		try {

			int j = 0;

			//
			// t@C
			//
			// ݒ
			String[] aryFileName = commonProperties.getFileName();
			String[] aryFileNameNew = new String[20];
			for (int i=0; i<20; i++) {
				aryFileNameNew[i] = "";
			}
			// ߂̓͒l𗚗Xg̈Ԗڂɐݒ肷
			j = 0;
			aryFileNameNew[j] = (String)jcboFile.getSelectedItem();
			j = j + 1;
			// Xg̓Ԗڈȍ~ݒ肷
			if (aryFileName != null) {
				for (int i=0; i<20; i++) {
					if (j < 20) {
						if (aryFileName[i] != null) {
							if (!(aryFileName[i].trim().equals(""))) {
								if (!(aryFileName[i].trim().equals((String)jcboFile.getSelectedItem()))) {
									aryFileNameNew[j] = aryFileName[i];
									j = j + 1;
								}
							}
						}
					}
				}
			}
			// R{{bNX̗ݒ
			if (aryFileNameNew != null) {
				jcboFile.removeAllItems();
				for (int i=0; i<aryFileNameNew.length; i++) {
					if (aryFileNameNew[i] != null) {
						if (!(aryFileNameNew[i].trim().equals(""))) {
							jcboFile.addItem(aryFileNameNew[i]);
						}
					}
				}
				// ʃvpeBݒ
				commonProperties.setFileName(aryFileNameNew);
			}


			//
			// tH_
			//
			// ݒ
			String[] aryFolderPath = commonProperties.getFolderPath();
			String[] aryFolderPathNew = new String[20];
			for (int i=0; i<20; i++) {
				aryFolderPathNew[i] = "";
			}
			// ߂̓͒l𗚗Xg̈Ԗڂɐݒ肷
			j = 0;
			aryFolderPathNew[j] = (String)jcboFolder.getSelectedItem();
			j = j + 1;
			// Xg̓Ԗڈȍ~ݒ肷
			if (aryFolderPath != null) {
				for (int i=0; i<20; i++) {
					if (j < 20) {
						if (aryFolderPath[i] != null) {
							if (!(aryFolderPath[i].trim().equals(""))) {
								if (!(aryFolderPath[i].trim().equals((String)jcboFolder.getSelectedItem()))) {
									aryFolderPathNew[j] = aryFolderPath[i];
									j = j + 1;
								}
							}
						}
					}
				}
			}
			// R{{bNX̗ݒ
			if (aryFolderPathNew != null) {
				jcboFolder.removeAllItems();
				for (int i=0; i<aryFolderPathNew.length; i++) {
					if (aryFolderPathNew[i] != null) {
						if (!(aryFolderPathNew[i].trim().equals(""))) {
							jcboFolder.addItem(aryFolderPathNew[i]);
						}
					}
				}
				// ʃvpeBݒ
				commonProperties.setFolderPath(aryFolderPathNew);
			}


			//
			// GR[h̎
			//
			// ʃvpeBݒ
			commonProperties.setEncode((String)jcboEnc.getSelectedItem());


			//
			// 镶PiK\j
			//
			// ݒ
			String[] aryRegEx = commonProperties.getRegEx();
			String[] aryRegExNew = new String[20];
			for (int i=0; i<20; i++) {
				aryRegExNew[i] = "";
			}
			// ߂̓͒l𗚗Xg̈Ԗڂɐݒ肷
			j = 0;
			aryRegExNew[j] = (String)jcboRegEx.getSelectedItem();
			j = j + 1;
			// Xg̓Ԗڈȍ~ݒ肷
			if (aryRegEx != null) {
				for (int i=0; i<20; i++) {
					if (j < 20) {
						if (aryRegEx[i] != null) {
							//if (!(aryRegEx[i].trim().equals(""))) {
								if (!(aryRegEx[i].trim().equals((String)jcboRegEx.getSelectedItem()))) {
									aryRegExNew[j] = aryRegEx[i];
									j = j + 1;
								}
							//}
						}
					}
				}
			}
			// R{{bNX̗ݒ
			if (aryRegExNew != null) {
				jcboRegEx.removeAllItems();
				for (int i=0; i<aryRegExNew.length; i++) {
					if (aryRegExNew[i] != null) {
						//if (!(aryRegExNew[i].trim().equals(""))) {
							jcboRegEx.addItem(aryRegExNew[i]);
						//}
					}
				}
				// ʃvpeBݒ
				commonProperties.setRegEx(aryRegExNew);
			}


			//
			// 镶QiK\j
			//
			// ݒ
			String[] aryRegExB = commonProperties.getRegExB();
			String[] aryRegExBNew = new String[20];
			for (int i=0; i<20; i++) {
				aryRegExBNew[i] = "";
			}
			// ߂̓͒l𗚗Xg̈Ԗڂɐݒ肷
			j = 0;
			aryRegExBNew[j] = (String)jcboRegExB.getSelectedItem();
			j = j + 1;
			// Xg̓Ԗڈȍ~ݒ肷
			if (aryRegExB != null) {
				for (int i=0; i<20; i++) {
					if (j < 20) {
						if (aryRegExB[i] != null) {
							//if (!(aryRegExB[i].trim().equals(""))) {
								if (!(aryRegExB[i].trim().equals((String)jcboRegExB.getSelectedItem()))) {
									aryRegExBNew[j] = aryRegExB[i];
									j = j + 1;
								}
							//}
						}
					}
				}
			}
			// R{{bNX̗ݒ
			if (aryRegExBNew != null) {
				jcboRegExB.removeAllItems();
				for (int i=0; i<aryRegExBNew.length; i++) {
					if (aryRegExBNew[i] != null) {
						//if (!(aryRegExBNew[i].trim().equals(""))) {
							jcboRegExB.addItem(aryRegExBNew[i]);
						//}
					}
				}
				// ʃvpeBݒ
				commonProperties.setRegExB(aryRegExBNew);
			}


			//
			// 镶RiK\j
			//
			// ݒ
			String[] aryRegExC = commonProperties.getRegExC();
			String[] aryRegExCNew = new String[20];
			for (int i=0; i<20; i++) {
				aryRegExCNew[i] = "";
			}
			// ߂̓͒l𗚗Xg̈Ԗڂɐݒ肷
			j = 0;
			aryRegExCNew[j] = (String)jcboRegExC.getSelectedItem();
			j = j + 1;
			// Xg̓Ԗڈȍ~ݒ肷
			if (aryRegExC != null) {
				for (int i=0; i<20; i++) {
					if (j < 20) {
						if (aryRegExC[i] != null) {
							//if (!(aryRegExC[i].trim().equals(""))) {
								if (!(aryRegExC[i].trim().equals((String)jcboRegExC.getSelectedItem()))) {
									aryRegExCNew[j] = aryRegExC[i];
									j = j + 1;
								}
							//}
						}
					}
				}
			}
			// R{{bNX̗ݒ
			if (aryRegExCNew != null) {
				jcboRegExC.removeAllItems();
				for (int i=0; i<aryRegExCNew.length; i++) {
					if (aryRegExCNew[i] != null) {
						//if (!(aryRegExCNew[i].trim().equals(""))) {
							jcboRegExC.addItem(aryRegExCNew[i]);
						//}
					}
				}
				// ʃvpeBݒ
				commonProperties.setRegExC(aryRegExCNew);
			}

		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

	}

	////////////////////////////////////////////////////////////////////////////
	//Ώۃt@C̎擾
	////////////////////////////////////////////////////////////////////////////
	long getFileNum() {

		try {
			int firstFlg = 0;
			long fileNum = 0;

			jtxtResult.setText("");		// ʂ̃NA
			statusBar2.setText("@");	// Xe[^XEo[̃NA

			if ((String)jcboFile.getSelectedItem() == null) {
				return 0;
			}
			if ((String)jcboFolder.getSelectedItem() == null) {
				return 0;
			}
			String suffixes[] = ((String)jcboFile.getSelectedItem()).split(";");
			FilenameFilter filter = new SearchFileFilter(suffixes);
			
			File RootDir[] = (new File((String)jcboFolder.getSelectedItem())).listFiles();

			// tH_ȉ
			if (RootDir!=null) {
				for (int j=0; j<RootDir.length; j++) {
					if (RootDir[j].isDirectory()) {
						// tH_̏ꍇ
						if (jchkSubFolder.isSelected()) {
							// TutH_ꍇ̓tH_ȉ̌s
							fileNum = getNextFileNum(RootDir[j], filter, fileNum);
						}
					} else {
						// t@C̏ꍇ
						if (firstFlg == 0) {
							firstFlg = 1;
							File fileNameList[] = (new File((String)jcboFolder.getSelectedItem())).listFiles(filter);
							if (fileNameList != null) {
								fileNum = fileNum + fileNameList.length;
							}
						}
					}
					progressMonitor.setNote("t@C̑𒲂ׂĂ܂ " + fileNum);
					progressMonitor.setProgress(1); 
					statusBar2.setText("@Ώۃt@C̑𒲂ׂĂ܂... " + fileNum + " ");
					// ~
					if (threadEndFlg == 0) {
						if (progressMonitor.isCanceled()) {
							threadEndFlg = 1;
							break;
						}
					} else {
						break;
					}
				}
			}
			statusBar2.setText("@Ώۃt@C̑ " + fileNum + " ");
			return fileNum;
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			return 0;
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//TutH_ȉ̌
	////////////////////////////////////////////////////////////////////////////
	long getNextFileNum(File dir, FilenameFilter filter, long fileNum) {

		try {
			int firstFlg = 0;
			File Dir[] = dir.listFiles();

			if (Dir==null) {
				return fileNum;
			}
			for (int i=0; i<Dir.length; i++) {
				if (Dir[i].isDirectory()) {
					fileNum = getNextFileNum(Dir[i], filter, fileNum);
				} else {
					if (firstFlg == 0) {
						firstFlg = 1;
						File fileNameList[] = dir.listFiles(filter);
						if (fileNameList != null) {
							fileNum = fileNum + fileNameList.length;
						}
					}
				}
				progressMonitor.setNote("t@C̑𒲂ׂĂ܂ " + fileNum);
				progressMonitor.setProgress(1); 
				statusBar2.setText("@Ώۃt@C̑𒲂ׂĂ܂... " + fileNum + " ");
				// ~
				if (threadEndFlg == 0) {
					if (progressMonitor.isCanceled()) {
						threadEndFlg = 1;
						break;
					}
				} else {
					break;
				}
			}
			return fileNum;
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			return 0;
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//Jn
	////////////////////////////////////////////////////////////////////////////
	void searchStart() {

		try {
			int firstFlg = 0;
			StringBuffer sb = new StringBuffer();
			StringBuffer sbArchive = null;
//			sbArchive.append("");

			if (commonProperties.getTextFormat().equals("0")) {
				jtxtResult.setContentType("text/html; charset=UTF-8");
			} else {
				jtxtResult.setContentType("text/plain");
			}



			// ʌ̏
			commonProperties.setFindCnt(0);

			// HTML`̏ꍇ
			if (commonProperties.getTextFormat().equals("0")) {
				sb.append("<html>");
				sb.append("<head>");
				sb.append("<title>JGrepper - </title>");
				sb.append("</head>");
				sb.append("<body>");
			}

			// TNGfB^`̏ꍇ
			if (commonProperties.getTextFormat().equals("2")) {
				sb.append("  \"");
				sb.append((String)jcboRegEx.getSelectedItem());
				sb.append("\"");
				sb.append(System.getProperty("line.separator"));

				sb.append("Ώ   ");
				sb.append((String)jcboFile.getSelectedItem());
				sb.append(System.getProperty("line.separator"));

				sb.append("tH_   ");
				sb.append((String)jcboFolder.getSelectedItem());
				sb.append(System.getProperty("line.separator"));

				if (jchkSubFolder.isSelected()) {
					sb.append("    (TutH_)");
				} else {
					sb.append("    (TutH_Ȃ)");
				}
				sb.append(System.getProperty("line.separator"));

				if (jchkSearchOpt1.isSelected()) {
					sb.append("    (p啶ʂ)");
				} else {
					sb.append("    (p啶ʂȂ)");
				}
				sb.append(System.getProperty("line.separator"));

				sb.append("    (K\:JGrepper)");
				sb.append(System.getProperty("line.separator"));

				sb.append("    (R[hZbg");
				if (jcboEnc.getSelectedItem().equals("")) {
					sb.append("̎");
				} else if (jcboEnc.getSelectedItem().equals("Shift-JIS(Windows{)")) {
					sb.append("FSJIS");
				} else if (jcboEnc.getSelectedItem().equals("Shift-JIS({)")) {
					sb.append("FSJIS");
				} else if (jcboEnc.getSelectedItem().equals("EUC({)")) {
					sb.append("FEUC");
				} else if (jcboEnc.getSelectedItem().equals("JIS({)")) {
					sb.append("FJIS");
				} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-16)")) {
					sb.append("FUnicode");
				} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-16BigEndian)")) {
					sb.append("FUniBE");
				} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-32)")) {
					sb.append("FUnicode");
				} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-32BigEndian)")) {
					sb.append("FUniBE");
				} else if (jcboEnc.getSelectedItem().equals("UTF-8")) {
					sb.append("FUTF-8");
				}
				sb.append(")");
				sb.append(System.getProperty("line.separator"));

				sb.append("    (vso)");
				sb.append(System.getProperty("line.separator"));
				sb.append(System.getProperty("line.separator"));
			}

			if ((String)jcboFile.getSelectedItem() == null) {
				return;
			}
			if ((String)jcboFolder.getSelectedItem() == null) {
				return;
			}
			String suffixes[] = ((String)jcboFile.getSelectedItem()).split(";");
			FilenameFilter filter = new SearchFileFilter(suffixes);
			
			File RootDir[] = (new File((String)jcboFolder.getSelectedItem())).listFiles();

			// tH_ȉ
			if (RootDir!=null) {
				for (int j=0; j<RootDir.length; j++) {
					if (RootDir[j].isDirectory()) {
						// tH_̏ꍇ
						if (jchkSubFolder.isSelected()) {
							// TutH_ꍇ̓tH_ȉ̌s
							//System.out.println(RootDir[j].getName());
							searchNext(RootDir[j], filter, sb, sbArchive);
						}
					} else {
						// t@C̏ꍇ
						if (firstFlg == 0) {
							firstFlg = 1;
							File fileNameList[] = (new File((String)jcboFolder.getSelectedItem())).listFiles(filter);
							if (fileNameList != null) {
								for (int k=0; k<fileNameList.length; k++) {
									statusBar2.setText("@Ώۃt@C̑ " + progressMax + "   " + fileNameList[k].getAbsolutePath());
									if (!(fileNameList[k].isDirectory())) {
										if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".xls")) {
											resultFormatExcel97(sb, fileNameList[k].getAbsolutePath(), null, null);
										} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".xlsx")) {
											resultFormatExcel2007(sb, fileNameList[k].getAbsolutePath(), null, null);
										} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".doc")) {
											resultFormatWord97(sb, fileNameList[k].getAbsolutePath(), null, null);
										} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".ppt")) {
											resultFormatPowerPoint97(sb, fileNameList[k].getAbsolutePath(), null, null);
										} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".pdf")) {
											resultFormatPdf(sb, fileNameList[k].getAbsolutePath(), null, null);
										} else {
											if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".zip")) {
												if (jchkArchive.isSelected()) {
													sbArchive = new StringBuffer();
													resultFormatZip(sb, fileNameList[k].getAbsolutePath(), sbArchive);
												} else {
													resultFormat(sb, fileNameList[k].getAbsolutePath(), null, null, null);
												}
											} else {
												resultFormat(sb, fileNameList[k].getAbsolutePath(), null, null, null);
											}
										}
									}
									progressCnt = progressCnt + 1;
									progressMonitor.setProgress((int)(progressCnt * 100 / progressMax)); 
									progressMonitor.setNote(progressCnt + "/" + progressMax);
									// ~
									if (threadEndFlg == 0) {
										if (progressMonitor.isCanceled()) {
											threadEndFlg = 1;
											break;
										}
									} else {
										break;
									}
								}
							}
						}
					}
					// ~
					if (threadEndFlg == 0) {
						if (progressMonitor.isCanceled()) {
							threadEndFlg = 1;
							break;
						}
					} else {
						break;
					}
				}
				// HTML`̏ꍇ
				if (commonProperties.getTextFormat().equals("0")) {
					sb.append("</body>");
					sb.append(System.getProperty("line.separator"));
					sb.append("</html>");
					sb.append(System.getProperty("line.separator"));
				}
				// TNGfB^`̏ꍇ
				if (commonProperties.getTextFormat().equals("2")) {
					// 
					sb.append(Integer.toString(commonProperties.getFindCnt()));
					sb.append(" ܂B");
					sb.append(System.getProperty("line.separator"));
				}
				// 
				jtxtResult.setText(sb.toString());
			}
			// ̗͗XV
			historyUpdate();
			
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//TutH_ȉ̌
	////////////////////////////////////////////////////////////////////////////
	void searchNext(File dir, FilenameFilter filter, StringBuffer sb, StringBuffer sbArchive) {

		int firstFlg = 0;
		File Dir[] = dir.listFiles();

		if (Dir==null) {
			return;
		}
		for (int i=0; i<Dir.length; i++) {
			if (Dir[i].isDirectory()) {
				searchNext(Dir[i], filter, sb, sbArchive);
			} else {
				if (firstFlg == 0) {
					firstFlg = 1;
					File fileNameList[] = dir.listFiles(filter);
					if (fileNameList != null) {
						for (int k=0; k<fileNameList.length; k++) {
							statusBar2.setText("@Ώۃt@C̑ " + progressMax + "   " + fileNameList[k].getAbsolutePath());
							if (!(fileNameList[k].isDirectory())) {
								if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".xls")) {
									resultFormatExcel97(sb, fileNameList[k].getAbsolutePath(), null, null);
								} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".xlsx")) {
									resultFormatExcel2007(sb, fileNameList[k].getAbsolutePath(), null, null);
								} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".doc")) {
									resultFormatWord97(sb, fileNameList[k].getAbsolutePath(), null, null);
								} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".ppt")) {
									resultFormatPowerPoint97(sb, fileNameList[k].getAbsolutePath(), null, null);
								} else if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".pdf")) {
									resultFormatPdf(sb, fileNameList[k].getAbsolutePath(), null, null);
								} else {
									if (fileNameList[k].getAbsolutePath().toLowerCase().endsWith(".zip")) {
										if (jchkArchive.isSelected()) {
											sbArchive = new StringBuffer();
											resultFormatZip(sb, fileNameList[k].getAbsolutePath(), sbArchive);
										} else {
											resultFormat(sb, fileNameList[k].getAbsolutePath(), null, null, null);
										}
									} else {
										resultFormat(sb, fileNameList[k].getAbsolutePath(), null, null, null);
									}
								}
							}
							progressCnt = progressCnt + 1;
							progressMonitor.setProgress((int)(progressCnt * 100 / progressMax)); 
							progressMonitor.setNote(progressCnt + "/" + progressMax);
							// ~
							if (threadEndFlg == 0) {
								if (progressMonitor.isCanceled()) {
									threadEndFlg = 1;
									break;
								}
							} else {
								break;
							}
						}
					}
				}
			}
			// ~
			if (threadEndFlg == 0) {
				if (progressMonitor.isCanceled()) {
					threadEndFlg = 1;
					break;
				}
			} else {
				break;
			}
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWiyhoj
	////////////////////////////////////////////////////////////////////////////
	void resultFormatZip(StringBuffer sb, String zipFileName, StringBuffer sbArchive) {
		try {
			if (sbArchive.toString().equals("")) {
				sbArchive.append("[ZIP]" + zipFileName);
			} else {
				// o[Wł͂PiK̈k܂łT|[gȂ̂ŁA elsẽWbNs邱Ƃ͂ȂA
				// IɂQiKȏ̈k܂ŃT|[gꍇ́A elseKvɂȂ̂ŎcĂB
				sbArchive.append(" ==> " + zipFileName);
			}
			ZipFile zf = new ZipFile(zipFileName);
			Enumeration enumZf = zf.getEntries();
			while (enumZf.hasMoreElements()) {
				ZipEntry ze = zf.getEntry(enumZf.nextElement().toString());
				// fBNg̏ꍇ͏Ȃ
				if (!(ze.isDirectory())) {
					//
					InputStream inputStream = zf.getInputStream(ze);
					InputStream encStream = zf.getInputStream(ze);
					//
					if (ze.getName().toLowerCase().endsWith(".xls")) {
						resultFormatExcel97(sb, ze.getName(), inputStream, sbArchive.toString());
					} else if (ze.getName().toLowerCase().endsWith(".xlsx")) {
						resultFormatExcel2007(sb, ze.getName(), inputStream, sbArchive.toString());
					} else if (ze.getName().toLowerCase().endsWith(".doc")) {
						resultFormatWord97(sb, ze.getName(), inputStream, sbArchive.toString());
					} else if (ze.getName().toLowerCase().endsWith(".ppt")) {
						resultFormatPowerPoint97(sb, ze.getName(), inputStream, sbArchive.toString());
					} else if (ze.getName().toLowerCase().endsWith(".pdf")) {
						resultFormatPdf(sb, ze.getName(), inputStream, sbArchive.toString());
					} else if (ze.getName().toLowerCase().endsWith(".zip")) {
						// o[Wł́APiK̈k܂ł̃T|[gƂ
					} else {
						resultFormat(sb, ze.getName(), inputStream, encStream, sbArchive.toString());
					}
					inputStream.close();
					encStream.close();
				}
			}
			zf.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWiv[eLXgj
	////////////////////////////////////////////////////////////////////////////
	void resultFormat(StringBuffer sb, String fileName, InputStream inputStream, InputStream encStream, String archiveFileName) {
		try {
			String strEnc = "";
			// Xg[̍쐬Abv
			InputStream inStream = null;
			InputStreamReader in = null;
			if (archiveFileName != null) {
				inStream = inputStream;
			} else {
				inStream = (InputStream)(new FileInputStream(fileName));
			}
			//
			if (jcboEnc.getSelectedItem().equals("")) {
				// ̃t@C̃GR[fBO𒲂ׂ
				UniversalDetector detector = new UniversalDetector(null);
				InputStream fis = null;
				if (archiveFileName != null) {
					fis = encStream;
				} else {
					fis = (InputStream)(new FileInputStream(fileName));
				}
				// Tvf[^^
				byte[] buf = new byte[4096];
				int nread;
				while (((nread=fis.read(buf)) > 0) && !detector.isDone()) {
					detector.handleData(buf, 0, nread);
				}
				fis.close();
				fis = null;
				detector.dataEnd();

				// GR[fBO擾
				String encoding = detector.getDetectedCharset();
				if (encoding != null) {
					if (encoding.equals("ISO-2022-JP")) {
						in = new InputStreamReader(inStream, "ISO2022JP");
						strEnc = "JIS";
					} else if (encoding.equals("SHIFT_JIS")) {
						in = new InputStreamReader(inStream, "MS932");
						strEnc = "SJIS";
					} else if (encoding.equals("EUC-JP")) {
						in = new InputStreamReader(inStream, "EUC_JP");
						strEnc = "EUC";
					} else if (encoding.equals("UTF-8")) {
						in = new InputStreamReader(inStream, "UTF8");
						strEnc = "UTF-8";
					} else if (encoding.equals("UTF-16LE")) {
						in = new InputStreamReader(inStream, "UnicodeLittle");
						strEnc = "Unicode";
					} else if (encoding.equals("UTF-16BE")) {
						in = new InputStreamReader(inStream, "UnicodeBig");
						strEnc = "UniBE";
					} else if (encoding.equals("UTF-32LE")) {
						in = new InputStreamReader(inStream, "UTF_32LE_BOM");
						strEnc = "Unicode";
					} else if (encoding.equals("UTF-32BE")) {
						in = new InputStreamReader(inStream, "UTF_32BE_BOM");
						strEnc = "UniBE";
					} else {
						// GR[fBOzȌꍇ͖ɁuShift-JIS(Windows{)vɂ
						in = new InputStreamReader(inStream, "MS932");
						strEnc = "SJIS";
					}
				} else {
					// t@CTCY[̏ꍇA܂́A
					// GR[fBOsȏꍇ͖ɁuShift-JIS(Windows{)vɂ
					in = new InputStreamReader(inStream, "MS932");
					strEnc = "SJIS";
				}
				detector.reset();
			} else if (jcboEnc.getSelectedItem().equals("Shift-JIS(Windows{)")) {
				in = new InputStreamReader(inStream, "MS932");
				strEnc = "SJIS";
			} else if (jcboEnc.getSelectedItem().equals("Shift-JIS({)")) {
				in = new InputStreamReader(inStream, "SJIS");
				strEnc = "SJIS";
			} else if (jcboEnc.getSelectedItem().equals("EUC({)")) {
				in = new InputStreamReader(inStream, "EUC_JP");
				strEnc = "EUC";
			} else if (jcboEnc.getSelectedItem().equals("JIS({)")) {
				in = new InputStreamReader(inStream, "ISO2022JP");
				strEnc = "JIS";
			} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-16)")) {
				in = new InputStreamReader(inStream, "UnicodeLittle");
				strEnc = "Unicode";
			} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-16BigEndian)")) {
				in = new InputStreamReader(inStream, "UnicodeBig");
				strEnc = "UniBE";
			} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-32)")) {
				in = new InputStreamReader(inStream, "UTF_32LE_BOM");
				strEnc = "Unicode";
			} else if (jcboEnc.getSelectedItem().equals("Unicode(UTF-32BigEndian)")) {
				in = new InputStreamReader(inStream, "UTF_32BE_BOM");
				strEnc = "UniBE";
			} else if (jcboEnc.getSelectedItem().equals("UTF-8")) {
				in = new InputStreamReader(inStream, "UTF8");
				strEnc = "UTF-8";
			}

			Pattern pattern;
			Pattern patternB;
			Pattern patternC;
			Matcher matcher = null;
			Matcher matcherB = null;
			Matcher matcherC = null;

			int forSakuraFlg = 0;

			int lineNo = 0;
			String inString = null;
			BufferedReader br = new BufferedReader(in);
			while((inString = br.readLine()) != null) {
				// sԍ̃JEg
				lineNo = lineNo + 1;

				// }b`Oi镶Pj
				String strRegex = (String)jcboRegEx.getSelectedItem();
				if (strRegex != null) {
					if (!(strRegex.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							pattern = Pattern.compile(strRegex);
						} else {
							// 啶ƏʂȂ
							pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcher = pattern.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcher = pattern.matcher(inString);
						}
					}
				}
				// }b`Oi镶Qj
				String strRegexB = (String)jcboRegExB.getSelectedItem();
				if (strRegexB != null) {
					if (!(strRegexB.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							patternB = Pattern.compile(strRegexB);
						} else {
							// 啶ƏʂȂ
							patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcherB = patternB.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcherB = patternB.matcher(inString);
						}
					}
				}
				// }b`Oi镶Rj
				String strRegexC = (String)jcboRegExC.getSelectedItem();
				if (strRegexC != null) {
					if (!(strRegexC.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							patternC = Pattern.compile(strRegexC);
						} else {
							// 啶ƏʂȂ
							patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcherC = patternC.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcherC = patternC.matcher(inString);
						}
					}
				}

				forSakuraFlg = 0;

				int findFlg = 0;
				if (jrdoAnd.isSelected()) {
					// ׂẴL[[h܂
					if (strRegex != null) {
						if (!(strRegex.equals(""))) {
							if (matcher.find()) {
								findFlg = findFlg + 1;
								forSakuraFlg = 1;
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
					if (strRegexB != null) {
						if (!(strRegexB.equals(""))) {
							if (matcherB.find()) {
								findFlg = findFlg + 1;
								if (forSakuraFlg == 0) {
									forSakuraFlg = 2;
								}
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
					if (strRegexC != null) {
						if (!(strRegexC.equals(""))) {
							if (matcherC.find()) {
								findFlg = findFlg + 1;
								if (forSakuraFlg == 0) {
									forSakuraFlg = 3;
								}
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
				} else {
					// ꂩ̃L[[h܂
					if (strRegex != null) {
						if (!(strRegex.equals(""))) {
							if (matcher.find()) {
								findFlg = 3;
								forSakuraFlg = 1;
							}
						}
					}
					if (strRegexB != null) {
						if (!(strRegexB.equals(""))) {
							if (matcherB.find()) {
								findFlg = 3;
								if (forSakuraFlg == 0) {
									forSakuraFlg = 2;
								}
							}
						}
					}
					if (strRegexC != null) {
						if (!(strRegexC.equals(""))) {
							if (matcherC.find()) {
								findFlg = 3;
								if (forSakuraFlg == 0) {
									forSakuraFlg = 3;
								}
							}
						}
					}
				}

				//if (matcher.find()) {
				if (findFlg == 3) {

					// ̃JEg
					commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);

					// GfB^ʂɌʂ̕ҏW
					if (commonProperties.getTextFormat().equals("0")) {
						// 0:HTML`
						if (archiveFileName != null) {
							sb.append(archiveFileName.substring(0,5));
							sb.append("<a href=\"file://");
							sb.append(archiveFileName.substring(5));
							sb.append("\">");
							sb.append(archiveFileName.substring(5));
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
							sb.append("==> ");
							sb.append(fileName);
							sb.append("<br>");
							sb.append(System.getProperty("line.separator"));
						} else {
							sb.append("<a href=\"file://");
							sb.append(fileName);
							sb.append("\">");
							sb.append(fileName);
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
						}
						sb.append(Integer.toString(lineNo));
						sb.append("s:");
						sb.append("<br>");
						sb.append(System.getProperty("line.separator"));
						sb.append("<plaintext>");
						sb.append(inString);
						sb.append("</plaintext>");
						sb.append("<br><br>");
						sb.append(System.getProperty("line.separator"));
					} else if (commonProperties.getTextFormat().equals("1")) {
						// 1:Gی`
						if (archiveFileName != null) {
							sb.append(archiveFileName);
							sb.append(" ==> ");
						}
						sb.append(fileName);
						sb.append("(");
						sb.append(Integer.toString(lineNo));
						sb.append("): ");
						sb.append(inString);
						sb.append(System.getProperty("line.separator"));
					} else if (commonProperties.getTextFormat().equals("2")) {
						// 2:TNGfB^`
						if (archiveFileName != null) {
							sb.append(archiveFileName);
							sb.append(" ==> ");
						}
						sb.append(fileName);
						sb.append("(");
						sb.append(Integer.toString(lineNo));
						sb.append(",");
						if (forSakuraFlg == 1) {
							if (matcher.toMatchResult().start() <= 0) {
								sb.append("1");
							} else {
								byte[] inBytes1 = (inString.substring(0, matcher.toMatchResult().start())).getBytes("MS932");
								sb.append(Integer.toString(inBytes1.length + 1));
							}
						} else if (forSakuraFlg == 2) {
							if (matcherB.toMatchResult().start() <= 0) {
								sb.append("1");
							} else {
								byte[] inBytes1 = (inString.substring(0, matcherB.toMatchResult().start())).getBytes("MS932");
								sb.append(Integer.toString(inBytes1.length + 1));
							}
						} else if (forSakuraFlg == 3) {
							if (matcherC.toMatchResult().start() <= 0) {
								sb.append("1");
							} else {
								byte[] inBytes1 = (inString.substring(0, matcherC.toMatchResult().start())).getBytes("MS932");
								sb.append(Integer.toString(inBytes1.length + 1));
							}
						}
						sb.append(")");
						if (jcboEnc.getSelectedItem().equals("")) {
							sb.append("  [");
							sb.append(strEnc);
							sb.append("]");
						}
						sb.append(": ");
						sb.append(inString);
						sb.append(System.getProperty("line.separator"));
					} else {
						// LȊO:HTML`
						if (archiveFileName != null) {
							sb.append(archiveFileName.substring(0,5));
							sb.append("<a href=\"file://");
							sb.append(archiveFileName.substring(5));
							sb.append("\">");
							sb.append(archiveFileName.substring(5));
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
							sb.append("==> ");
							sb.append(fileName);
							sb.append("<br>");
							sb.append(System.getProperty("line.separator"));
						} else {
							sb.append("<a href=\"file://");
							sb.append(fileName);
							sb.append("\">");
							sb.append(fileName);
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
						}
						sb.append(Integer.toString(lineNo));
						sb.append("s:");
						sb.append("<br>");
						sb.append(System.getProperty("line.separator"));
						sb.append("<plaintext>");
						sb.append(inString);
						sb.append("</plaintext>");
						sb.append("<br><br>");
						sb.append(System.getProperty("line.separator"));
					}
				}
			}
			// Xg[
			br.close();
			in.close();
			inStream.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWidXV|QOORj
	////////////////////////////////////////////////////////////////////////////
	void resultFormatExcel97(StringBuffer sb, String fileName, InputStream inputStream, String archiveFileName) {

		try {
			// Excel̃t@Cǂݍ݁A[NubN擾
			HSSFWorkbook book = null;
			if (archiveFileName != null) {
				book = new HSSFWorkbook(inputStream);
			} else {
				book = new HSSFWorkbook(new FileInputStream(fileName));
			}

			// V[g擾
			int sheets = book.getNumberOfSheets();

			for (int sheetNumber=0; sheetNumber<sheets; sheetNumber++) {
				HSSFSheet sheet = book.getSheetAt(sheetNumber);	// V[g擾
				int firstRowNum = sheet.getFirstRowNum();		// f[^̂ŏ̍s̍sԍ擾
				int lastRowNum = sheet.getLastRowNum();			// f[^̂Ō̍s̍sԍ擾
				for (int rowNum=firstRowNum; rowNum<=lastRowNum; rowNum++) {
					// s擾
					HSSFRow row = sheet.getRow(rowNum);
					if (row == null) {
						continue;
					}
					int firstCellNum = row.getFirstCellNum();	// f[^̂ŏ̗̗ԍ擾
					int lastCellNum = row.getLastCellNum();		// f[^̂Ō̗̗ԍ擾
					for (int cellNum=firstCellNum; cellNum<=lastCellNum; cellNum++) {
						// Z擾
						HSSFCell cell = row.getCell(cellNum);
						//if (cell == null) {
						//	continue;
						//}

						Pattern pattern;
						Pattern patternB;
						Pattern patternC;
						Matcher matcher = null;
						Matcher matcherB = null;
						Matcher matcherC = null;
						String inString;
						String strRegex;
						String strRegexB;
						String strRegexC;
						int findFlg = 0;

						if (cell != null) {
							// Z̒l擾
							inString = null;
							if (cell.getCellType() == HSSFCell.CELL_TYPE_STRING) {
								inString = cell.getStringCellValue();
							}
							if (inString != null) {
								// }b`Oi镶Pj
								strRegex = (String)jcboRegEx.getSelectedItem();
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											pattern = Pattern.compile(strRegex);
										} else {
											// 啶ƏʂȂ
											pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcher = pattern.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcher = pattern.matcher(inString);
										}
									}
								}
								// }b`Oi镶Qj
								strRegexB = (String)jcboRegExB.getSelectedItem();
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternB = Pattern.compile(strRegexB);
										} else {
											// 啶ƏʂȂ
											patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherB = patternB.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherB = patternB.matcher(inString);
										}
									}
								}
								// }b`Oi镶Rj
								strRegexC = (String)jcboRegExC.getSelectedItem();
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternC = Pattern.compile(strRegexC);
										} else {
											// 啶ƏʂȂ
											patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherC = patternC.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherC = patternC.matcher(inString);
										}
									}
								}
								findFlg = 0;
								if (jrdoAnd.isSelected()) {
									// ׂẴL[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									// ꂩ̃L[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = 3;
											}
										}
									}
								}
								//if (matcher.find()) {
								if (findFlg == 3) {
									// ̃JEg
									commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
									if (commonProperties.getTextFormat().equals("0")) {
										// 0:HTML`
										if (archiveFileName != null) {
											sb.append(archiveFileName.substring(0,5));
											sb.append("<a href=\"file://");
											sb.append(archiveFileName.substring(5));
											sb.append("\">");
											sb.append(archiveFileName.substring(5));
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
											sb.append("==> ");
											sb.append("[Excel]");
											sb.append(fileName);
											sb.append("<br>");
											sb.append(System.getProperty("line.separator"));
										} else {
											sb.append("[Excel]");
											sb.append("<a href=\"file://");
											sb.append(fileName);
											sb.append("\">");
											sb.append(fileName);
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
										}
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̒l: ");
										sb.append("<br>");
										sb.append(System.getProperty("line.separator"));
										sb.append("<plaintext>");
										sb.append(inString);
										sb.append("</plaintext>");
										sb.append("<br><br>");
										sb.append(System.getProperty("line.separator"));
									} else {
										if (archiveFileName != null) {
											sb.append(archiveFileName);
											sb.append(" ==> ");
										}
										sb.append("[Excel]");
										sb.append(fileName);
										sb.append(", ");
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̒l: ");
										sb.append(inString);
										sb.append(System.getProperty("line.separator"));
									}
								}
							}
						}
						
						// Z̃Rg擾
						HSSFComment cellComment = sheet.getCellComment(rowNum, cellNum);
						if (cellComment != null) {
							inString = cellComment.getString().getString();
							if (inString != null) {
								// }b`Oi镶Pj
								strRegex = (String)jcboRegEx.getSelectedItem();
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											pattern = Pattern.compile(strRegex);
										} else {
											// 啶ƏʂȂ
											pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcher = pattern.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcher = pattern.matcher(inString);
										}
									}
								}
								// }b`Oi镶Qj
								strRegexB = (String)jcboRegExB.getSelectedItem();
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternB = Pattern.compile(strRegexB);
										} else {
											// 啶ƏʂȂ
											patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherB = patternB.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherB = patternB.matcher(inString);
										}
									}
								}
								// }b`Oi镶Rj
								strRegexC = (String)jcboRegExC.getSelectedItem();
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternC = Pattern.compile(strRegexC);
										} else {
											// 啶ƏʂȂ
											patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherC = patternC.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherC = patternC.matcher(inString);
										}
									}
								}
								findFlg = 0;
								if (jrdoAnd.isSelected()) {
									// ׂẴL[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									// ꂩ̃L[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = 3;
											}
										}
									}
								}
								//if (matcher.find()) {
								if (findFlg == 3) {
									// ̃JEg
									commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
									if (commonProperties.getTextFormat().equals("0")) {
										// 0:HTML`
										if (archiveFileName != null) {
											sb.append(archiveFileName.substring(0,5));
											sb.append("<a href=\"file://");
											sb.append(archiveFileName.substring(5));
											sb.append("\">");
											sb.append(archiveFileName.substring(5));
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
											sb.append("==> ");
											sb.append("[Excel]");
											sb.append(fileName);
											sb.append("<br>");
											sb.append(System.getProperty("line.separator"));
										} else {
											sb.append("[Excel]");
											sb.append("<a href=\"file://");
											sb.append(fileName);
											sb.append("\">");
											sb.append(fileName);
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
										}
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̃Rg: ");
										sb.append("<br>");
										sb.append(System.getProperty("line.separator"));
										sb.append("<plaintext>");
										sb.append(inString);
										sb.append("</plaintext>");
										sb.append("<br><br>");
										sb.append(System.getProperty("line.separator"));
									} else {
										if (archiveFileName != null) {
											sb.append(archiveFileName);
											sb.append(" ==> ");
										}
										sb.append("[Excel]");
										sb.append(fileName);
										sb.append(", ");
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̃Rg: ");
										sb.append(inString);
										sb.append(System.getProperty("line.separator"));
									}
								}
							}
						}

					}
				}
			}

		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}


	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWidQOOVj
	////////////////////////////////////////////////////////////////////////////
	void resultFormatExcel2007(StringBuffer sb, String fileName, InputStream inputStream, String archiveFileName) {

		try {
			// Excel̃t@Cǂݍ݁A[NubN擾
			XSSFWorkbook book = null;
			if (archiveFileName != null) {
				book = new XSSFWorkbook(inputStream);
			} else {
				book = new XSSFWorkbook(new FileInputStream(fileName));
			}

			// V[g擾
			int sheets = book.getNumberOfSheets();

			for (int sheetNumber=0; sheetNumber<sheets; sheetNumber++) {
				XSSFSheet sheet = book.getSheetAt(sheetNumber);	// V[g擾
				int firstRowNum = sheet.getFirstRowNum();		// f[^̂ŏ̍s̍sԍ擾
				int lastRowNum = sheet.getLastRowNum();			// f[^̂Ō̍s̍sԍ擾
				for (int rowNum=firstRowNum; rowNum<=lastRowNum; rowNum++) {
					// s擾
					XSSFRow row = sheet.getRow(rowNum);
					if (row == null) {
						continue;
					}
					int firstCellNum = row.getFirstCellNum();	// f[^̂ŏ̗̗ԍ擾
					int lastCellNum = row.getLastCellNum();		// f[^̂Ō̗̗ԍ擾
					for (int cellNum=firstCellNum; cellNum<=lastCellNum; cellNum++) {
						// Z擾
						XSSFCell cell = row.getCell(cellNum);
						//if (cell == null) {
						//	continue;
						//}

						Pattern pattern;
						Pattern patternB;
						Pattern patternC;
						Matcher matcher = null;
						Matcher matcherB = null;
						Matcher matcherC = null;
						String inString;
						String strRegex;
						String strRegexB;
						String strRegexC;
						int findFlg = 0;

						if (cell != null) {
							// Z̒l擾
							inString = null;
							if (cell.getCellType() == XSSFCell.CELL_TYPE_STRING) {
								inString = cell.getStringCellValue();
							}
							if (inString != null) {
								// }b`Oi镶Pj
								strRegex = (String)jcboRegEx.getSelectedItem();
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											pattern = Pattern.compile(strRegex);
										} else {
											// 啶ƏʂȂ
											pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcher = pattern.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcher = pattern.matcher(inString);
										}
									}
								}
								// }b`Oi镶Qj
								strRegexB = (String)jcboRegExB.getSelectedItem();
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternB = Pattern.compile(strRegexB);
										} else {
											// 啶ƏʂȂ
											patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherB = patternB.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherB = patternB.matcher(inString);
										}
									}
								}
								// }b`Oi镶Rj
								strRegexC = (String)jcboRegExC.getSelectedItem();
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternC = Pattern.compile(strRegexC);
										} else {
											// 啶ƏʂȂ
											patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherC = patternC.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherC = patternC.matcher(inString);
										}
									}
								}
								findFlg = 0;
								if (jrdoAnd.isSelected()) {
									// ׂẴL[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									// ꂩ̃L[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = 3;
											}
										}
									}
								}
								//if (matcher.find()) {
								if (findFlg == 3) {
									// ̃JEg
									commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
									if (commonProperties.getTextFormat().equals("0")) {
										// 0:HTML`
										if (archiveFileName != null) {
											sb.append(archiveFileName.substring(0,5));
											sb.append("<a href=\"file://");
											sb.append(archiveFileName.substring(5));
											sb.append("\">");
											sb.append(archiveFileName.substring(5));
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
											sb.append("==> ");
											sb.append("[Excel]");
											sb.append(fileName);
											sb.append("<br>");
											sb.append(System.getProperty("line.separator"));
										} else {
											sb.append("[Excel]");
											sb.append("<a href=\"file://");
											sb.append(fileName);
											sb.append("\">");
											sb.append(fileName);
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
										}
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̒l: ");
										sb.append("<br>");
										sb.append(System.getProperty("line.separator"));
										sb.append("<plaintext>");
										sb.append(inString);
										sb.append("</plaintext>");
										sb.append("<br><br>");
										sb.append(System.getProperty("line.separator"));
									} else {
										if (archiveFileName != null) {
											sb.append(archiveFileName);
											sb.append(" ==> ");
										}
										sb.append("[Excel]");
										sb.append(fileName);
										sb.append(", ");
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̒l: ");
										sb.append(inString);
										sb.append(System.getProperty("line.separator"));
									}
								}
							}
						}
						
						// Z̃Rg擾
						XSSFComment cellComment = sheet.getCellComment(rowNum, cellNum);
						if (cellComment != null) {
							inString = cellComment.getString().getString();
							if (inString != null) {
								// }b`Oi镶Pj
								strRegex = (String)jcboRegEx.getSelectedItem();
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											pattern = Pattern.compile(strRegex);
										} else {
											// 啶ƏʂȂ
											pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcher = pattern.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcher = pattern.matcher(inString);
										}
									}
								}
								// }b`Oi镶Qj
								strRegexB = (String)jcboRegExB.getSelectedItem();
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternB = Pattern.compile(strRegexB);
										} else {
											// 啶ƏʂȂ
											patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherB = patternB.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherB = patternB.matcher(inString);
										}
									}
								}
								// }b`Oi镶Rj
								strRegexC = (String)jcboRegExC.getSelectedItem();
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (jchkSearchOpt1.isSelected()) {
											// 啶Əʂ
											patternC = Pattern.compile(strRegexC);
										} else {
											// 啶ƏʂȂ
											patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
										}
										if (jchkSearchOpt2.isSelected()) {
											// sƍs̋󔒂𖳎
											matcherC = patternC.matcher(inString.trim());
										} else {
											// sƍs̋󔒂𖳎Ȃ
											matcherC = patternC.matcher(inString);
										}
									}
								}
								findFlg = 0;
								if (jrdoAnd.isSelected()) {
									// ׂẴL[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									// ꂩ̃L[[h܂
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (matcher.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (matcherB.find()) {
												findFlg = 3;
											}
										}
									}
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (matcherC.find()) {
												findFlg = 3;
											}
										}
									}
								}
								//if (matcher.find()) {
								if (findFlg == 3) {
									// ̃JEg
									commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
									if (commonProperties.getTextFormat().equals("0")) {
										// 0:HTML`
										if (archiveFileName != null) {
											sb.append(archiveFileName.substring(0,5));
											sb.append("<a href=\"file://");
											sb.append(archiveFileName.substring(5));
											sb.append("\">");
											sb.append(archiveFileName.substring(5));
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
											sb.append("==> ");
											sb.append("[Excel]");
											sb.append(fileName);
											sb.append("<br>");
											sb.append(System.getProperty("line.separator"));
										} else {
											sb.append("[Excel]");
											sb.append("<a href=\"file://");
											sb.append(fileName);
											sb.append("\">");
											sb.append(fileName);
											sb.append("</a><br>");
											sb.append(System.getProperty("line.separator"));
										}
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̃Rg: ");
										sb.append("<br>");
										sb.append(System.getProperty("line.separator"));
										sb.append("<plaintext>");
										sb.append(inString);
										sb.append("</plaintext>");
										sb.append("<br><br>");
										sb.append(System.getProperty("line.separator"));
									} else {
										if (archiveFileName != null) {
											sb.append(archiveFileName);
											sb.append(" ==> ");
										}
										sb.append("[Excel]");
										sb.append(fileName);
										sb.append(", ");
										sb.append("V[g=(");
										sb.append(book.getSheetName(sheetNumber));
										sb.append("), ");
										sb.append("Z(");
										sb.append(Integer.toString(rowNum + 1));
										sb.append(",");
										sb.append(Integer.toString(cellNum + 1));
										sb.append(")̃Rg: ");
										sb.append(inString);
										sb.append(System.getProperty("line.separator"));
									}
								}
							}
						}
					}
				}
			}

		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}


	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWivXV|QOORj
	////////////////////////////////////////////////////////////////////////////
	void resultFormatWord97(StringBuffer sb, String fileName, InputStream inputStream, String archiveFileName) {

		try {
			StringBuffer sbBuf = null;

			// Word̃t@Cǂݍ
			HWPFDocument doc = null;
			if (archiveFileName != null) {
				doc = new HWPFDocument(inputStream);
			} else {
				doc = new HWPFDocument(new FileInputStream(fileName));
			}

			// 擾
			Range r = doc.getRange();
			for (int i=0; i<r.numSections(); i++) {
				// ߂擾
				Section s = r.getSection(i);
				for (int j=0; j<s.numParagraphs(); j++) {
					// i擾
					Paragraph p = s.getParagraph(j);
					sbBuf = new StringBuffer();
					for (int k=0; k<p.numCharacterRuns(); k++) {
						// ǂݏo
						CharacterRun run = p.getCharacterRun(k);
						String text = run.text();
						sbBuf.append(text);
					}
					Pattern pattern;
					Pattern patternB;
					Pattern patternC;
					Matcher matcher = null;
					Matcher matcherB = null;
					Matcher matcherC = null;
					String inString;
					String strRegex;
					String strRegexB;
					String strRegexC;
					int findFlg = 0;

					StringReader sr = new StringReader(sbBuf.toString());
					BufferedReader br = new BufferedReader(sr);
					while((inString=br.readLine()) != null) { 
						// }b`Oi镶Pj
						strRegex = (String)jcboRegEx.getSelectedItem();
						if (strRegex != null) {
							if (!(strRegex.equals(""))) {
								if (jchkSearchOpt1.isSelected()) {
									// 啶Əʂ
									pattern = Pattern.compile(strRegex);
								} else {
									// 啶ƏʂȂ
									pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
								}
								if (jchkSearchOpt2.isSelected()) {
									// sƍs̋󔒂𖳎
									matcher = pattern.matcher(inString.trim());
								} else {
									// sƍs̋󔒂𖳎Ȃ
									matcher = pattern.matcher(inString);
								}
							}
						}
						// }b`Oi镶Qj
						strRegexB = (String)jcboRegExB.getSelectedItem();
						if (strRegexB != null) {
							if (!(strRegexB.equals(""))) {
								if (jchkSearchOpt1.isSelected()) {
									// 啶Əʂ
									patternB = Pattern.compile(strRegexB);
								} else {
									// 啶ƏʂȂ
									patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
								}
								if (jchkSearchOpt2.isSelected()) {
									// sƍs̋󔒂𖳎
									matcherB = patternB.matcher(inString.trim());
								} else {
									// sƍs̋󔒂𖳎Ȃ
									matcherB = patternB.matcher(inString);
								}
							}
						}
						// }b`Oi镶Rj
						strRegexC = (String)jcboRegExC.getSelectedItem();
						if (strRegexC != null) {
							if (!(strRegexC.equals(""))) {
								if (jchkSearchOpt1.isSelected()) {
									// 啶Əʂ
									patternC = Pattern.compile(strRegexC);
								} else {
									// 啶ƏʂȂ
									patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
								}
								if (jchkSearchOpt2.isSelected()) {
									// sƍs̋󔒂𖳎
									matcherC = patternC.matcher(inString.trim());
								} else {
									// sƍs̋󔒂𖳎Ȃ
									matcherC = patternC.matcher(inString);
								}
							}
						}
						findFlg = 0;
						if (jrdoAnd.isSelected()) {
							// ׂẴL[[h܂
							if (strRegex != null) {
								if (!(strRegex.equals(""))) {
									if (matcher.find()) {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
							} else {
								findFlg = findFlg + 1;
							}
							if (strRegexB != null) {
								if (!(strRegexB.equals(""))) {
									if (matcherB.find()) {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
							} else {
								findFlg = findFlg + 1;
							}
							if (strRegexC != null) {
								if (!(strRegexC.equals(""))) {
									if (matcherC.find()) {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
							} else {
								findFlg = findFlg + 1;
							}
						} else {
							// ꂩ̃L[[h܂
							if (strRegex != null) {
								if (!(strRegex.equals(""))) {
									if (matcher.find()) {
										findFlg = 3;
									}
								}
							}
							if (strRegexB != null) {
								if (!(strRegexB.equals(""))) {
									if (matcherB.find()) {
										findFlg = 3;
									}
								}
							}
							if (strRegexC != null) {
								if (!(strRegexC.equals(""))) {
									if (matcherC.find()) {
										findFlg = 3;
									}
								}
							}
						}
						//if (matcher.find()) {
						if (findFlg == 3) {
							// ̃JEg
							commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
							if (commonProperties.getTextFormat().equals("0")) {
								// 0:HTML`
								if (archiveFileName != null) {
									sb.append(archiveFileName.substring(0,5));
									sb.append("<a href=\"file://");
									sb.append(archiveFileName.substring(5));
									sb.append("\">");
									sb.append(archiveFileName.substring(5));
									sb.append("</a><br>");
									sb.append(System.getProperty("line.separator"));
									sb.append("==> ");
									sb.append("[Word]");
									sb.append(fileName);
									sb.append("<br>");
									sb.append(System.getProperty("line.separator"));
								} else {
									sb.append("[Word]");
									sb.append("<a href=\"file://");
									sb.append(fileName);
									sb.append("\">");
									sb.append(fileName);
									sb.append("</a><br>");
									sb.append(System.getProperty("line.separator"));
								}
								sb.append(Integer.toString(i + 1));
								sb.append(", ");
								sb.append(Integer.toString(j + 1));
								sb.append("i: ");
								sb.append("<br>");
								sb.append(System.getProperty("line.separator"));
								sb.append("<plaintext>");
								sb.append(inString);
								sb.append("</plaintext>");
								sb.append("<br><br>");
								sb.append(System.getProperty("line.separator"));
							} else {
								if (archiveFileName != null) {
									sb.append(archiveFileName);
									sb.append(" ==> ");
								}
								sb.append("[Word]");
								sb.append(fileName);
								sb.append(", ");
								sb.append(Integer.toString(i + 1));
								sb.append(", ");
								sb.append(Integer.toString(j + 1));
								sb.append("i: ");
								sb.append(inString);
								sb.append(System.getProperty("line.separator"));
							}
						}
					}
				}
			}
		} catch(IllegalArgumentException ex1) {
			// WordłȂt@C̊gqudocv̏ꍇ(rtft@C)́AIllegalArgumentException̂ŃX[
		} catch(IOException ex2) {
			// WordłȂt@C̊gqudocv̏ꍇ(eLXgt@C)́AIOException̂ŃX[
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			if (archiveFileName != null) {
				ErrorDialog d = new ErrorDialog(new JFrame(), "t@C:" + archiveFileName + System.getProperty("line.separator") + stringWriter.toString());
			} else {
				ErrorDialog d = new ErrorDialog(new JFrame(), "t@C:" + fileName + System.getProperty("line.separator") + stringWriter.toString());
			}
		}
	}


	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWiooXV|QOORj
	////////////////////////////////////////////////////////////////////////////
	void resultFormatPowerPoint97(StringBuffer sb, String fileName, InputStream inputStream, String archiveFileName) {

		try {
			StringBuffer sbBuf = null;

			// PowerPoint̃t@Cǂݍ
			SlideShow slideShow = null;
			if (archiveFileName != null) {
				slideShow = new SlideShow(inputStream);
			} else {
				slideShow = new SlideShow(new FileInputStream(fileName));
			}
			Slide[] arySlides = slideShow.getSlides();

			for (int i=0; i<arySlides.length; i++) {
				// eLXg̎擾
				TextRun[] aryTextRuns = arySlides[i].getTextRuns();
				for (int j=0; j<aryTextRuns.length; j++) {
					String text = aryTextRuns[j].getText();
					if (text != null) {
						Pattern pattern;
						Pattern patternB;
						Pattern patternC;
						Matcher matcher = null;
						Matcher matcherB = null;
						Matcher matcherC = null;
						String inString;
						String strRegex;
						String strRegexB;
						String strRegexC;
						int findFlg = 0;

						StringReader sr = new StringReader(text);
						BufferedReader br = new BufferedReader(sr);
						while((inString=br.readLine()) != null) { 
							// }b`Oi镶Pj
							strRegex = (String)jcboRegEx.getSelectedItem();
							if (strRegex != null) {
								if (!(strRegex.equals(""))) {
									if (jchkSearchOpt1.isSelected()) {
										// 啶Əʂ
										pattern = Pattern.compile(strRegex);
									} else {
										// 啶ƏʂȂ
										pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
									}
									if (jchkSearchOpt2.isSelected()) {
										// sƍs̋󔒂𖳎
										matcher = pattern.matcher(inString.trim());
									} else {
										// sƍs̋󔒂𖳎Ȃ
										matcher = pattern.matcher(inString);
									}
								}
							}
							// }b`Oi镶Qj
							strRegexB = (String)jcboRegExB.getSelectedItem();
							if (strRegexB != null) {
								if (!(strRegexB.equals(""))) {
									if (jchkSearchOpt1.isSelected()) {
										// 啶Əʂ
										patternB = Pattern.compile(strRegexB);
									} else {
										// 啶ƏʂȂ
										patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
									}
									if (jchkSearchOpt2.isSelected()) {
										// sƍs̋󔒂𖳎
										matcherB = patternB.matcher(inString.trim());
									} else {
										// sƍs̋󔒂𖳎Ȃ
										matcherB = patternB.matcher(inString);
									}
								}
							}
							// }b`Oi镶Rj
							strRegexC = (String)jcboRegExC.getSelectedItem();
							if (strRegexC != null) {
								if (!(strRegexC.equals(""))) {
									if (jchkSearchOpt1.isSelected()) {
										// 啶Əʂ
										patternC = Pattern.compile(strRegexC);
									} else {
										// 啶ƏʂȂ
										patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
									}
									if (jchkSearchOpt2.isSelected()) {
										// sƍs̋󔒂𖳎
										matcherC = patternC.matcher(inString.trim());
									} else {
										// sƍs̋󔒂𖳎Ȃ
										matcherC = patternC.matcher(inString);
									}
								}
							}
							findFlg = 0;
							if (jrdoAnd.isSelected()) {
								// ׂẴL[[h܂
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (matcher.find()) {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (matcherB.find()) {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (matcherC.find()) {
											findFlg = findFlg + 1;
										}
									} else {
										findFlg = findFlg + 1;
									}
								} else {
									findFlg = findFlg + 1;
								}
							} else {
								// ꂩ̃L[[h܂
								if (strRegex != null) {
									if (!(strRegex.equals(""))) {
										if (matcher.find()) {
											findFlg = 3;
										}
									}
								}
								if (strRegexB != null) {
									if (!(strRegexB.equals(""))) {
										if (matcherB.find()) {
											findFlg = 3;
										}
									}
								}
								if (strRegexC != null) {
									if (!(strRegexC.equals(""))) {
										if (matcherC.find()) {
											findFlg = 3;
										}
									}
								}
							}
							//if (matcher.find()) {
							if (findFlg == 3) {
								// ̃JEg
								commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
								if (commonProperties.getTextFormat().equals("0")) {
									// 0:HTML`
									if (archiveFileName != null) {
										sb.append(archiveFileName.substring(0,5));
										sb.append("<a href=\"file://");
										sb.append(archiveFileName.substring(5));
										sb.append("\">");
										sb.append(archiveFileName.substring(5));
										sb.append("</a><br>");
										sb.append(System.getProperty("line.separator"));
										sb.append("==> ");
										sb.append("[PowerPoint]");
										sb.append(fileName);
										sb.append("<br>");
										sb.append(System.getProperty("line.separator"));
									} else {
										sb.append("[PowerPoint]");
										sb.append("<a href=\"file://");
										sb.append(fileName);
										sb.append("\">");
										sb.append(fileName);
										sb.append("</a><br>");
										sb.append(System.getProperty("line.separator"));
									}
									sb.append(Integer.toString(i + 1));
									sb.append("ײ: ");
									sb.append("<br>");
									sb.append(System.getProperty("line.separator"));
									sb.append("<plaintext>");
									sb.append(inString);
									sb.append("</plaintext>");
									sb.append("<br><br>");
									sb.append(System.getProperty("line.separator"));
								} else {
									if (archiveFileName != null) {
										sb.append(archiveFileName);
										sb.append(" ==> ");
									}
									sb.append("[PowerPoint]");
									sb.append(fileName);
									sb.append(", ");
									sb.append(Integer.toString(i + 1));
									sb.append("ײ: ");
									sb.append(inString);
									sb.append(System.getProperty("line.separator"));
								}
							}
						}
					}
				}
				// m[g̎擾
				Notes notes = arySlides[i].getNotesSheet();
				if (notes != null) {
					TextRun[] aryNoteTextRuns = notes.getTextRuns();
					sbBuf = new StringBuffer();
					for (int k=0; k<aryNoteTextRuns.length; k++) {
						String text = aryNoteTextRuns[k].getText();
						sbBuf.append(text);
					}
					if (sbBuf != null) {
						if (sbBuf.toString() != null) {
							if (sbBuf.toString() != "") {
								Pattern pattern;
								Pattern patternB;
								Pattern patternC;
								Matcher matcher = null;
								Matcher matcherB = null;
								Matcher matcherC = null;
								String inString;
								String strRegex;
								String strRegexB;
								String strRegexC;
								int findFlg = 0;

								StringReader sr = new StringReader(sbBuf.toString());
								BufferedReader br = new BufferedReader(sr);
								while((inString=br.readLine()) != null) { 
									// }b`Oi镶Pj
									strRegex = (String)jcboRegEx.getSelectedItem();
									if (strRegex != null) {
										if (!(strRegex.equals(""))) {
											if (jchkSearchOpt1.isSelected()) {
												// 啶Əʂ
												pattern = Pattern.compile(strRegex);
											} else {
												// 啶ƏʂȂ
												pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
											}
											if (jchkSearchOpt2.isSelected()) {
												// sƍs̋󔒂𖳎
												matcher = pattern.matcher(inString.trim());
											} else {
												// sƍs̋󔒂𖳎Ȃ
												matcher = pattern.matcher(inString);
											}
										}
									}
									// }b`Oi镶Qj
									strRegexB = (String)jcboRegExB.getSelectedItem();
									if (strRegexB != null) {
										if (!(strRegexB.equals(""))) {
											if (jchkSearchOpt1.isSelected()) {
												// 啶Əʂ
												patternB = Pattern.compile(strRegexB);
											} else {
												// 啶ƏʂȂ
												patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
											}
											if (jchkSearchOpt2.isSelected()) {
												// sƍs̋󔒂𖳎
												matcherB = patternB.matcher(inString.trim());
											} else {
												// sƍs̋󔒂𖳎Ȃ
												matcherB = patternB.matcher(inString);
											}
										}
									}
									// }b`Oi镶Rj
									strRegexC = (String)jcboRegExC.getSelectedItem();
									if (strRegexC != null) {
										if (!(strRegexC.equals(""))) {
											if (jchkSearchOpt1.isSelected()) {
												// 啶Əʂ
												patternC = Pattern.compile(strRegexC);
											} else {
												// 啶ƏʂȂ
												patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
											}
											if (jchkSearchOpt2.isSelected()) {
												// sƍs̋󔒂𖳎
												matcherC = patternC.matcher(inString.trim());
											} else {
												// sƍs̋󔒂𖳎Ȃ
												matcherC = patternC.matcher(inString);
											}
										}
									}
									findFlg = 0;
									if (jrdoAnd.isSelected()) {
										// ׂẴL[[h܂
										if (strRegex != null) {
											if (!(strRegex.equals(""))) {
												if (matcher.find()) {
													findFlg = findFlg + 1;
												}
											} else {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
										if (strRegexB != null) {
											if (!(strRegexB.equals(""))) {
												if (matcherB.find()) {
													findFlg = findFlg + 1;
												}
											} else {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
										if (strRegexC != null) {
											if (!(strRegexC.equals(""))) {
												if (matcherC.find()) {
													findFlg = findFlg + 1;
												}
											} else {
												findFlg = findFlg + 1;
											}
										} else {
											findFlg = findFlg + 1;
										}
									} else {
										// ꂩ̃L[[h܂
										if (strRegex != null) {
											if (!(strRegex.equals(""))) {
												if (matcher.find()) {
													findFlg = 3;
												}
											}
										}
										if (strRegexB != null) {
											if (!(strRegexB.equals(""))) {
												if (matcherB.find()) {
													findFlg = 3;
												}
											}
										}
										if (strRegexC != null) {
											if (!(strRegexC.equals(""))) {
												if (matcherC.find()) {
													findFlg = 3;
												}
											}
										}
									}
									//if (matcher.find()) {
									if (findFlg == 3) {
										// ̃JEg
										commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
										if (commonProperties.getTextFormat().equals("0")) {
											// 0:HTML`
											if (archiveFileName != null) {
												sb.append(archiveFileName.substring(0,5));
												sb.append("<a href=\"file://");
												sb.append(archiveFileName.substring(5));
												sb.append("\">");
												sb.append(archiveFileName.substring(5));
												sb.append("</a><br>");
												sb.append(System.getProperty("line.separator"));
												sb.append("==> ");
												sb.append("[PowerPoint]");
												sb.append(fileName);
												sb.append("<br>");
												sb.append(System.getProperty("line.separator"));
											} else {
												sb.append("[PowerPoint]");
												sb.append("<a href=\"file://");
												sb.append(fileName);
												sb.append("\">");
												sb.append(fileName);
												sb.append("</a><br>");
												sb.append(System.getProperty("line.separator"));
											}
											sb.append(Integer.toString(i + 1));
											sb.append("ײ: ");
											sb.append("<br>");
											sb.append(System.getProperty("line.separator"));
											sb.append("<plaintext>");
											sb.append(inString);
											sb.append("</plaintext>");
											sb.append("<br><br>");
											sb.append(System.getProperty("line.separator"));
										} else {
											if (archiveFileName != null) {
												sb.append(archiveFileName);
												sb.append(" ==> ");
											}
											sb.append("[PowerPoint]");
											sb.append(fileName);
											sb.append(", ");
											sb.append(Integer.toString(i + 1));
											sb.append("ײ: ");
											sb.append(inString);
											sb.append(System.getProperty("line.separator"));
										}
									}
								}
							}
						}
					}
					sbBuf = null;
				}
			}
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}


	////////////////////////////////////////////////////////////////////////////
	//ʂ̕ҏWiocej
	////////////////////////////////////////////////////////////////////////////
	void resultFormatPdf(StringBuffer sb, String fileName, InputStream inputStream, String archiveFileName) {

		try {
			// PDDocumentIuWFNg쐬
			PDDocument pdfDoc = null;
			if (archiveFileName != null) {
				pdfDoc = PDDocument.load(inputStream);
			} else {
				//pdfDoc = PDDocument.load(new FileInputStream(fileName));
				pdfDoc = PDDocument.load(new File(fileName));
			}
			
			// PDFo[W\
			//System.out.println(pdfDoc.getDocument().getVersion());
			
			// PDDocumentIuWFNgeLXg𒊏o
			PDFTextStripper textStripper = null;
			textStripper = new PDFTextStripper();
			String text = textStripper.getText(pdfDoc);
			
			Pattern pattern;
			Pattern patternB;
			Pattern patternC;
			Matcher matcher = null;
			Matcher matcherB = null;
			Matcher matcherC = null;
			String inString;
			String strRegex;
			String strRegexB;
			String strRegexC;
			int findFlg = 0;

			StringReader sr = new StringReader(text);
			BufferedReader br = new BufferedReader(sr);

			int lineCnt = 0;
			while((inString=br.readLine()) != null) { 

				lineCnt = lineCnt + 1;
				// }b`Oi镶Pj
				strRegex = (String)jcboRegEx.getSelectedItem();
				if (strRegex != null) {
					if (!(strRegex.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							pattern = Pattern.compile(strRegex);
						} else {
							// 啶ƏʂȂ
							pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcher = pattern.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcher = pattern.matcher(inString);
						}
					}
				}
				// }b`Oi镶Qj
				strRegexB = (String)jcboRegExB.getSelectedItem();
				if (strRegexB != null) {
					if (!(strRegexB.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							patternB = Pattern.compile(strRegexB);
						} else {
							// 啶ƏʂȂ
							patternB = Pattern.compile(strRegexB, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcherB = patternB.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcherB = patternB.matcher(inString);
						}
					}
				}
				// }b`Oi镶Rj
				strRegexC = (String)jcboRegExC.getSelectedItem();
				if (strRegexC != null) {
					if (!(strRegexC.equals(""))) {
						if (jchkSearchOpt1.isSelected()) {
							// 啶Əʂ
							patternC = Pattern.compile(strRegexC);
						} else {
							// 啶ƏʂȂ
							patternC = Pattern.compile(strRegexC, Pattern.CASE_INSENSITIVE);
						}
						if (jchkSearchOpt2.isSelected()) {
							// sƍs̋󔒂𖳎
							matcherC = patternC.matcher(inString.trim());
						} else {
							// sƍs̋󔒂𖳎Ȃ
							matcherC = patternC.matcher(inString);
						}
					}
				}
				findFlg = 0;
				if (jrdoAnd.isSelected()) {
					// ׂẴL[[h܂
					if (strRegex != null) {
						if (!(strRegex.equals(""))) {
							if (matcher.find()) {
								findFlg = findFlg + 1;
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
					if (strRegexB != null) {
						if (!(strRegexB.equals(""))) {
							if (matcherB.find()) {
								findFlg = findFlg + 1;
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
					if (strRegexC != null) {
						if (!(strRegexC.equals(""))) {
							if (matcherC.find()) {
								findFlg = findFlg + 1;
							}
						} else {
							findFlg = findFlg + 1;
						}
					} else {
						findFlg = findFlg + 1;
					}
				} else {
					// ꂩ̃L[[h܂
					if (strRegex != null) {
						if (!(strRegex.equals(""))) {
							if (matcher.find()) {
								findFlg = 3;
							}
						}
					}
					if (strRegexB != null) {
						if (!(strRegexB.equals(""))) {
							if (matcherB.find()) {
								findFlg = 3;
							}
						}
					}
					if (strRegexC != null) {
						if (!(strRegexC.equals(""))) {
							if (matcherC.find()) {
								findFlg = 3;
							}
						}
					}
				}
				//if (matcher.find()) {
				if (findFlg == 3) {
					// ̃JEg
					commonProperties.setFindCnt(commonProperties.getFindCnt() + 1);
					if (commonProperties.getTextFormat().equals("0")) {
						// 0:HTML`
						if (archiveFileName != null) {
							sb.append(archiveFileName.substring(0,5));
							sb.append("<a href=\"file://");
							sb.append(archiveFileName.substring(5));
							sb.append("\">");
							sb.append(archiveFileName.substring(5));
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
							sb.append("==> ");
							sb.append("[PDF]");
							sb.append(fileName);
							sb.append("<br>");
							sb.append(System.getProperty("line.separator"));
						} else {
							sb.append("[PDF]");
							sb.append("<a href=\"file://");
							sb.append(fileName);
							sb.append("\">");
							sb.append(fileName);
							sb.append("</a><br>");
							sb.append(System.getProperty("line.separator"));
						}
						sb.append(Integer.toString(lineCnt));
						sb.append(" s: ");
						sb.append("<br>");
						sb.append(System.getProperty("line.separator"));
						sb.append("<plaintext>");
						sb.append(inString);
						sb.append("</plaintext>");
						sb.append("<br><br>");
						sb.append(System.getProperty("line.separator"));
					} else {
						if (archiveFileName != null) {
							sb.append(archiveFileName);
							sb.append(" ==> ");
						}
						sb.append("[PDF]");
						sb.append(fileName);
						sb.append(", ");
						sb.append(Integer.toString(lineCnt));
						sb.append(" s: ");
						sb.append(inString);
						sb.append(System.getProperty("line.separator"));
					}
				}
			}
			pdfDoc.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
	}


	////////////////////////////////////////////////////////////////////////////
	//C[`
	////////////////////////////////////////////////////////////////////////////
	public static void main(String[] args) {
		new JGrepper(args);
	}
}


/******************************************************************************
 *lsbq
 *itH_c[̃ACRʂɐݒ肷j
 ******************************************************************************/
class MyTreeCellRenderer extends DefaultTreeCellRenderer {

	public Component getTreeCellRendererComponent(JTree tree,
												  Object value,
												  boolean selected,
												  boolean expanded,
												  boolean leaf,
												  int row,
												  boolean hasFocus) {
		//܂̓ftHg̃_R|[lgiJLabelj擾
		Component c = super.getTreeCellRendererComponent(tree,
														 value,
														 selected,
														 expanded,
														 leaf,
														 row,
														 hasFocus);
		String strVal = value.toString();
		if (strVal.equals("Rs[^")) {
			ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/icon_monitor_pc.gif"));
			((JLabel)c).setIcon(icon);
		} else if (strVal.length() >= 2) {
			if (strVal.substring(1,2).equals(":")) {
				//ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("Resources/drive.png"));
				ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/folder.gif"));
				((JLabel)c).setIcon(icon);
			} else {
				ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/folder.gif"));
				((JLabel)c).setIcon(icon);
			}
		} else {
			ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("Resources/Images/folder.gif"));
			((JLabel)c).setIcon(icon);
		}
		return c;
	}
}


/******************************************************************************
 *llsm
 *itH_c[JƂ_ł̃tH_̃f[^ǉj
 ******************************************************************************/
class MyMutableTreeNode extends DefaultMutableTreeNode {

	/**
	 * RXgN^[
	 *
	 * @param userObject	m[h̃[U[IuWFNg
	 */
	public MyMutableTreeNode(Object userObject) {
		super(userObject);
	}

	@Override
	public boolean isLeaf() {
		return false;
	}
}


/******************************************************************************
 *tB^ݒ_CAO
 ******************************************************************************/
class FormRange extends JDialog implements ActionListener {

	// t@C
	private JTextField jtxtFile;

	// t@CXg
	private DefaultListModel	model;
	private JList				list;

	// ʃvpeB
	private CommonProperties commonProperties;

	private String strFileList;


	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormRange(JFrame parent, CommonProperties commonProps) {

		super(parent, "tB^ݒ", true);

		commonProperties = commonProps;
		strFileList = "";
		String strFontName = "lr SVbN";

		getContentPane().setSize(500,350);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(500, 350));

		// t@Cixj
		JLabel jlblFile = new JLabel("t@C",JLabel.LEFT);
		jlblFile.setBounds(20,30,100,20);
		jlblFile.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jlblFile.setBorder(new LineBorder(Color.blue, 1, true));

		// t@Ci̓eLXgj
		jtxtFile = new JTextField("");
		jtxtFile.setBounds(125,30,355,20);
		jtxtFile.setFont(new Font(strFontName, Font.PLAIN, 12));

		// (͗)
		JLabel jlblExp = new JLabel("(͗) *.C *.CPP *.H Ȃ...",JLabel.LEFT);
		jlblExp.setBounds(125,53,250,20);
		jlblExp.setFont(new Font(strFontName, Font.PLAIN, 12));
		jlblExp.setForeground(Color.RED);

		// [ǉ]{^
		JButton jbtnApp = new JButton("Xgɒǉ");
		jbtnApp.setBounds(380,55,100,20);
		jbtnApp.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnApp.setMargin(new Insets(0, 0, 0, 0));

		// t@CXg
		model = new DefaultListModel();
		list = new JList(model);
		list.setFont(new Font(strFontName, Font.PLAIN, 12));

		// t@CXgScrollPane
		JScrollPane jscrpaneList = new JScrollPane(list, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		jscrpaneList.setBounds(20,80,460,95);
		jscrpaneList.setFont(new Font(strFontName, Font.PLAIN, 12));

		// [폜]{^
		JButton jbtnDel = new JButton("폜");
		jbtnDel.setBounds(350,180,40,20);
		jbtnDel.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnDel.setMargin(new Insets(0, 0, 0, 0));

		// [Sč폜]{^
		JButton jbtnAllDel = new JButton("Sč폜");
		jbtnAllDel.setBounds(395,180,80,20);
		jbtnAllDel.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnAllDel.setMargin(new Insets(0, 0, 0, 0));

		// [o^]{^
		JButton jbtnOk = new JButton("o^");
		jbtnOk.setBounds(180,300,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));

		//[]{^
		JButton jbtnCan = new JButton("");
		jbtnCan.setBounds(260,300,60,30);
		jbtnCan.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnCan.setMargin(new Insets(0, 0, 0, 0));

		getContentPane().add(jlblFile);
		getContentPane().add(jtxtFile);
		getContentPane().add(jlblExp);
		getContentPane().add(jbtnApp);
		getContentPane().add(jscrpaneList);
		getContentPane().add(jbtnDel);
		getContentPane().add(jbtnAllDel);
		getContentPane().add(jbtnOk);
		getContentPane().add(jbtnCan);

		jbtnApp.setActionCommand("AppClick");
		jbtnApp.addActionListener(this);

		jbtnDel.setActionCommand("DelClick");
		jbtnDel.addActionListener(this);

		jbtnAllDel.setActionCommand("AllDelClick");
		jbtnAllDel.addActionListener(this);

		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		jbtnCan.setActionCommand("CancelClick");
		jbtnCan.addActionListener(this);

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("AppClick")) {
			OnAppClick();
		} else if (cmd.equals("DelClick")) {
			OnDelClick();
		} else if (cmd.equals("AllDelClick")) {
			OnAllDelClick();
		} else if (cmd.equals("OkClick")) {
			OnOkClick();
		} else if (cmd.equals("CancelClick")) {
			OnCancelClick();
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[ǉ]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnAppClick() {
		if (!(jtxtFile.getText().trim().equals(""))) {
			model.addElement(jtxtFile.getText());
			list.ensureIndexIsVisible(model.getSize() - 1);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[폜]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnDelClick() {
		// Xg̑Is폜
		if (!list.isSelectionEmpty()){
			int index = list.getSelectedIndex();
			model.remove(index);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[Sč폜]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnAllDelClick() {
		// XgSs폜
		model.clear();
	}

	////////////////////////////////////////////////////////////////////////////
	//[o^]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnOkClick() {

		if (model.getSize() <= 0) {
			// _CAO\
			setVisible(false);
			return;
		}

		StringBuffer sb = new StringBuffer();
		
		for (int i=0; i<model.getSize(); i++) {
			list.setSelectedIndex(i);
			String val = (String)list.getSelectedValue();
			if (val != null) {
				sb.append(val);
				sb.append(";");
			}
		}
		strFileList = sb.substring(0, sb.length()-1);

		// _CAO\
		setVisible(false);
	}

	////////////////////////////////////////////////////////////////////////////
	//[]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnCancelClick() {

		strFileList = "";

		// _CAO\
		setVisible(false);
	}

	////////////////////////////////////////////////////////////////////////////
	//Xgɒǉt@C̎擾
	////////////////////////////////////////////////////////////////////////////
	public String getFileName() {
		return strFileList;
	}
}


/******************************************************************************
 *K\͕̓⏕_CAO
 ******************************************************************************/
class FormCond extends JDialog implements ActionListener {

	private JTextField jtxtBun1;
	private JTextField jtxtBun2;
	private JTextField jtxtBun3;

	private SpinnerNumberModel	spnMdlN2;
	private JSpinner			jspnN2;
	private SpinnerNumberModel	spnMdlN3;
	private JSpinner			jspnN3;
	private SpinnerNumberModel	spnMdlM3;
	private JSpinner			jspnM3;

	private JComboBox jcboBun1;
	private JComboBox jcboBun2;
	private JComboBox jcboBun3;

	private JTextField jtxtRegex;

	// Xg
	private DefaultListModel	model;
	private JList				list;
	private int					ListMax = 50;

	// ʃvpeB
	private CommonProperties commonProperties;
	// K\
	private String[] aryCond;
	private String[] aryRegex;
	// K\
	private String strRegex;


	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormCond(JFrame parent, CommonProperties commonProps) {

		super(parent, "K\͕̓⏕", true);

		commonProperties = commonProps;
		aryCond = new String[ListMax];
		aryRegex = new String[ListMax];
		strRegex = "";
		String strFontName = "lr SVbN";

		getContentPane().setSize(800,450);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(800, 450));

		// Pixj
		JLabel jlblBun = new JLabel("<<̍쐬>>",JLabel.LEFT);
		jlblBun.setBounds(10,10,160,20);
		jlblBun.setFont(new Font(strFontName, Font.BOLD, 12));
		jlblBun.setForeground(Color.BLUE);

		// Pi̓eLXgj
		jtxtBun1 = new JTextField("");
		jtxtBun1.setBounds(10,35,170,20);
		jtxtBun1.setFont(new Font(strFontName, Font.PLAIN, 12));

		// P⑫
		String[] jcboBun1_items = {"Pȏ܂ށ@@@@@@@@@@@@@     +",
								   "OP܂ށ@@@@@@@@@@@@     ?",
								   "Oȏ܂ށ@@@@@@@@@@@@@     *",
								   "s̐擪Ɉv@@@@@@@@@@     ^",
								   "s̖Ɉv@@@@@@@@@@     $",
								   "̒Ɋ܂܂PɈv@@@@@    []",
								   "̒Ɋ܂܂ȂPɈv@@@@   [^]"
								 };
		jcboBun1 = new JComboBox(jcboBun1_items);
		jcboBun1.setEditable(false);
		jcboBun1.setBounds(180,35,420,20);
		jcboBun1.setFont(new Font(strFontName, Font.PLAIN, 12));

		// [ǉP]{^
		JButton jbtnApp1 = new JButton("Xgɒǉ");
		jbtnApp1.setBounds(600,35,90,20);
		jbtnApp1.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnApp1.setMargin(new Insets(0, 0, 0, 0));
		jbtnApp1.setToolTipText("̏<<Xg>>ɒǉ܂");

		// [eXgP]{^
		//JButton jbtnTest1 = new JButton("eXgs");
		//jbtnTest1.setBounds(690,35,70,20);
		//jbtnTest1.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jbtnTest1.setMargin(new Insets(0, 0, 0, 0));
		//jbtnTest1.setToolTipText("K\̃eXgs܂");

		// Qi̓eLXgj
		jtxtBun2 = new JTextField("");
		jtxtBun2.setBounds(10,62,170,20);
		jtxtBun2.setFont(new Font(strFontName, Font.PLAIN, 12));

		// Q⑫
		String[] jcboBun2_items = {"傤ǂJԂ̂܂ށ@@@   {n}",
								   "ȏJԂ̂܂ށ@@@@@  {n,}"
								 };
		jcboBun2 = new JComboBox(jcboBun2_items);
		jcboBun2.setEditable(false);
		jcboBun2.setBounds(180,62,360,20);
		jcboBun2.setFont(new Font(strFontName, Font.PLAIN, 12));

		// ixj
		JLabel jlblN2 = new JLabel("=",JLabel.RIGHT);
		jlblN2.setBounds(540,62,20,20);
		jlblN2.setFont(new Font(strFontName, Font.PLAIN, 12));

		// iXsi[j
		spnMdlN2 = new SpinnerNumberModel(1, 1, null, 1);
		jspnN2 = new JSpinner(spnMdlN2);
		jspnN2.setBounds(560,62,39,20);
		jspnN2.setFont(new Font(strFontName, Font.PLAIN, 12));

		// [ǉQ]{^
		JButton jbtnApp2 = new JButton("Xgɒǉ");
		jbtnApp2.setBounds(600,62,90,20);
		jbtnApp2.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnApp2.setMargin(new Insets(0, 0, 0, 0));
		jbtnApp2.setToolTipText("̏<<Xg>>ɒǉ܂");

		// [eXgQ]{^
		//JButton jbtnTest2 = new JButton("eXgs");
		//jbtnTest2.setBounds(690,62,70,20);
		//jbtnTest2.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jbtnTest2.setMargin(new Insets(0, 0, 0, 0));
		//jbtnTest2.setToolTipText("K\̃eXgs܂");

		// Ri̓eLXgj
		jtxtBun3 = new JTextField("");
		jtxtBun3.setBounds(10,89,170,20);
		jtxtBun3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// R⑫
		String[] jcboBun3_items = {"ȏろȉJԂ̂܂ށ@ {n,m}"
								 };
		jcboBun3 = new JComboBox(jcboBun3_items);
		jcboBun3.setEditable(false);
		jcboBun3.setBounds(180,89,302,20);
		jcboBun3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// ixj
		JLabel jlblN3 = new JLabel("=",JLabel.RIGHT);
		jlblN3.setBounds(480,89,20,20);
		jlblN3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// iXsi[j
		spnMdlN3 = new SpinnerNumberModel(1, 1, null, 1);
		jspnN3 = new JSpinner(spnMdlN3);
		jspnN3.setBounds(500,89,39,20);
		jspnN3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// ixj
		JLabel jlblM3 = new JLabel("=",JLabel.RIGHT);
		jlblM3.setBounds(540,89,20,20);
		jlblM3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// iXsi[j
		spnMdlM3 = new SpinnerNumberModel(1, 1, null, 1);
		jspnM3 = new JSpinner(spnMdlM3);
		jspnM3.setBounds(560,89,39,20);
		jspnM3.setFont(new Font(strFontName, Font.PLAIN, 12));

		// [ǉR]{^
		JButton jbtnApp3 = new JButton("Xgɒǉ");
		jbtnApp3.setBounds(600,89,90,20);
		jbtnApp3.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnApp3.setMargin(new Insets(0, 0, 0, 0));
		jbtnApp3.setToolTipText("̏<<Xg>>ɒǉ܂");

		// [eXgR]{^
		//JButton jbtnTest3 = new JButton("eXgs");
		//jbtnTest3.setBounds(690,89,70,20);
		//jbtnTest3.setFont(new Font(strFontName, Font.PLAIN, 12));
		//jbtnTest3.setMargin(new Insets(0, 0, 0, 0));
		//jbtnTest3.setToolTipText("K\̃eXgs܂");

		// Xgixj
		JLabel jlblSiki = new JLabel("<<Xg>>",JLabel.LEFT);
		jlblSiki.setBounds(10,120,160,20);
		jlblSiki.setFont(new Font(strFontName, Font.BOLD, 12));
		jlblSiki.setForeground(Color.BLUE);

		// Xg
		model = new DefaultListModel();
		list = new JList(model);
		list.setFont(new Font(strFontName, Font.PLAIN, 12));

		// XgScrollPane
		JScrollPane jscrpaneList = new JScrollPane(list, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		jscrpaneList.setBounds(10,145,680,125);
		jscrpaneList.setFont(new Font(strFontName, Font.PLAIN, 12));

		// [i]{^
		JButton jbtnGrp1 = new JButton("(");
		jbtnGrp1.setBounds(690,145,30,20);
		jbtnGrp1.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnGrp1.setMargin(new Insets(0, 0, 0, 0));
		jbtnGrp1.setToolTipText("O[vJn");

		// [j]{^
		JButton jbtnGrp2 = new JButton(")");
		jbtnGrp2.setBounds(690,165,30,20);
		jbtnGrp2.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnGrp2.setMargin(new Insets(0, 0, 0, 0));
		jbtnGrp2.setToolTipText("O[vI");

		// [OR]{^
		JButton jbtnOr = new JButton("b");
		jbtnOr.setBounds(690,185,30,20);
		jbtnOr.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOr.setMargin(new Insets(0, 0, 0, 0));
		jbtnOr.setToolTipText("܂");

		// [폜]{^
		JButton jbtnDel = new JButton("폜");
		jbtnDel.setBounds(560,280,40,20);
		jbtnDel.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnDel.setMargin(new Insets(0, 0, 0, 0));
		jbtnDel.setToolTipText("Xg̑Is폜܂");

		// [Sč폜]{^
		JButton jbtnAllDel = new JButton("Sč폜");
		jbtnAllDel.setBounds(610,280,80,20);
		jbtnAllDel.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnAllDel.setMargin(new Insets(0, 0, 0, 0));
		jbtnAllDel.setToolTipText("Xg̑SĂ̍s폜܂");


		// K\vr[ixj
		JLabel jlblRegex = new JLabel("<<K\vr[>>",JLabel.LEFT);
		jlblRegex.setBounds(10,310,220,20);
		jlblRegex.setFont(new Font(strFontName, Font.BOLD, 12));
		jlblRegex.setForeground(Color.BLUE);

		// K\vr[i̓eLXgj
		jtxtRegex = new JTextField("");
		jtxtRegex.setBounds(10,335,680,20);
		jtxtRegex.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtRegex.setEditable(false);


		// [o^]{^
		JButton jbtnOk = new JButton("o^");
		jbtnOk.setBounds(330,400,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));

		//[]{^
		JButton jbtnCan = new JButton("");
		jbtnCan.setBounds(410,400,60,30);
		jbtnCan.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnCan.setMargin(new Insets(0, 0, 0, 0));

		getContentPane().add(jlblBun);
		getContentPane().add(jtxtBun1);
		getContentPane().add(jcboBun1);
		getContentPane().add(jbtnApp1);
		//getContentPane().add(jbtnTest1);
		getContentPane().add(jtxtBun2);
		getContentPane().add(jcboBun2);
		getContentPane().add(jlblN2);
		getContentPane().add(jspnN2);
		getContentPane().add(jbtnApp2);
		//getContentPane().add(jbtnTest2);
		getContentPane().add(jtxtBun3);
		getContentPane().add(jcboBun3);
		getContentPane().add(jlblN3);
		getContentPane().add(jspnN3);
		getContentPane().add(jlblM3);
		getContentPane().add(jspnM3);
		getContentPane().add(jbtnApp3);
		//getContentPane().add(jbtnTest3);
		getContentPane().add(jlblSiki);
		getContentPane().add(jscrpaneList);
		getContentPane().add(jbtnGrp1);
		getContentPane().add(jbtnGrp2);
		getContentPane().add(jbtnOr);
		getContentPane().add(jbtnDel);
		getContentPane().add(jbtnAllDel);
		getContentPane().add(jlblRegex);
		getContentPane().add(jtxtRegex);
		getContentPane().add(jbtnOk);
		getContentPane().add(jbtnCan);

		jbtnApp1.setActionCommand("App1Click");
		jbtnApp1.addActionListener(this);

		//jbtnTest1.setActionCommand("Test1Click");
		//jbtnTest1.addActionListener(this);

		jbtnApp2.setActionCommand("App2Click");
		jbtnApp2.addActionListener(this);

		//jbtnTest2.setActionCommand("Test2Click");
		//jbtnTest2.addActionListener(this);

		jbtnApp3.setActionCommand("App3Click");
		jbtnApp3.addActionListener(this);

		//jbtnTest3.setActionCommand("Test3Click");
		//jbtnTest3.addActionListener(this);

		jbtnGrp1.setActionCommand("Grp1Click");
		jbtnGrp1.addActionListener(this);

		jbtnGrp2.setActionCommand("Grp2Click");
		jbtnGrp2.addActionListener(this);

		jbtnOr.setActionCommand("OrClick");
		jbtnOr.addActionListener(this);

		jbtnDel.setActionCommand("DelClick");
		jbtnDel.addActionListener(this);

		jbtnAllDel.setActionCommand("AllDelClick");
		jbtnAllDel.addActionListener(this);

		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		jbtnCan.setActionCommand("CancelClick");
		jbtnCan.addActionListener(this);

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//K\̕ҏW
	////////////////////////////////////////////////////////////////////////////
	void editRegex(String targetCmd, int targetIdx, String targetCond, String targetRegex) {

		if (targetCmd.equals("append")) {
			aryCond[targetIdx]  = targetCond;
			aryRegex[targetIdx] = targetRegex;
		} else if (targetCmd.equals("delete")) {
			aryCond[targetIdx]  = "";
			aryRegex[targetIdx] = "";
			for (int i=targetIdx+1; i<ListMax; i++) {
				aryCond[i-1]  = aryCond[i];
				aryRegex[i-1] = aryRegex[i];
			}
			aryCond[ListMax - 1]  = null;
			aryRegex[ListMax - 1] = null;
		} else if (targetCmd.equals("alldelete")) {
			aryCond = null;
			aryRegex = null;
			aryCond = new String[ListMax];
			aryRegex = new String[ListMax];
		}
		strRegex = "";
		for (int i=0; i<ListMax; i++) {
			if (aryRegex[i] != null) {
				strRegex = strRegex + aryRegex[i];
			}
		}
		jtxtRegex.setText(strRegex);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("App1Click")) {
			OnApp1Click();
		} else if (cmd.equals("App2Click")) {
			OnApp2Click();
		} else if (cmd.equals("App3Click")) {
			OnApp3Click();
		//} else if (cmd.equals("Test1Click")) {
		//	OnTest1Click();
		//} else if (cmd.equals("Test2Click")) {
		//	OnTest2Click();
		//} else if (cmd.equals("Test3Click")) {
		//	OnTest3Click();
		} else if (cmd.equals("Grp1Click")) {
			OnGrp1Click();
		} else if (cmd.equals("Grp2Click")) {
			OnGrp2Click();
		} else if (cmd.equals("OrClick")) {
			OnOrClick();
		} else if (cmd.equals("DelClick")) {
			OnDelClick();
		} else if (cmd.equals("AllDelClick")) {
			OnAllDelClick();
		} else if (cmd.equals("OkClick")) {
			OnOkClick();
		} else if (cmd.equals("CancelClick")) {
			OnCancelClick();
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[ǉP]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnApp1Click() {
		if (!(jtxtBun1.getText().trim().equals(""))) {
			if (model.getSize() < ListMax) {
				String strBun = (String)jcboBun1.getSelectedItem();
				String strVar = "u" + jtxtBun1.getText() + "v" + strBun;
				model.addElement(strVar);
				list.ensureIndexIsVisible(model.getSize() - 1);
				
				String strVar2 = "";
				int idx = strVar.lastIndexOf(" ");
				if (strVar.substring(idx).trim().equals("+")) {
					strVar2 = jtxtBun1.getText() + "+";
				} else if (strVar.substring(idx).trim().equals("?")) {
					strVar2 = jtxtBun1.getText() + "?";
				} else if (strVar.substring(idx).trim().equals("*")) {
					strVar2 = jtxtBun1.getText() + "*";
				} else if (strVar.substring(idx).trim().equals("^")) {
					strVar2 = "^" + jtxtBun1.getText();
				} else if (strVar.substring(idx).trim().equals("$")) {
					strVar2 = jtxtBun1.getText() + "$";
				} else if (strVar.substring(idx).trim().equals("[]")) {
					strVar2 = "[" + jtxtBun1.getText() + "]";
				} else if (strVar.substring(idx).trim().equals("[^]")) {
					strVar2 = "[^" + jtxtBun1.getText() + "]";
				}
				editRegex("append", (model.getSize() - 1), strVar, strVar2);
			} else {
				JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[ǉQ]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnApp2Click() {
		if (!(jtxtBun2.getText().trim().equals(""))) {
			if (model.getSize() < ListMax) {
				String strBun = (String)jcboBun2.getSelectedItem();
				Integer N2 = (Integer)spnMdlN2.getValue();
				strBun = strBun.replaceAll("+", String.valueOf(N2));
				String strVar = "u" + jtxtBun2.getText() + "v" + strBun;
				model.addElement(strVar);
				list.ensureIndexIsVisible(model.getSize() - 1);

				String strVar2 = "";
				int idx = strVar.lastIndexOf(" ");
				if (strVar.substring(idx).trim().equals("{n}")) {
					strVar2 = "(" + jtxtBun2.getText() + ")" + "{" + String.valueOf(N2) + "}";
				} else if (strVar.substring(idx).trim().equals("{n,}")) {
					strVar2 = "(" + jtxtBun2.getText() + ")" + "{" + String.valueOf(N2) + ",}";
				}
				editRegex("append", (model.getSize() - 1), strVar, strVar2);
			} else {
				JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[ǉR]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnApp3Click() {
		if (!(jtxtBun3.getText().trim().equals(""))) {
			if (model.getSize() < ListMax) {
				String strBun = (String)jcboBun3.getSelectedItem();
				Integer N3 = (Integer)spnMdlN3.getValue();
				Integer M3 = (Integer)spnMdlM3.getValue();
				strBun = strBun.replaceAll("+", String.valueOf(N3));
				strBun = strBun.replaceAll("+", String.valueOf(M3));
				String strVar = "u" + jtxtBun3.getText() + "v" + strBun;
				model.addElement(strVar);
				list.ensureIndexIsVisible(model.getSize() - 1);

				String strVar2 = "";
				strVar2 = jtxtBun3.getText() + "{" + String.valueOf(N3) + "," + String.valueOf(M3) + "}";
				editRegex("append", (model.getSize() - 1), strVar, strVar2);
			} else {
				JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[eXgP]{^NbN
	////////////////////////////////////////////////////////////////////////////
	//void OnTest1Click() {
	//	if (!(jtxtBun1.getText().trim().equals(""))) {
	//	}
	//}

	////////////////////////////////////////////////////////////////////////////
	//[eXgQ]{^NbN
	////////////////////////////////////////////////////////////////////////////
	//void OnTest2Click() {
	//	if (!(jtxtBun2.getText().trim().equals(""))) {
	//	}
	//}

	////////////////////////////////////////////////////////////////////////////
	//[eXgR]{^NbN
	////////////////////////////////////////////////////////////////////////////
	//void OnTest3Click() {
	//	if (!(jtxtBun3.getText().trim().equals(""))) {
	//	}
	//}

	////////////////////////////////////////////////////////////////////////////
	//[iFO[vJn]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnGrp1Click() {
		if (model.getSize() < ListMax) {
			String strVar = "i";
			model.addElement(strVar);
			list.ensureIndexIsVisible(model.getSize() - 1);

			editRegex("append", (model.getSize() - 1), "i", "(");
		} else {
			JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[jFO[vI]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnGrp2Click() {
		if (model.getSize() < ListMax) {
			String strVar = "j";
			model.addElement(strVar);
			list.ensureIndexIsVisible(model.getSize() - 1);

			editRegex("append", (model.getSize() - 1), "j", ")");
		} else {
			JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[bF܂]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnOrClick() {
		if (model.getSize() < ListMax) {
			String strVar = "b";
			model.addElement(strVar);
			list.ensureIndexIsVisible(model.getSize() - 1);

			editRegex("append", (model.getSize() - 1), "b", "|");
		} else {
			JOptionPane.showMessageDialog(this, "Xg̍ڐTO𒴂܂B" + System.getProperty("line.separator") + "ȏAXgɒǉł܂B", "xbZ[W", JOptionPane.WARNING_MESSAGE);
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[폜]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnDelClick() {
		// Xg̑Is폜
		if (!list.isSelectionEmpty()){
			int index = list.getSelectedIndex();
			model.remove(index);
			editRegex("delete", index, "", "");
		}
	}

	////////////////////////////////////////////////////////////////////////////
	//[Sč폜]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnAllDelClick() {
		// XgSs폜
		model.clear();
		editRegex("alldelete", 0, "", "");
	}

	////////////////////////////////////////////////////////////////////////////
	//[o^]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnOkClick() {
		// _CAO\
		setVisible(false);
	}

	////////////////////////////////////////////////////////////////////////////
	//[]{^NbN
	////////////////////////////////////////////////////////////////////////////
	void OnCancelClick() {
		strRegex = "";
		// _CAO\
		setVisible(false);
	}

	////////////////////////////////////////////////////////////////////////////
	//K\̎擾
	////////////////////////////////////////////////////////////////////////////
	public String getRegex() {
		return strRegex;
	}
}


/******************************************************************************
 *[wv]-[JGrepperɂ]
 ******************************************************************************/
class FormAbout extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormAbout(JFrame parent) {

		super(parent, "JGrepperɂ", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(550,500);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(550, 500));

		// eLXg
		JTextArea jtxtGpl = new JTextArea();
		jtxtGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneGpl = new JScrollPane(jtxtGpl, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneGpl.setBounds(0,0,550,450);
		scrollpaneGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtGpl.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(245,460,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneGpl);
		getContentPane().add(jbtnOk);

		try {
			InputStream is = getClass().getClassLoader().getResourceAsStream("Resources/Doc/ReadMe.txt");
			//BufferedReader br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			jtxtGpl.read(br, null);
			is.close();
			br.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *[wv]-[GNU General Public License version 3 (GPLv3)]
 ******************************************************************************/
class FormAboutGpl extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormAboutGpl(JFrame parent) {

		super(parent, "GNU General Public License version 3 (GPLv3)", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(550,500);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(550, 500));

		// eLXg
		JTextArea jtxtGpl = new JTextArea();
		jtxtGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneGpl = new JScrollPane(jtxtGpl, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneGpl.setBounds(0,0,550,450);
		scrollpaneGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtGpl.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(245,460,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneGpl);
		getContentPane().add(jbtnOk);

		try {
			InputStream is = getClass().getClassLoader().getResourceAsStream("Resources/Doc/gpl-3.0.txt");
			//BufferedReader br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			jtxtGpl.read(br, null);
			is.close();
			br.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *[wv]-[Apache License Version 2.0]
 ******************************************************************************/
class FormAboutAsf extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormAboutAsf(JFrame parent) {

		super(parent, "Apache License Version 2.0", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(550,500);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(550, 500));

		// eLXg
		JTextArea jtxtGpl = new JTextArea();
		jtxtGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneGpl = new JScrollPane(jtxtGpl, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneGpl.setBounds(0,0,550,450);
		scrollpaneGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtGpl.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(245,460,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneGpl);
		getContentPane().add(jbtnOk);

		try {
			InputStream is = getClass().getClassLoader().getResourceAsStream("Resources/Doc/LICENSE-2.0.txt");
			//BufferedReader br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			jtxtGpl.read(br, null);
			is.close();
			br.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *[wv]-[The Legion of the Bouncy Castle (MIT License)]
 ******************************************************************************/
class FormAboutBouncyCastle extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormAboutBouncyCastle(JFrame parent) {

		super(parent, "The Legion of the Bouncy Castle (MIT License)", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(650,500);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(650, 500));

		// eLXg
		JTextArea jtxtGpl = new JTextArea();
		jtxtGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneGpl = new JScrollPane(jtxtGpl, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneGpl.setBounds(0,0,650,450);
		scrollpaneGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtGpl.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(295,460,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneGpl);
		getContentPane().add(jbtnOk);

		try {
			InputStream is = getClass().getClassLoader().getResourceAsStream("Resources/Doc/LICENSE-TheLegionOfTheBouncyCastle.txt");
			//BufferedReader br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			jtxtGpl.read(br, null);
			is.close();
			br.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *[wv]-[NOTICE]
 ******************************************************************************/
class FormNOTICE extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public FormNOTICE(JFrame parent) {

		super(parent, "NOTICE", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(550,500);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(550, 500));

		// eLXg
		JTextArea jtxtGpl = new JTextArea();
		jtxtGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneGpl = new JScrollPane(jtxtGpl, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneGpl.setBounds(0,0,550,450);
		scrollpaneGpl.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtGpl.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(245,460,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneGpl);
		getContentPane().add(jbtnOk);

		try {
			InputStream is = getClass().getClassLoader().getResourceAsStream("Resources/Doc/NOTICE.txt");
			//BufferedReader br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			jtxtGpl.read(br, null);
			is.close();
			br.close();
		} catch(Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *G[_CAO\
 ******************************************************************************/
class ErrorDialog extends JDialog implements ActionListener {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	public ErrorDialog(JFrame parent, String mes) {

		super(parent, "ERROR!!", true);

		String strFontName = "lr SVbN";

		getContentPane().setSize(550,300);
		getContentPane().setLayout(null);
		getContentPane().setPreferredSize(new Dimension(550, 300));

		// eLXg
		JTextArea jtxtMes = new JTextArea();
		jtxtMes.setFont(new Font(strFontName, Font.PLAIN, 12));
		JScrollPane scrollpaneMes = new JScrollPane(jtxtMes, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollpaneMes.setBounds(0,0,550,250);
		scrollpaneMes.setFont(new Font(strFontName, Font.PLAIN, 12));
		jtxtMes.setEditable(false);

		// [nj]{^
		JButton jbtnOk = new JButton("OK");
		jbtnOk.setBounds(245,260,60,30);
		jbtnOk.setFont(new Font(strFontName, Font.PLAIN, 12));
		jbtnOk.setMargin(new Insets(0, 0, 0, 0));
		jbtnOk.setActionCommand("OkClick");
		jbtnOk.addActionListener(this);

		getContentPane().add(scrollpaneMes);
		getContentPane().add(jbtnOk);

		jtxtMes.setText(mes);

		pack();

		// t[XN[ɕ\
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(((screen.width - getSize().width) / 2),
					((screen.height - getSize().height) / 2));

		setVisible(true);
	}

	////////////////////////////////////////////////////////////////////////////
	//Cxg
	////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent ae) {

		String cmd = ae.getActionCommand();

		if (cmd.equals("OkClick")) {
			// _CAO\
			setVisible(false);
		}
	}
}


/******************************************************************************
 *ʃvpeB
 ******************************************************************************/
class CommonProperties {

	private String fontName;		// tHg
	private String fontSize;		// tHgTCY
	private String[] fileName;		// t@C
	private String[] folderPath;	// tH_
	private String subFolder;		// TutH_i0:ȂA1:j
	private String archive;			// kt@C̒gi0:ȂA1:j
	private String encode;			// GR[h
	private String[] regEx;			// K\P
	private String[] regExB;		// K\Q
	private String[] regExC;		// K\R
	private String regExAndOr;		// K\`^ni0:ׂẴL[[h܂ށA1:ꂩ̃L[[h܂ށj
	private String caseInsensitive;	// 啶Əʂi0:ʂȂA1:ʂj
	private String trim;			// sƍs̋󔒂𖳎i0:ȂA1:j
	private String textFormat;		// \`i0:HTML`A1:Gی`A2:TNGfB^`j
	private int findCnt;			// ʌ

	////////////////////////////////////////////////////////////////////////////
	//vpeB̑SNA
	////////////////////////////////////////////////////////////////////////////
	public void clear() {
		this.fontName = null;
		this.fontSize = null;
		this.fileName = null;
		this.folderPath = null;
		this.subFolder = null;
		this.archive = null;
		this.encode = null;
		this.regEx = null;
		this.regExB = null;
		this.regExC = null;
		this.regExAndOr = null;
		this.caseInsensitive = null;
		this.trim = null;
		this.textFormat = null;
		this.findCnt = 0;
		return;
	}

	// tHg̎擾
	public String getFontName() {
		return fontName;
	}
	// tHg̐ݒ
	public void setFontName(String fontName) {
		this.fontName = fontName;
	}

	// tHgTCY̎擾
	public String getFontSize() {
		return fontSize;
	}
	// tHgTCY̐ݒ
	public void setFontSize(String fontSize) {
		this.fontSize = fontSize;
	}

	// t@C̎擾
	public String[] getFileName() {
		return fileName;
	}
	// t@C̐ݒ
	public void setFileName(String[] fileName) {
		this.fileName = fileName;
	}

	// tH_̎擾
	public String[] getFolderPath() {
		return folderPath;
	}
	// tH_̐ݒ
	public void setFolderPath(String[] folderPath) {
		this.folderPath = folderPath;
	}

	// TutH_L̎擾
	public String getSubFolder() {
		return subFolder;
	}
	// TutH_L̐ݒ
	public void setSubFolder(String subFolder) {
		this.subFolder = subFolder;
	}

	// kt@CL̎擾
	public String getArchive() {
		return archive;
	}
	// kt@CL̐ݒ
	public void setArchive(String archive) {
		this.archive = archive;
	}

	// GR[h̎擾
	public String getEncode() {
		return encode;
	}
	// GR[h̐ݒ
	public void setEncode(String encode) {
		this.encode = encode;
	}

	// K\P̎擾
	public String[] getRegEx() {
		return regEx;
	}
	// K\P̐ݒ
	public void setRegEx(String[] regEx) {
		this.regEx = regEx;
	}

	// K\Q̎擾
	public String[] getRegExB() {
		return regExB;
	}
	// K\Q̐ݒ
	public void setRegExB(String[] regExB) {
		this.regExB = regExB;
	}

	// K\R̎擾
	public String[] getRegExC() {
		return regExC;
	}
	// K\R̐ݒ
	public void setRegExC(String[] regExC) {
		this.regExC = regExC;
	}

	// K\`^n̎擾
	public String getRegExAndOr() {
		return regExAndOr;
	}
	// K\`^n̐ݒ
	public void setRegExAndOr(String regExAndOr) {
		this.regExAndOr = regExAndOr;
	}

	// 啶ʂ̎擾
	public String getCaseInsensitive() {
		return caseInsensitive;
	}
	// 啶ʂ̐ݒ
	public void setCaseInsensitive(String caseInsensitive) {
		this.caseInsensitive = caseInsensitive;
	}

	// ss󔒖̎擾
	public String getTrim() {
		return trim;
	}
	// ss󔒖̐ݒ
	public void setTrim(String trim) {
		this.trim = trim;
	}

	// \`̎擾
	public String getTextFormat() {
		return textFormat;
	}
	// \`̐ݒ
	public void setTextFormat(String textFormat) {
		this.textFormat = textFormat;
	}

	// ʌ̎擾
	public int getFindCnt() {
		return findCnt;
	}
	// ʌ̐ݒ
	public void setFindCnt(int findCnt) {
		this.findCnt = findCnt;
	}

}

/******************************************************************************
 *vpeBt@C̏
 ******************************************************************************/
class SetProperties {

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	SetProperties(CommonProperties commonProp) {
		try {
			Properties prop = new Properties();

			// tHg
			prop.setProperty("jgrepper.opt00_fontname", commonProp.getFontName());
			// tHgTCY
			prop.setProperty("jgrepper.opt00_fontsize", commonProp.getFontSize());
			// t@C
			String[] aryFileName = commonProp.getFileName();
			if (aryFileName == null) {
				prop.setProperty("jgrepper.filename01", "");
				prop.setProperty("jgrepper.filename02", "");
				prop.setProperty("jgrepper.filename03", "");
				prop.setProperty("jgrepper.filename04", "");
				prop.setProperty("jgrepper.filename05", "");
				prop.setProperty("jgrepper.filename06", "");
				prop.setProperty("jgrepper.filename07", "");
				prop.setProperty("jgrepper.filename08", "");
				prop.setProperty("jgrepper.filename09", "");
				prop.setProperty("jgrepper.filename10", "");
				prop.setProperty("jgrepper.filename11", "");
				prop.setProperty("jgrepper.filename12", "");
				prop.setProperty("jgrepper.filename13", "");
				prop.setProperty("jgrepper.filename14", "");
				prop.setProperty("jgrepper.filename15", "");
				prop.setProperty("jgrepper.filename16", "");
				prop.setProperty("jgrepper.filename17", "");
				prop.setProperty("jgrepper.filename18", "");
				prop.setProperty("jgrepper.filename19", "");
				prop.setProperty("jgrepper.filename20", "");
			} else {
				if (aryFileName[0] == null) {
					prop.setProperty("jgrepper.filename01", "");
				} else {
					prop.setProperty("jgrepper.filename01", aryFileName[0]);
				}
				if (aryFileName[1] == null) {
					prop.setProperty("jgrepper.filename02", "");
				} else {
					prop.setProperty("jgrepper.filename02", aryFileName[1]);
				}
				if (aryFileName[2] == null) {
					prop.setProperty("jgrepper.filename03", "");
				} else {
					prop.setProperty("jgrepper.filename03", aryFileName[2]);
				}
				if (aryFileName[3] == null) {
					prop.setProperty("jgrepper.filename04", "");
				} else {
					prop.setProperty("jgrepper.filename04", aryFileName[3]);
				}
				if (aryFileName[4] == null) {
					prop.setProperty("jgrepper.filename05", "");
				} else {
					prop.setProperty("jgrepper.filename05", aryFileName[4]);
				}
				if (aryFileName[5] == null) {
					prop.setProperty("jgrepper.filename06", "");
				} else {
					prop.setProperty("jgrepper.filename06", aryFileName[5]);
				}
				if (aryFileName[6] == null) {
					prop.setProperty("jgrepper.filename07", "");
				} else {
					prop.setProperty("jgrepper.filename07", aryFileName[6]);
				}
				if (aryFileName[7] == null) {
					prop.setProperty("jgrepper.filename08", "");
				} else {
					prop.setProperty("jgrepper.filename08", aryFileName[7]);
				}
				if (aryFileName[8] == null) {
					prop.setProperty("jgrepper.filename09", "");
				} else {
					prop.setProperty("jgrepper.filename09", aryFileName[8]);
				}
				if (aryFileName[9] == null) {
					prop.setProperty("jgrepper.filename10", "");
				} else {
					prop.setProperty("jgrepper.filename10", aryFileName[9]);
				}
				if (aryFileName[10] == null) {
					prop.setProperty("jgrepper.filename11", "");
				} else {
					prop.setProperty("jgrepper.filename11", aryFileName[10]);
				}
				if (aryFileName[11] == null) {
					prop.setProperty("jgrepper.filename12", "");
				} else {
					prop.setProperty("jgrepper.filename12", aryFileName[11]);
				}
				if (aryFileName[12] == null) {
					prop.setProperty("jgrepper.filename13", "");
				} else {
					prop.setProperty("jgrepper.filename13", aryFileName[12]);
				}
				if (aryFileName[13] == null) {
					prop.setProperty("jgrepper.filename14", "");
				} else {
					prop.setProperty("jgrepper.filename14", aryFileName[13]);
				}
				if (aryFileName[14] == null) {
					prop.setProperty("jgrepper.filename15", "");
				} else {
					prop.setProperty("jgrepper.filename15", aryFileName[14]);
				}
				if (aryFileName[15] == null) {
					prop.setProperty("jgrepper.filename16", "");
				} else {
					prop.setProperty("jgrepper.filename16", aryFileName[15]);
				}
				if (aryFileName[16] == null) {
					prop.setProperty("jgrepper.filename17", "");
				} else {
					prop.setProperty("jgrepper.filename17", aryFileName[16]);
				}
				if (aryFileName[17] == null) {
					prop.setProperty("jgrepper.filename18", "");
				} else {
					prop.setProperty("jgrepper.filename18", aryFileName[17]);
				}
				if (aryFileName[18] == null) {
					prop.setProperty("jgrepper.filename19", "");
				} else {
					prop.setProperty("jgrepper.filename19", aryFileName[18]);
				}
				if (aryFileName[19] == null) {
					prop.setProperty("jgrepper.filename20", "");
				} else {
					prop.setProperty("jgrepper.filename20", aryFileName[19]);
				}
			}
			// tH_
			String[] aryFolderPath = commonProp.getFolderPath();
			if (aryFolderPath == null) {
				prop.setProperty("jgrepper.folderpath01", "");
				prop.setProperty("jgrepper.folderpath02", "");
				prop.setProperty("jgrepper.folderpath03", "");
				prop.setProperty("jgrepper.folderpath04", "");
				prop.setProperty("jgrepper.folderpath05", "");
				prop.setProperty("jgrepper.folderpath06", "");
				prop.setProperty("jgrepper.folderpath07", "");
				prop.setProperty("jgrepper.folderpath08", "");
				prop.setProperty("jgrepper.folderpath09", "");
				prop.setProperty("jgrepper.folderpath10", "");
				prop.setProperty("jgrepper.folderpath11", "");
				prop.setProperty("jgrepper.folderpath12", "");
				prop.setProperty("jgrepper.folderpath13", "");
				prop.setProperty("jgrepper.folderpath14", "");
				prop.setProperty("jgrepper.folderpath15", "");
				prop.setProperty("jgrepper.folderpath16", "");
				prop.setProperty("jgrepper.folderpath17", "");
				prop.setProperty("jgrepper.folderpath18", "");
				prop.setProperty("jgrepper.folderpath19", "");
				prop.setProperty("jgrepper.folderpath20", "");
			} else {
				if (aryFolderPath[0] == null) {
					prop.setProperty("jgrepper.folderpath01", "");
				} else {
					prop.setProperty("jgrepper.folderpath01", aryFolderPath[0]);
				}
				if (aryFolderPath[1] == null) {
					prop.setProperty("jgrepper.folderpath02", "");
				} else {
					prop.setProperty("jgrepper.folderpath02", aryFolderPath[1]);
				}
				if (aryFolderPath[2] == null) {
					prop.setProperty("jgrepper.folderpath03", "");
				} else {
					prop.setProperty("jgrepper.folderpath03", aryFolderPath[2]);
				}
				if (aryFolderPath[3] == null) {
					prop.setProperty("jgrepper.folderpath04", "");
				} else {
					prop.setProperty("jgrepper.folderpath04", aryFolderPath[3]);
				}
				if (aryFolderPath[4] == null) {
					prop.setProperty("jgrepper.folderpath05", "");
				} else {
					prop.setProperty("jgrepper.folderpath05", aryFolderPath[4]);
				}
				if (aryFolderPath[5] == null) {
					prop.setProperty("jgrepper.folderpath06", "");
				} else {
					prop.setProperty("jgrepper.folderpath06", aryFolderPath[5]);
				}
				if (aryFolderPath[6] == null) {
					prop.setProperty("jgrepper.folderpath07", "");
				} else {
					prop.setProperty("jgrepper.folderpath07", aryFolderPath[6]);
				}
				if (aryFolderPath[7] == null) {
					prop.setProperty("jgrepper.folderpath08", "");
				} else {
					prop.setProperty("jgrepper.folderpath08", aryFolderPath[7]);
				}
				if (aryFolderPath[8] == null) {
					prop.setProperty("jgrepper.folderpath09", "");
				} else {
					prop.setProperty("jgrepper.folderpath09", aryFolderPath[8]);
				}
				if (aryFolderPath[9] == null) {
					prop.setProperty("jgrepper.folderpath10", "");
				} else {
					prop.setProperty("jgrepper.folderpath10", aryFolderPath[9]);
				}
				if (aryFolderPath[10] == null) {
					prop.setProperty("jgrepper.folderpath11", "");
				} else {
					prop.setProperty("jgrepper.folderpath11", aryFolderPath[10]);
				}
				if (aryFolderPath[11] == null) {
					prop.setProperty("jgrepper.folderpath12", "");
				} else {
					prop.setProperty("jgrepper.folderpath12", aryFolderPath[11]);
				}
				if (aryFolderPath[12] == null) {
					prop.setProperty("jgrepper.folderpath13", "");
				} else {
					prop.setProperty("jgrepper.folderpath13", aryFolderPath[12]);
				}
				if (aryFolderPath[13] == null) {
					prop.setProperty("jgrepper.folderpath14", "");
				} else {
					prop.setProperty("jgrepper.folderpath14", aryFolderPath[13]);
				}
				if (aryFolderPath[14] == null) {
					prop.setProperty("jgrepper.folderpath15", "");
				} else {
					prop.setProperty("jgrepper.folderpath15", aryFolderPath[14]);
				}
				if (aryFolderPath[15] == null) {
					prop.setProperty("jgrepper.folderpath16", "");
				} else {
					prop.setProperty("jgrepper.folderpath16", aryFolderPath[15]);
				}
				if (aryFolderPath[16] == null) {
					prop.setProperty("jgrepper.folderpath17", "");
				} else {
					prop.setProperty("jgrepper.folderpath17", aryFolderPath[16]);
				}
				if (aryFolderPath[17] == null) {
					prop.setProperty("jgrepper.folderpath18", "");
				} else {
					prop.setProperty("jgrepper.folderpath18", aryFolderPath[17]);
				}
				if (aryFolderPath[18] == null) {
					prop.setProperty("jgrepper.folderpath19", "");
				} else {
					prop.setProperty("jgrepper.folderpath19", aryFolderPath[18]);
				}
				if (aryFolderPath[19] == null) {
					prop.setProperty("jgrepper.folderpath20", "");
				} else {
					prop.setProperty("jgrepper.folderpath20", aryFolderPath[19]);
				}
			}
			// 镶PiK\j
			String[] aryRegEx = commonProp.getRegEx();
			if (aryRegEx == null) {
				prop.setProperty("jgrepper.regex01", "");
				prop.setProperty("jgrepper.regex02", "");
				prop.setProperty("jgrepper.regex03", "");
				prop.setProperty("jgrepper.regex04", "");
				prop.setProperty("jgrepper.regex05", "");
				prop.setProperty("jgrepper.regex06", "");
				prop.setProperty("jgrepper.regex07", "");
				prop.setProperty("jgrepper.regex08", "");
				prop.setProperty("jgrepper.regex09", "");
				prop.setProperty("jgrepper.regex10", "");
				prop.setProperty("jgrepper.regex11", "");
				prop.setProperty("jgrepper.regex12", "");
				prop.setProperty("jgrepper.regex13", "");
				prop.setProperty("jgrepper.regex14", "");
				prop.setProperty("jgrepper.regex15", "");
				prop.setProperty("jgrepper.regex16", "");
				prop.setProperty("jgrepper.regex17", "");
				prop.setProperty("jgrepper.regex18", "");
				prop.setProperty("jgrepper.regex19", "");
				prop.setProperty("jgrepper.regex20", "");
			} else {
				if (aryRegEx[0] == null) {
					prop.setProperty("jgrepper.regex01", "");
				} else {
					prop.setProperty("jgrepper.regex01", aryRegEx[0]);
				}
				if (aryRegEx[1] == null) {
					prop.setProperty("jgrepper.regex02", "");
				} else {
					prop.setProperty("jgrepper.regex02", aryRegEx[1]);
				}
				if (aryRegEx[2] == null) {
					prop.setProperty("jgrepper.regex03", "");
				} else {
					prop.setProperty("jgrepper.regex03", aryRegEx[2]);
				}
				if (aryRegEx[3] == null) {
					prop.setProperty("jgrepper.regex04", "");
				} else {
					prop.setProperty("jgrepper.regex04", aryRegEx[3]);
				}
				if (aryRegEx[4] == null) {
					prop.setProperty("jgrepper.regex05", "");
				} else {
					prop.setProperty("jgrepper.regex05", aryRegEx[4]);
				}
				if (aryRegEx[5] == null) {
					prop.setProperty("jgrepper.regex06", "");
				} else {
					prop.setProperty("jgrepper.regex06", aryRegEx[5]);
				}
				if (aryRegEx[6] == null) {
					prop.setProperty("jgrepper.regex07", "");
				} else {
					prop.setProperty("jgrepper.regex07", aryRegEx[6]);
				}
				if (aryRegEx[7] == null) {
					prop.setProperty("jgrepper.regex08", "");
				} else {
					prop.setProperty("jgrepper.regex08", aryRegEx[7]);
				}
				if (aryRegEx[8] == null) {
					prop.setProperty("jgrepper.regex09", "");
				} else {
					prop.setProperty("jgrepper.regex09", aryRegEx[8]);
				}
				if (aryRegEx[9] == null) {
					prop.setProperty("jgrepper.regex10", "");
				} else {
					prop.setProperty("jgrepper.regex10", aryRegEx[9]);
				}
				if (aryRegEx[10] == null) {
					prop.setProperty("jgrepper.regex11", "");
				} else {
					prop.setProperty("jgrepper.regex11", aryRegEx[10]);
				}
				if (aryRegEx[11] == null) {
					prop.setProperty("jgrepper.regex12", "");
				} else {
					prop.setProperty("jgrepper.regex12", aryRegEx[11]);
				}
				if (aryRegEx[12] == null) {
					prop.setProperty("jgrepper.regex13", "");
				} else {
					prop.setProperty("jgrepper.regex13", aryRegEx[12]);
				}
				if (aryRegEx[13] == null) {
					prop.setProperty("jgrepper.regex14", "");
				} else {
					prop.setProperty("jgrepper.regex14", aryRegEx[13]);
				}
				if (aryRegEx[14] == null) {
					prop.setProperty("jgrepper.regex15", "");
				} else {
					prop.setProperty("jgrepper.regex15", aryRegEx[14]);
				}
				if (aryRegEx[15] == null) {
					prop.setProperty("jgrepper.regex16", "");
				} else {
					prop.setProperty("jgrepper.regex16", aryRegEx[15]);
				}
				if (aryRegEx[16] == null) {
					prop.setProperty("jgrepper.regex17", "");
				} else {
					prop.setProperty("jgrepper.regex17", aryRegEx[16]);
				}
				if (aryRegEx[17] == null) {
					prop.setProperty("jgrepper.regex18", "");
				} else {
					prop.setProperty("jgrepper.regex18", aryRegEx[17]);
				}
				if (aryRegEx[18] == null) {
					prop.setProperty("jgrepper.regex19", "");
				} else {
					prop.setProperty("jgrepper.regex19", aryRegEx[18]);
				}
				if (aryRegEx[19] == null) {
					prop.setProperty("jgrepper.regex20", "");
				} else {
					prop.setProperty("jgrepper.regex20", aryRegEx[19]);
				}
			}
			// 镶QiK\j
			String[] aryRegExB = commonProp.getRegExB();
			if (aryRegExB == null) {
				prop.setProperty("jgrepper.regexb01", "");
				prop.setProperty("jgrepper.regexb02", "");
				prop.setProperty("jgrepper.regexb03", "");
				prop.setProperty("jgrepper.regexb04", "");
				prop.setProperty("jgrepper.regexb05", "");
				prop.setProperty("jgrepper.regexb06", "");
				prop.setProperty("jgrepper.regexb07", "");
				prop.setProperty("jgrepper.regexb08", "");
				prop.setProperty("jgrepper.regexb09", "");
				prop.setProperty("jgrepper.regexb10", "");
				prop.setProperty("jgrepper.regexb11", "");
				prop.setProperty("jgrepper.regexb12", "");
				prop.setProperty("jgrepper.regexb13", "");
				prop.setProperty("jgrepper.regexb14", "");
				prop.setProperty("jgrepper.regexb15", "");
				prop.setProperty("jgrepper.regexb16", "");
				prop.setProperty("jgrepper.regexb17", "");
				prop.setProperty("jgrepper.regexb18", "");
				prop.setProperty("jgrepper.regexb19", "");
				prop.setProperty("jgrepper.regexb20", "");
			} else {
				if (aryRegExB[0] == null) {
					prop.setProperty("jgrepper.regexb01", "");
				} else {
					prop.setProperty("jgrepper.regexb01", aryRegExB[0]);
				}
				if (aryRegExB[1] == null) {
					prop.setProperty("jgrepper.regexb02", "");
				} else {
					prop.setProperty("jgrepper.regexb02", aryRegExB[1]);
				}
				if (aryRegExB[2] == null) {
					prop.setProperty("jgrepper.regexb03", "");
				} else {
					prop.setProperty("jgrepper.regexb03", aryRegExB[2]);
				}
				if (aryRegExB[3] == null) {
					prop.setProperty("jgrepper.regexb04", "");
				} else {
					prop.setProperty("jgrepper.regexb04", aryRegExB[3]);
				}
				if (aryRegExB[4] == null) {
					prop.setProperty("jgrepper.regexb05", "");
				} else {
					prop.setProperty("jgrepper.regexb05", aryRegExB[4]);
				}
				if (aryRegExB[5] == null) {
					prop.setProperty("jgrepper.regexb06", "");
				} else {
					prop.setProperty("jgrepper.regexb06", aryRegExB[5]);
				}
				if (aryRegExB[6] == null) {
					prop.setProperty("jgrepper.regexb07", "");
				} else {
					prop.setProperty("jgrepper.regexb07", aryRegExB[6]);
				}
				if (aryRegExB[7] == null) {
					prop.setProperty("jgrepper.regexb08", "");
				} else {
					prop.setProperty("jgrepper.regexb08", aryRegExB[7]);
				}
				if (aryRegExB[8] == null) {
					prop.setProperty("jgrepper.regexb09", "");
				} else {
					prop.setProperty("jgrepper.regexb09", aryRegExB[8]);
				}
				if (aryRegExB[9] == null) {
					prop.setProperty("jgrepper.regexb10", "");
				} else {
					prop.setProperty("jgrepper.regexb10", aryRegExB[9]);
				}
				if (aryRegExB[10] == null) {
					prop.setProperty("jgrepper.regexb11", "");
				} else {
					prop.setProperty("jgrepper.regexb11", aryRegExB[10]);
				}
				if (aryRegExB[11] == null) {
					prop.setProperty("jgrepper.regexb12", "");
				} else {
					prop.setProperty("jgrepper.regexb12", aryRegExB[11]);
				}
				if (aryRegExB[12] == null) {
					prop.setProperty("jgrepper.regexb13", "");
				} else {
					prop.setProperty("jgrepper.regexb13", aryRegExB[12]);
				}
				if (aryRegExB[13] == null) {
					prop.setProperty("jgrepper.regexb14", "");
				} else {
					prop.setProperty("jgrepper.regexb14", aryRegExB[13]);
				}
				if (aryRegExB[14] == null) {
					prop.setProperty("jgrepper.regexb15", "");
				} else {
					prop.setProperty("jgrepper.regexb15", aryRegExB[14]);
				}
				if (aryRegExB[15] == null) {
					prop.setProperty("jgrepper.regexb16", "");
				} else {
					prop.setProperty("jgrepper.regexb16", aryRegExB[15]);
				}
				if (aryRegExB[16] == null) {
					prop.setProperty("jgrepper.regexb17", "");
				} else {
					prop.setProperty("jgrepper.regexb17", aryRegExB[16]);
				}
				if (aryRegExB[17] == null) {
					prop.setProperty("jgrepper.regexb18", "");
				} else {
					prop.setProperty("jgrepper.regexb18", aryRegExB[17]);
				}
				if (aryRegExB[18] == null) {
					prop.setProperty("jgrepper.regexb19", "");
				} else {
					prop.setProperty("jgrepper.regexb19", aryRegExB[18]);
				}
				if (aryRegExB[19] == null) {
					prop.setProperty("jgrepper.regexb20", "");
				} else {
					prop.setProperty("jgrepper.regexb20", aryRegExB[19]);
				}
			}
			// 镶RiK\j
			String[] aryRegExC = commonProp.getRegExC();
			if (aryRegExC == null) {
				prop.setProperty("jgrepper.regexc01", "");
				prop.setProperty("jgrepper.regexc02", "");
				prop.setProperty("jgrepper.regexc03", "");
				prop.setProperty("jgrepper.regexc04", "");
				prop.setProperty("jgrepper.regexc05", "");
				prop.setProperty("jgrepper.regexc06", "");
				prop.setProperty("jgrepper.regexc07", "");
				prop.setProperty("jgrepper.regexc08", "");
				prop.setProperty("jgrepper.regexc09", "");
				prop.setProperty("jgrepper.regexc10", "");
				prop.setProperty("jgrepper.regexc11", "");
				prop.setProperty("jgrepper.regexc12", "");
				prop.setProperty("jgrepper.regexc13", "");
				prop.setProperty("jgrepper.regexc14", "");
				prop.setProperty("jgrepper.regexc15", "");
				prop.setProperty("jgrepper.regexc16", "");
				prop.setProperty("jgrepper.regexc17", "");
				prop.setProperty("jgrepper.regexc18", "");
				prop.setProperty("jgrepper.regexc19", "");
				prop.setProperty("jgrepper.regexc20", "");
			} else {
				if (aryRegExC[0] == null) {
					prop.setProperty("jgrepper.regexc01", "");
				} else {
					prop.setProperty("jgrepper.regexc01", aryRegExC[0]);
				}
				if (aryRegExC[1] == null) {
					prop.setProperty("jgrepper.regexc02", "");
				} else {
					prop.setProperty("jgrepper.regexc02", aryRegExC[1]);
				}
				if (aryRegExC[2] == null) {
					prop.setProperty("jgrepper.regexc03", "");
				} else {
					prop.setProperty("jgrepper.regexc03", aryRegExC[2]);
				}
				if (aryRegExC[3] == null) {
					prop.setProperty("jgrepper.regexc04", "");
				} else {
					prop.setProperty("jgrepper.regexc04", aryRegExC[3]);
				}
				if (aryRegExC[4] == null) {
					prop.setProperty("jgrepper.regexc05", "");
				} else {
					prop.setProperty("jgrepper.regexc05", aryRegExC[4]);
				}
				if (aryRegExC[5] == null) {
					prop.setProperty("jgrepper.regexc06", "");
				} else {
					prop.setProperty("jgrepper.regexc06", aryRegExC[5]);
				}
				if (aryRegExC[6] == null) {
					prop.setProperty("jgrepper.regexc07", "");
				} else {
					prop.setProperty("jgrepper.regexc07", aryRegExC[6]);
				}
				if (aryRegExC[7] == null) {
					prop.setProperty("jgrepper.regexc08", "");
				} else {
					prop.setProperty("jgrepper.regexc08", aryRegExC[7]);
				}
				if (aryRegExC[8] == null) {
					prop.setProperty("jgrepper.regexc09", "");
				} else {
					prop.setProperty("jgrepper.regexc09", aryRegExC[8]);
				}
				if (aryRegExC[9] == null) {
					prop.setProperty("jgrepper.regexc10", "");
				} else {
					prop.setProperty("jgrepper.regexc10", aryRegExC[9]);
				}
				if (aryRegExC[10] == null) {
					prop.setProperty("jgrepper.regexc11", "");
				} else {
					prop.setProperty("jgrepper.regexc11", aryRegExC[10]);
				}
				if (aryRegExC[11] == null) {
					prop.setProperty("jgrepper.regexc12", "");
				} else {
					prop.setProperty("jgrepper.regexc12", aryRegExC[11]);
				}
				if (aryRegExC[12] == null) {
					prop.setProperty("jgrepper.regexc13", "");
				} else {
					prop.setProperty("jgrepper.regexc13", aryRegExC[12]);
				}
				if (aryRegExC[13] == null) {
					prop.setProperty("jgrepper.regexc14", "");
				} else {
					prop.setProperty("jgrepper.regexc14", aryRegExC[13]);
				}
				if (aryRegExC[14] == null) {
					prop.setProperty("jgrepper.regexc15", "");
				} else {
					prop.setProperty("jgrepper.regexc15", aryRegExC[14]);
				}
				if (aryRegExC[15] == null) {
					prop.setProperty("jgrepper.regexc16", "");
				} else {
					prop.setProperty("jgrepper.regexc16", aryRegExC[15]);
				}
				if (aryRegExC[16] == null) {
					prop.setProperty("jgrepper.regexc17", "");
				} else {
					prop.setProperty("jgrepper.regexc17", aryRegExC[16]);
				}
				if (aryRegExC[17] == null) {
					prop.setProperty("jgrepper.regexc18", "");
				} else {
					prop.setProperty("jgrepper.regexc18", aryRegExC[17]);
				}
				if (aryRegExC[18] == null) {
					prop.setProperty("jgrepper.regexc19", "");
				} else {
					prop.setProperty("jgrepper.regexc19", aryRegExC[18]);
				}
				if (aryRegExC[19] == null) {
					prop.setProperty("jgrepper.regexc20", "");
				} else {
					prop.setProperty("jgrepper.regexc20", aryRegExC[19]);
				}
			}
			// 镶i`^nj
			prop.setProperty("jgrepper.regexandor", commonProp.getRegExAndOr());
			// TutH_
			prop.setProperty("jgrepper.opt01_subfolder", commonProp.getSubFolder());
			// kt@C̒g
			prop.setProperty("jgrepper.opt01_archive", commonProp.getArchive());
			// GR[h̎
			prop.setProperty("jgrepper.opt01_encode", commonProp.getEncode());
			// 啶Əʂ
			prop.setProperty("jgrepper.opt01_caseinsensitive", commonProp.getCaseInsensitive());
			// sƍs̋󔒂𖳎
			prop.setProperty("jgrepper.opt01_trim", commonProp.getTrim());
			// GREPʂ̕\`
			prop.setProperty("jgrepper.opt01_textformat", commonProp.getTextFormat());

			// vpeBt@C̏
			prop.store(new FileOutputStream("jgrepper.properties"), "JGrepper properties");

		} catch (Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
			//ex.printStackTrace();
		}
	}
}

/******************************************************************************
 *vpeBt@C̓ǂݍ
 ******************************************************************************/
class GetProperties {

	Properties prop;

	////////////////////////////////////////////////////////////////////////////
	//RXgN^
	////////////////////////////////////////////////////////////////////////////
	GetProperties() {
		try {
			prop = new Properties();
			prop.load(new FileInputStream("jgrepper.properties"));
		} catch (FileNotFoundException e1) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			e1.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		} catch (Exception ex) {
			StringWriter stringWriter = new StringWriter();
			PrintWriter printWriter = new PrintWriter(stringWriter);
			ex.printStackTrace(printWriter);
			ErrorDialog d = new ErrorDialog(new JFrame(), stringWriter.toString());
		}
	}

	// tHg
	public String getFontName() {
		return prop.getProperty("jgrepper.opt00_fontname", "lr SVbN");
	}
	// tHgTCY
	public String getFontSize() {
		return prop.getProperty("jgrepper.opt00_fontsize", "12");
	}
	// t@CiPj
	public String getFileName1() {
		return prop.getProperty("jgrepper.filename01", "");
	}
	// t@CiQj
	public String getFileName2() {
		return prop.getProperty("jgrepper.filename02", "");
	}
	// t@CiRj
	public String getFileName3() {
		return prop.getProperty("jgrepper.filename03", "");
	}
	// t@CiSj
	public String getFileName4() {
		return prop.getProperty("jgrepper.filename04", "");
	}
	// t@CiTj
	public String getFileName5() {
		return prop.getProperty("jgrepper.filename05", "");
	}
	// t@CiUj
	public String getFileName6() {
		return prop.getProperty("jgrepper.filename06", "");
	}
	// t@CiVj
	public String getFileName7() {
		return prop.getProperty("jgrepper.filename07", "");
	}
	// t@CiWj
	public String getFileName8() {
		return prop.getProperty("jgrepper.filename08", "");
	}
	// t@CiXj
	public String getFileName9() {
		return prop.getProperty("jgrepper.filename09", "");
	}
	// t@CiPOj
	public String getFileName10() {
		return prop.getProperty("jgrepper.filename10", "");
	}
	// t@CiPPj
	public String getFileName11() {
		return prop.getProperty("jgrepper.filename11", "");
	}
	// t@CiPQj
	public String getFileName12() {
		return prop.getProperty("jgrepper.filename12", "");
	}
	// t@CiPRj
	public String getFileName13() {
		return prop.getProperty("jgrepper.filename13", "");
	}
	// t@CiPSj
	public String getFileName14() {
		return prop.getProperty("jgrepper.filename14", "");
	}
	// t@CiPTj
	public String getFileName15() {
		return prop.getProperty("jgrepper.filename15", "");
	}
	// t@CiPUj
	public String getFileName16() {
		return prop.getProperty("jgrepper.filename16", "");
	}
	// t@CiPVj
	public String getFileName17() {
		return prop.getProperty("jgrepper.filename17", "");
	}
	// t@CiPWj
	public String getFileName18() {
		return prop.getProperty("jgrepper.filename18", "");
	}
	// t@CiPXj
	public String getFileName19() {
		return prop.getProperty("jgrepper.filename19", "");
	}
	// t@CiQOj
	public String getFileName20() {
		return prop.getProperty("jgrepper.filename20", "");
	}
	// tH_iPj
	public String getFolderPath1() {
		return prop.getProperty("jgrepper.folderpath01", "");
	}
	// tH_iQj
	public String getFolderPath2() {
		return prop.getProperty("jgrepper.folderpath02", "");
	}
	// tH_iRj
	public String getFolderPath3() {
		return prop.getProperty("jgrepper.folderpath03", "");
	}
	// tH_iSj
	public String getFolderPath4() {
		return prop.getProperty("jgrepper.folderpath04", "");
	}
	// tH_iTj
	public String getFolderPath5() {
		return prop.getProperty("jgrepper.folderpath05", "");
	}
	// tH_iUj
	public String getFolderPath6() {
		return prop.getProperty("jgrepper.folderpath06", "");
	}
	// tH_iVj
	public String getFolderPath7() {
		return prop.getProperty("jgrepper.folderpath07", "");
	}
	// tH_iWj
	public String getFolderPath8() {
		return prop.getProperty("jgrepper.folderpath08", "");
	}
	// tH_iXj
	public String getFolderPath9() {
		return prop.getProperty("jgrepper.folderpath09", "");
	}
	// tH_iPOj
	public String getFolderPath10() {
		return prop.getProperty("jgrepper.folderpath10", "");
	}
	// tH_iPPj
	public String getFolderPath11() {
		return prop.getProperty("jgrepper.folderpath11", "");
	}
	// tH_iPQj
	public String getFolderPath12() {
		return prop.getProperty("jgrepper.folderpath12", "");
	}
	// tH_iPRj
	public String getFolderPath13() {
		return prop.getProperty("jgrepper.folderpath13", "");
	}
	// tH_iPSj
	public String getFolderPath14() {
		return prop.getProperty("jgrepper.folderpath14", "");
	}
	// tH_iPTj
	public String getFolderPath15() {
		return prop.getProperty("jgrepper.folderpath15", "");
	}
	// tH_iPUj
	public String getFolderPath16() {
		return prop.getProperty("jgrepper.folderpath16", "");
	}
	// tH_iPVj
	public String getFolderPath17() {
		return prop.getProperty("jgrepper.folderpath17", "");
	}
	// tH_iPWj
	public String getFolderPath18() {
		return prop.getProperty("jgrepper.folderpath18", "");
	}
	// tH_iPXj
	public String getFolderPath19() {
		return prop.getProperty("jgrepper.folderpath19", "");
	}
	// tH_iQOj
	public String getFolderPath20() {
		return prop.getProperty("jgrepper.folderpath20", "");
	}
	// 镶PiPj
	public String getRegEx1() {
		return prop.getProperty("jgrepper.regex01", "");
	}
	// 镶PiQj
	public String getRegEx2() {
		return prop.getProperty("jgrepper.regex02", "");
	}
	// 镶PiRj
	public String getRegEx3() {
		return prop.getProperty("jgrepper.regex03", "");
	}
	// 镶PiSj
	public String getRegEx4() {
		return prop.getProperty("jgrepper.regex04", "");
	}
	// 镶PiTj
	public String getRegEx5() {
		return prop.getProperty("jgrepper.regex05", "");
	}
	// 镶PiUj
	public String getRegEx6() {
		return prop.getProperty("jgrepper.regex06", "");
	}
	// 镶PiVj
	public String getRegEx7() {
		return prop.getProperty("jgrepper.regex07", "");
	}
	// 镶PiWj
	public String getRegEx8() {
		return prop.getProperty("jgrepper.regex08", "");
	}
	// 镶PiXj
	public String getRegEx9() {
		return prop.getProperty("jgrepper.regex09", "");
	}
	// 镶PiPOj
	public String getRegEx10() {
		return prop.getProperty("jgrepper.regex10", "");
	}
	// 镶PiPPj
	public String getRegEx11() {
		return prop.getProperty("jgrepper.regex11", "");
	}
	// 镶PiPQj
	public String getRegEx12() {
		return prop.getProperty("jgrepper.regex12", "");
	}
	// 镶PiPRj
	public String getRegEx13() {
		return prop.getProperty("jgrepper.regex13", "");
	}
	// 镶PiPSj
	public String getRegEx14() {
		return prop.getProperty("jgrepper.regex14", "");
	}
	// 镶PiPTj
	public String getRegEx15() {
		return prop.getProperty("jgrepper.regex15", "");
	}
	// 镶PiPUj
	public String getRegEx16() {
		return prop.getProperty("jgrepper.regex16", "");
	}
	// 镶PiPVj
	public String getRegEx17() {
		return prop.getProperty("jgrepper.regex17", "");
	}
	// 镶PiPWj
	public String getRegEx18() {
		return prop.getProperty("jgrepper.regex18", "");
	}
	// 镶PiPXj
	public String getRegEx19() {
		return prop.getProperty("jgrepper.regex19", "");
	}
	// 镶PiQOj
	public String getRegEx20() {
		return prop.getProperty("jgrepper.regex20", "");
	}
	// 镶QiPj
	public String getRegExB1() {
		return prop.getProperty("jgrepper.regexb01", "");
	}
	// 镶QiQj
	public String getRegExB2() {
		return prop.getProperty("jgrepper.regexb02", "");
	}
	// 镶QiRj
	public String getRegExB3() {
		return prop.getProperty("jgrepper.regexb03", "");
	}
	// 镶QiSj
	public String getRegExB4() {
		return prop.getProperty("jgrepper.regexb04", "");
	}
	// 镶QiTj
	public String getRegExB5() {
		return prop.getProperty("jgrepper.regexb05", "");
	}
	// 镶QiUj
	public String getRegExB6() {
		return prop.getProperty("jgrepper.regexb06", "");
	}
	// 镶QiVj
	public String getRegExB7() {
		return prop.getProperty("jgrepper.regexb07", "");
	}
	// 镶QiWj
	public String getRegExB8() {
		return prop.getProperty("jgrepper.regexb08", "");
	}
	// 镶QiXj
	public String getRegExB9() {
		return prop.getProperty("jgrepper.regexb09", "");
	}
	// 镶QiPOj
	public String getRegExB10() {
		return prop.getProperty("jgrepper.regexb10", "");
	}
	// 镶QiPPj
	public String getRegExB11() {
		return prop.getProperty("jgrepper.regexb11", "");
	}
	// 镶QiPQj
	public String getRegExB12() {
		return prop.getProperty("jgrepper.regexb12", "");
	}
	// 镶QiPRj
	public String getRegExB13() {
		return prop.getProperty("jgrepper.regexb13", "");
	}
	// 镶QiPSj
	public String getRegExB14() {
		return prop.getProperty("jgrepper.regexb14", "");
	}
	// 镶QiPTj
	public String getRegExB15() {
		return prop.getProperty("jgrepper.regexb15", "");
	}
	// 镶QiPUj
	public String getRegExB16() {
		return prop.getProperty("jgrepper.regexb16", "");
	}
	// 镶QiPVj
	public String getRegExB17() {
		return prop.getProperty("jgrepper.regexb17", "");
	}
	// 镶QiPWj
	public String getRegExB18() {
		return prop.getProperty("jgrepper.regexb18", "");
	}
	// 镶QiPXj
	public String getRegExB19() {
		return prop.getProperty("jgrepper.regexb19", "");
	}
	// 镶QiQOj
	public String getRegExB20() {
		return prop.getProperty("jgrepper.regexb20", "");
	}
	// 镶RiPj
	public String getRegExC1() {
		return prop.getProperty("jgrepper.regexc01", "");
	}
	// 镶RiQj
	public String getRegExC2() {
		return prop.getProperty("jgrepper.regexc02", "");
	}
	// 镶RiRj
	public String getRegExC3() {
		return prop.getProperty("jgrepper.regexc03", "");
	}
	// 镶RiSj
	public String getRegExC4() {
		return prop.getProperty("jgrepper.regexc04", "");
	}
	// 镶RiTj
	public String getRegExC5() {
		return prop.getProperty("jgrepper.regexc05", "");
	}
	// 镶RiUj
	public String getRegExC6() {
		return prop.getProperty("jgrepper.regexc06", "");
	}
	// 镶RiVj
	public String getRegExC7() {
		return prop.getProperty("jgrepper.regexc07", "");
	}
	// 镶RiWj
	public String getRegExC8() {
		return prop.getProperty("jgrepper.regexc08", "");
	}
	// 镶RiXj
	public String getRegExC9() {
		return prop.getProperty("jgrepper.regexc09", "");
	}
	// 镶RiPOj
	public String getRegExC10() {
		return prop.getProperty("jgrepper.regexc10", "");
	}
	// 镶RiPPj
	public String getRegExC11() {
		return prop.getProperty("jgrepper.regexc11", "");
	}
	// 镶RiPQj
	public String getRegExC12() {
		return prop.getProperty("jgrepper.regexc12", "");
	}
	// 镶RiPRj
	public String getRegExC13() {
		return prop.getProperty("jgrepper.regexc13", "");
	}
	// 镶RiPSj
	public String getRegExC14() {
		return prop.getProperty("jgrepper.regexc14", "");
	}
	// 镶RiPTj
	public String getRegExC15() {
		return prop.getProperty("jgrepper.regexc15", "");
	}
	// 镶RiPUj
	public String getRegExC16() {
		return prop.getProperty("jgrepper.regexc16", "");
	}
	// 镶RiPVj
	public String getRegExC17() {
		return prop.getProperty("jgrepper.regexc17", "");
	}
	// 镶RiPWj
	public String getRegExC18() {
		return prop.getProperty("jgrepper.regexc18", "");
	}
	// 镶RiPXj
	public String getRegExC19() {
		return prop.getProperty("jgrepper.regexc19", "");
	}
	// 镶RiQOj
	public String getRegExC20() {
		return prop.getProperty("jgrepper.regexc20", "");
	}
	// 镶i`^nj
	public String getRegExAndOr() {
		return prop.getProperty("jgrepper.regexandor", "0");
	}
	// TutH_
	public String getSubFolder() {
		return prop.getProperty("jgrepper.opt01_subfolder", "0");
	}
	// kt@C̒g
	public String getArchive() {
		return prop.getProperty("jgrepper.opt01_archive", "0");
	}
	// GR[h̎
	public String getEncode() {
		return prop.getProperty("jgrepper.opt01_encode", "");
	}
	// 啶Əʂ
	public String getCaseInsensitive() {
		return prop.getProperty("jgrepper.opt01_caseinsensitive", "0");
	}
	// sƍs̋󔒂𖳎
	public String getTrim() {
		return prop.getProperty("jgrepper.opt01_trim", "0");
	}
	// ʂ̕\`
	public String getTextFormat() {
		return prop.getProperty("jgrepper.opt01_textformat", "0");
	}
}

/******************************************************************************
 *ree
 *itB^[ݒ肷j
 ******************************************************************************/
class SearchFileFilter implements FilenameFilter {

	private String[] sfxes;

	public SearchFileFilter(String[] suffixes) {
		sfxes = new String[suffixes.length];
		System.arraycopy(suffixes, 0, sfxes, 0, suffixes.length);
	}

	public boolean accept(File dir, String name){

		// t@Cƈvꍇtrueԋp
		// łȂfalseԋp
		for (int i=0; i<sfxes.length; i++) {
			// p^[kȂ疳Ƀ}b`
			if (sfxes[i].length() == 0) {
				return (true);
			}
			// K\ɕϊ
			String strRegex = sfxes[i];
			strRegex = strRegex.replace(".", "\\.");
			strRegex = strRegex.replace("*", ".*");

			Pattern pattern = null;
			if (System.getProperty("os.name").toUpperCase().startsWith("WINDOWS")) {
				// Windowsł͑啶ƏʂȂ
				pattern = Pattern.compile(strRegex, Pattern.CASE_INSENSITIVE);
			} else {
				// WindowsȊOOSł͑啶Əʂ
				pattern = Pattern.compile(strRegex);
			}
			Matcher matcher = pattern.matcher(name);
			boolean b = matcher.matches();
			if (b == true) {
				return (true);
			}
		}
		return (false);
	}
}
